<?php
/* 
	Fonctions d'affichage des animations et du plan de formation
	Circon'script PHP Script
	Version 7.0.3 
	CeCILL Copyright (C) 2008 Thierry Gangloff
	e-mail: thierry.gangloff@ac-strasbourg.fr
*/

/*
	AfficheUneAnimation
	
	*** Avertissement ***
	Les tests sur les plans se font uniquement par test direct d'galit: $plan==XX 
	Cela permet de suivre chaque tape pour un plan donn, et facilite la maintenance/mise  jour/ajout.
	Evidemment on peut simplifier, mais le but ici est de faciliter la lecture !
	************
	
	E: $id_anim: identifiant de l'animation
	$h: handle mysql
	$impair: pour couleur de la barre de titre (0/1)
	$url_ret: si non vide, url de la page  laquelle il faut revenir aprs modification de l'animation (=> si url est mis, on peut modifier les animations et revenir  la page)
	$id_stagiaire: identifiant du stagiaire
	$test_date: 0 pas de test sur date, 1 <=, 2 >=, 3==  $date, 4= dates indfinies, 5 dates FOAD
	$date: date  tester au format sql.
		Les dates ont diffrentes significations: 
			'0000-00-00' et '9999-12-31': dates  dfinir. 
			'9999-12-30': Formation  distance (donc pas de date dfinie)
	$plan==28: affichage par la circo du plan de formation d'un stagiaire, avec uniquement les sances pour lesquelles il est inscrit, avec cases  cocher. Comme plan 23, avec les inscriptions au lieu des convocations
	$plan==27: comme plan=25, mais ne montre que les sances faisant partie du groupe
	$plan==26: comme plan==25, mais ne montre que les sances faisant partie de la liste
	$plan==25: la circo tablit des listes tries de sances a affecter aux stagiaires n'ayant pas assez de convocations. Fonctionne comme plan==12 avec une balise input de texte au lieu de checkbox.	Utilise id_liste (qui peut etre ==0 si nouvelle liste).
	$plan==24: Affichage PAR LA CIRCO   du plan de formation d'un stagiaire, avec uniquement les sances pour lesquelles il est inscrit (cf plan 6)  
	$plan==23: Affichage PAR LA CIRCO du plan de formation d'un stagiaire, avec uniquement les sances pour lesquelles il est convoqu (cf plan 7), cases  cocher pour "dconvoquer" et boutons de validation.
	$plan==22: importations, comme en 1. On n'affiche que les animations DEJA importes, et parmi celles-ci, que les sances DEJA importes. Utlilis dans le cas o les exportations ne sont plus autorises.
	$plan==21: organisation du plan de formation. On affiche tout le plan,y compris les animations non visibles par les stagiaires, avec des liens sur les thmes
	$plan==20: Importations, comme en 1. On n'affiche que les animations DEJA importes par id_circo  partir de id_circo_import (accepte=1)
	$plan==19: Importations, comme en 1. On n'affiche que les animations NON importes par id_circo  partir de id_circo_import (accepte=0)
	$plan==18: Affichage des animations classes par date (affichage comme en plan 2) 
	$plan==17: Affichage des animations de la circo classes par date et non par domaine, thme (calendrier). Les animations sont affiches comme en plan 0
	$plan==16: Affichage du plan de formation d'un stagiaire, avec uniquement les sances pour lesquelles il est convoqu (cf plan 7) et possibilit de cocher ses absences
	$plan==15: Affichage du plan de formation complet vu par un stagiaire.
	$plan==14: affichage du plan de formation vu par un stagiaire, selon son groupe, sans cases  cocher. Si id_groupe du stagiaire est a 0, affichage du plan de la circo (comme en 15).
	$plan==13: l'administrateur choisit les sances pour un groupe donn, mais on en voit que les sances choisies.
	$plan==12: l'administrateur choisit des sances pour un groupe donn. Toutes les sances du plan sont montres, celles appartenant au groupe sont coches. 
	$plan==11: comme plan==3 mais l'administrateur effectue les inscriptions pour un stagiaire donn
	$plan==10: l'administrateur modifie les inscriptions  partir des animations
	$plan==9: l'administrateur effectue les convocations  partir des animations: affichage du plan et lien vers la liste des stagiaires
	$plan==8: l'administrateur consulte les convocations ou les inscriptions sur le plan de formation. Fonctionne comme (5). Ncessite le code javascript 'ouvre(adr)'
	$plan==7: comme 5, mais on ne montre que les animations auxquelles le stagiaire est CONVOQUE.
	$plan==6: comme 5, mais on ne montre que les animations auxquelles le stagiaire est inscrit, pas les autres.
	$plan==5: le stagiaire consulte les animations, mais ne peut plus s'inscrire car les inscriptions sont closes.
	$plan==4: le stagiaire choisit ses animations. Ncessite prsence du code javascript 'ouvre(adr)' dfini en ins_inscription_un_stagiaire.php, qui ouvre une fentre popup  l'adresse donne en paramtres
	$plan==3: l'administrateur effectue les convocations pour un stagiaire donn. (coche des sances o il est convoqu)
	$plan==2: affichage du plan de formation final d'une circo, sans cases  cocher. 
	$plan==1: importations: on choisit parmi les animations importes provenant d'une circo donne, celles que l'on veut accepter
	$plan==0: animations proposes par la circo, meme celles qu'elle exporte uniquement. Pas celles importes.
	
*/


function afficheUneAnimation($id_anim,$h,&$impair,$url_ret,$plan=0,$id_stagiaire=0,$id_groupe=0,$test_date='', $date='', $id_liste=0)
{
	global $id_circo;
	static $numAncre=1;
	//debug("afficheUneAnimation: plan=$plan");
	$classe="class=\"seance_paire\"";
	if ($date=='0000-00-00') $date='9999-12-31';
	if ($impair) $classe="class=\"seance_impaire\"";
	$q="SELECT intitule,annule, description,remarque,lien,id_circo, categories.codage,categories.libelle FROM animations LEFT JOIN categories ON animations.id_categorie=categories.id_categorie WHERE id_anim=$id_anim";
	$animation=queryArray($q,$h);
	if (sizeof($animation)==0) return false;
	$nb_seances=queryValue("SELECT COUNT(*) FROM seances WHERE seances.id_anim=$id_anim",$h);
	$libAnnule='';
	if ($animation['annule']) $libAnnule="[ANNUL&Eacute;]&nbsp;:&nbsp;";
	// si prsence d'une URL de retour, c'est qu'on veut pouvoir modifier l'animation. Ne la met en place que si l'animation appartient  la circo
	$intitule=htmlentities($animation['intitule'],ENT_COMPAT,'ISO-8859-15');
	$non_partage=false;
	if ($plan==21) {
		$n=queryValue("SELECT COUNT(*) FROM partages,seances WHERE partages.id_circo=$id_circo AND partages.accepte=1 AND partages.id_seance=seances.id_seance AND seances.id_anim=$id_anim",$h);
		$non_partage= ($n==0);
	}	
	if ($url_ret && $animation['id_circo']==$id_circo) { 
		$ancre="animation".$numAncre;
		++$numAncre;
		if ($non_partage)
			printf( "<a name=\"$ancre\"></a><h4 $classe><a href=\"adm_animations_modif.php?Modifier=$id_anim&amp;url_ret=%s&amp;Ancre=$ancre\"><span class=\"non_partage\">%s</span></a></h4>\n",$url_ret,lierPonctuation($libAnnule.$intitule));
		else
			printf( "<a name=\"$ancre\"></a><h4 $classe><a href=\"adm_animations_modif.php?Modifier=$id_anim&amp;url_ret=%s&amp;Ancre=$ancre\">%s</a></h4>\n",$url_ret,lierPonctuation($libAnnule.$intitule));
	}
	else 
		if ($non_partage)
			printf("<h4 $classe><span class=\"non_partage\">%s</span></h4>",lierPonctuation($libAnnule.$intitule));
		else
			printf("<h4 $classe>%s</h4>",lierPonctuation($libAnnule.$intitule));

/*

	if ($plan==21) {
		$n=queryValue("SELECT COUNT(*) FROM partages,seances WHERE partages.id_circo=$id_circo AND partages.accepte=1 AND partages.id_seance=seances.id_seance AND seances.id_anim=$id_anim",$h);
		if ($n==0) printf("<h4 class=\"non_partage\">%s</h4>",lierPonctuation($libAnnule.htmlentities($animation['intitule'],ENT_COMPAT,'ISO-8859-15')));
		else  printf("<h4>%s</h4>",lierPonctuation($libAnnule.htmlentities($animation['intitule'],ENT_COMPAT,'ISO-8859-15')));
	}
	else if ($url_ret) { 
		if ($animation['id_circo']!=$id_circo) printf("<h4>%s</h4>",lierPonctuation($libAnnule.htmlentities($animation['intitule'],ENT_COMPAT,'ISO-8859-15')));
		else	{
			$ancre="animation".$numAncre;
			++$numAncre;
			printf( "<a name=\"$ancre\"></a><h4><a href=\"adm_animations_modif.php?Modifier=$id_anim&amp;url_ret=%s&amp;Ancre=$ancre\">%s</a></h4>\n",$url_ret,lierPonctuation($libAnnule.htmlentities($animation['intitule'],ENT_COMPAT,'ISO-8859-15')));
			}
	}
	else printf("<h4>%s</h4>",lierPonctuation($libAnnule.htmlentities($animation['intitule'],ENT_COMPAT,'ISO-8859-15')));
*/	
	if ($libAnnule) print "<table class=\"annule\">";
	else print "<table>\n";
	
	print "<tr>\n";
	if (($plan==1||$plan==19 ||$plan==20) && $animation['id_circo']!=$id_circo) {
		print "<td><input type=\"submit\" name=\"ajouter\" value=\"1\" class=\"bouton_ajoute\" />\n";	
		print "<input type=\"submit\" name=\"retrancher\" value=\"1\" class=\"bouton_retranche\" /></td>\n";	
	}
	else if ($plan==22 && $animation['id_circo']!=$id_circo) {
		print "<input type=\"submit\" name=\"retrancher\" value=\"1\" class=\"bouton_retranche\" /></td>\n";	
	}
	print '<td class="animation_intitule">';
	$codage=htmlentities($animation['codage'],ENT_COMPAT,'ISO-8859-15');
	$libelle_codage=htmlentities($animation['libelle'],ENT_COMPAT,'ISO-8859-15');
	if ($codage) print "<p><em>R&eacute;f : <a href=\"javascript:void(0)\" title=\"$libelle_codage\">$codage</a></em></p>\n";
	$descr=lierPonctuation(htmlentities($animation['description'],ENT_COMPAT,'ISO-8859-15'));
	$lien=htmlentities($animation['lien'],ENT_COMPAT,'ISO-8859-15');
	$unlien='';
	if ($lien) $unlien="<a href=\"javascript:ouvreLien('$lien')\" title=\"Lien externe vers des informations. S'ouvre dans une nouvelle fen&ecirc;tre.\"><img src=\"images/lien_externe.png\" alt=\"lien externe\" width=\"16\" height=\"16\" /></a>&nbsp;";
	if ($descr) $descr=str_replace("\n","<br/>",$descr);
	$rem=lierPonctuation(htmlentities($animation['remarque'],ENT_COMPAT,'ISO-8859-15'));
	if ($rem) $rem=str_replace("\n","<br/>",$rem);
	if ($descr && !$rem) print "<p>$unlien$descr</p>\n";
	else if ($rem && !$descr) print "<p>$unlien<em>$rem</em></p>\n";
	else if ($rem && $descr) print "<p>$unlien$descr<br/><em>$rem</em></p>\n";
	else print "<p>$unlien&nbsp;</p>\n";
	print "</td>\n";
	if ($plan==1 || $plan==19 || $plan==20 ||$plan==22) { //afficher domaine et thme pour une animation importe
		$domaine=queryValue("SELECT domaines.libelle FROM positions,domaines WHERE positions.id_anim=$id_anim AND positions.id_domaine=domaines.id_domaine AND domaines.id_circo=$id_circo",$h);
		$theme=queryValue("SELECT themes.libelle FROM positions, themes WHERE positions.id_anim=$id_anim AND positions.id_theme=themes.id_theme AND themes.id_circo=$id_circo",$h);
		print '<td class="animation_intitule">';
		print "<h5>Import&eacute; dans...</h5>\n";
		if ($domaine) print "<p class=\"domaine_petit\">$domaine</p>\n";
		if ($theme) print "<p class=\"theme_petit\">$theme</p>\n";
		if (!$domaine && !$theme) print '[non import&eacute;e]';
		print "</td>";
	}

	// affiche les sances
	print "<td>\n";
	$ok=false;	
	$max_precedent=0; // maximum de la sance prcdente, ncessaire pour le traitmeent des conditions
	$total_inscrits_precedent=0;
	while(1) {
		//affichage des en-ttes
		$ok=false;
		print "<table class=\"seance\">\n";
		print "<tr class=\"seance_entete\">\n";
		$nbcols=6; // nombre de colonnes affiches, servira pour le colspan=... lors de l'affichage de la ligne suppl.
		if ($plan==1||$plan==2||$plan==3||$plan==4||$plan==5||$plan==6||$plan==7||$plan==8||$plan==9||$plan==10||$plan==11||$plan==12||$plan==13||$plan==14||$plan==15||$plan==16||$plan==19||$plan==20||$plan==21||$plan==23||$plan==24||$plan==25||$plan==26||$plan==27||$plan==28) {
			print"<td>Org.</td>\n";
			++$nbcols;
		}
		if ($plan==0) {
			print "<td>Circos</td>\n";
			++$nbcols;
		}
  		print"<td>Public</td>\n";
		print"<td>Date</td>\n";
 	 	print"<td>Lieu</td>\n";
		print"<td>Intervenants</td>\n";
		print"<td>Remarque</td>\n";
		print"<td>Dur&eacute;e</td>\n";
		//colonne inscriptions ?
		if ($plan==3||$plan==4||$plan==5||$plan==6||$plan==8||$plan==9||$plan==10||$plan==11||$plan==24||$plan==25||$plan==26||$plan==27||$plan==28) { 
			print "<td>Inscr</td>\n";
			++$nbcols;
		}
		//colonne Convocations ?
		if ($plan==3||$plan==7||$plan==8||$plan==9||$plan==10||$plan==11||$plan==23||$plan==25||$plan==26||$plan==27) {
			print "<td>Conv</td>\n";
			++$nbcols;
		}
		if ($plan==16) {
			print "<td>Abs.</td>\n";
			++$nbcols;
			print "<td>Exc.</td>\n";
			++$nbcols;
		}			
		//colonne supplmentaire ?
		if ($plan==9||$plan==0||$plan==2||$plan==10||$plan==14||$plan==15||$plan==21) { // pour plan 9, icone des stagiaires et pour plan 0 et 2, accolade runissant les sances 
			print "<td>&nbsp;</td>\n";
			++$nbcols;
		}
		// groupement
		if ($plan==12||$plan==13) {
			print"<td>Groupe</td>\n";
			++$nbcols;
		}
		if ($plan==25||$plan==26||$plan==27) {
			print"<td>Tri</td>\n";
			++$nbcols;
		}	
    	print"</tr>\n";	
		if ($plan==0||$plan==21) // toutes les sances de l'animation
			$q="SELECT seances.id_seance,max,public,cond FROM seances WHERE seances.id_anim=$id_anim ORDER BY seances.tri";		
		else if($plan==1||$plan==19||$plan==20) // affiche les sances partages (que le partage soit accept ou non)
			$q="SELECT seances.id_seance, max,public,accepte,id_partage,cond FROM seances, partages WHERE seances.id_anim=$id_anim AND seances.id_seance=partages.id_seance AND partages.id_circo=$id_circo ORDER BY seances.tri";		
		else if ($plan==22||$plan==25)  // n'affiche que les sances partages acceptes
			if (!$id_groupe) 
				$q="SELECT seances.id_seance, max,public,accepte,id_partage,cond, 0 AS groupement FROM seances, partages 
				WHERE seances.id_anim=$id_anim AND seances.id_seance=partages.id_seance AND partages.id_circo=$id_circo AND accepte=1 ORDER BY seances.tri";		
			else 
				$q="SELECT seances.id_seance, max,public,accepte,id_partage, CASE WHEN groupements.id_groupe IS NULL THEN 0 ELSE 1 END AS groupement,cond FROM (seances, partages) 
				LEFT JOIN groupements ON groupements.id_groupe=$id_groupe AND groupements.id_seance=seances.id_seance
				WHERE seances.id_anim=$id_anim AND seances.id_seance=partages.id_seance AND partages.id_circo=$id_circo AND accepte=1 ORDER BY seances.tri";		
		else if ($plan==27) 
			$q="SELECT seances.id_seance, max,public,id_partage,cond, 1 AS groupement FROM groupements,seances, partages,dates WHERE groupements.id_seance=seances.id_seance AND groupements.id_groupe=$id_groupe AND id_anim=$id_anim AND seances.id_seance=partages.id_seance AND partages.id_circo=$id_circo AND dates.id_seance=seances.id_seance AND accepte=1 GROUP BY seances.id_seance ORDER BY seances.tri";	
		else if ($plan==26) // n'affiche que les sances partages acceptes faisant partie de la liste
			if (!$id_groupe) $q="SELECT seances.id_seance, max, public,accepte, id_partage, cond, 0 AS groupement FROM seances, partages,items WHERE seances.id_anim=$id_anim AND seances.id_seance=partages.id_seance AND partages.id_circo=$id_circo AND accepte=1 AND seances.id_seance=items.id_seance AND items.id_liste=$id_liste ORDER BY seances.tri";
			else $q="SELECT seances.id_seance, max, public,accepte, id_partage,  CASE WHEN groupements.id_groupe IS NULL THEN 0 ELSE 1 END AS groupement, cond FROM (seances, partages,items) 
			LEFT JOIN groupements ON groupements.id_groupe=$id_groupe AND groupements.id_seance=seances.id_seance
			WHERE seances.id_anim=$id_anim AND seances.id_seance=partages.id_seance AND partages.id_circo=$id_circo AND accepte=1 AND seances.id_seance=items.id_seance AND items.id_liste=$id_liste ORDER BY seances.tri";
		else if($plan==2||$plan==3||$plan==8||$plan==9||$plan==10||$plan==11||$plan==12||$plan==15||$plan==23||$plan==28) 
			$q="SELECT seances.id_seance, max,public,id_partage, CASE WHEN groupements.id_groupe IS NULL THEN 0 ELSE 1 END AS groupement,cond FROM (seances, partages,dates) LEFT JOIN groupements ON groupements.id_groupe=$id_groupe AND groupements.id_seance=seances.id_seance WHERE id_anim=$id_anim AND seances.id_seance=partages.id_seance AND partages.id_circo=$id_circo AND dates.id_seance=seances.id_seance AND accepte=1 GROUP BY seances.id_seance ORDER BY seances.tri";	
		else if ($plan==4||$plan==5) {
			if ($id_groupe==0)
				$q="SELECT seances.id_seance, max,public,id_partage,cond FROM seances, partages,dates WHERE id_anim=$id_anim AND seances.id_seance=partages.id_seance AND partages.id_circo=$id_circo AND dates.id_seance=seances.id_seance AND accepte=1 GROUP BY seances.id_seance ORDER BY seances.tri";	
			else
				$q="SELECT seances.id_seance, max,public,id_partage, groupements.id_groupement,inscriptions.id_inscr,cond
					FROM (seances, partages,dates)
					LEFT JOIN inscriptions ON inscriptions.id_seance=seances.id_seance AND inscriptions.id_stagiaire=$id_stagiaire
					LEFT JOIN groupements ON groupements.id_groupe=$id_groupe AND groupements.id_seance=seances.id_seance
					WHERE id_anim=$id_anim AND seances.id_seance=partages.id_seance AND partages.id_circo=$id_circo AND dates.id_seance=seances.id_seance AND accepte=1
					GROUP BY seances.id_seance 
					HAVING (id_groupement IS NOT NULL) OR (id_inscr IS NOT NULL)
					ORDER BY seances.tri";	
		}
		else if ($plan==6||$plan==24) 
			$q="SELECT seances.id_seance, max,public,id_partage,cond FROM seances, partages,dates,inscriptions WHERE id_anim=$id_anim AND seances.id_seance=partages.id_seance AND partages.id_circo=$id_circo AND dates.id_seance=seances.id_seance AND inscriptions.id_seance=seances.id_seance AND inscriptions.id_stagiaire=$id_stagiaire AND accepte=1 GROUP BY seances.id_seance ORDER BY seances.tri";
		else if ($plan==7||$plan==16)
			$q="SELECT seances.id_seance, max,public,id_partage,cond FROM seances, partages,dates,convocations WHERE id_anim=$id_anim AND seances.id_seance=partages.id_seance AND partages.id_circo=$id_circo AND dates.id_seance=seances.id_seance AND convocations.id_seance=seances.id_seance AND convocations.id_stagiaire=$id_stagiaire AND accepte=1 GROUP BY seances.id_seance ORDER BY seances.tri";
		else if ($plan==13) 
			$q="SELECT seances.id_seance, max,public,id_partage,cond FROM groupements,seances, partages,dates WHERE groupements.id_seance=seances.id_seance AND groupements.id_groupe=$id_groupe AND id_anim=$id_anim AND seances.id_seance=partages.id_seance AND partages.id_circo=$id_circo AND dates.id_seance=seances.id_seance AND accepte=1 GROUP BY seances.id_seance ORDER BY seances.tri";	
		else if ($plan==14) 
			if ($id_groupe==0)
				$q="SELECT seances.id_seance, max,public,id_partage,cond FROM seances, partages,dates WHERE id_anim=$id_anim AND seances.id_seance=partages.id_seance AND partages.id_circo=$id_circo AND dates.id_seance=seances.id_seance AND accepte=1 GROUP BY seances.id_seance ORDER BY seances.tri";	
			else
				$q="SELECT seances.id_seance, max,public,id_partage,cond FROM seances, partages,dates,groupements WHERE id_anim=$id_anim AND seances.id_seance=partages.id_seance AND partages.id_circo=$id_circo AND dates.id_seance=seances.id_seance AND accepte=1 AND groupements.id_seance=seances.id_seance AND groupements.id_groupe=$id_groupe GROUP BY seances.id_seance ORDER BY seances.tri";	
		else
			die("Plan incorrect: $plan");
		
		$r2=query($q,$h);
		if (!$r2) break;
		
		//trouver le libelle de la circo d'origine (si plan!=0)
		$libelle_circo_origine='';
		if ($plan==1 || $plan==2 ||$plan==3||$plan==4||$plan==5||$plan==6||$plan==7||$plan==8||$plan==9||$plan==10||$plan==11||$plan==12||$plan==13||$plan==14||$plan==15||$plan==16||$plan==19||$plan==20||$plan==21||$plan==22||$plan==23||$plan==24||$plan==25||$plan==26||$plan==27||$plan==28) 
			$libelle_circo_origine=queryValue("SELECT libelle_court FROM circos WHERE id_circo=".$animation['id_circo'],$h);
		// pour affichage ligne vide entre deux sances
		$nb_dates_prec=0;
		$numligne=0;	
		while ($seance=@mysqli_fetch_array($r2)) {
			$id_seance=$seance['id_seance'];
			$q="SELECT * FROM dates WHERE id_seance=$id_seance ORDER BY dates.tri";
			$r3=query($q,$h);
			$nb_dates=@mysqli_num_rows($r3);
			//ligne vide ?
			if (($plan==0 || $plan==2||$plan==15||$plan==21) && $numligne>0 && $nb_dates>1 && $nb_dates_prec>1) {
				print "<tr><td colspan=\"$nbcols\">&nbsp;</td></tr>\n";
			}
			++$numligne;
			$nb_dates_prec=$nb_dates;
			//Vrification, pour un stagiaire donn, s'il est inscrit ou convoqu
			$stag_inscrit=-1; //valeurs normales: -1 pas pris en compte, 0 le stagiaire n'est pas inscrit (resp. convoqu), 1 le stagiaire est inscrit (resp. convoqu)
			$stag_convoque=-1;
			$groupement=-1;
			$tri='';
			if ($plan==3||$plan==11) {
				$q="SELECT COUNT(*) FROM inscriptions WHERE id_stagiaire=$id_stagiaire AND id_seance=".$seance['id_seance'];
				$stag_inscrit=queryValue($q,$h);
				$q="SELECT COUNT(*) FROM convocations WHERE id_stagiaire=$id_stagiaire AND id_seance=".$seance['id_seance'];
				$stag_convoque=queryValue($q,$h);
			}
			else if ($plan==4||$plan==5||$plan==6||$plan==24||$plan==28) {
				$q="SELECT COUNT(*) FROM inscriptions WHERE id_stagiaire=$id_stagiaire AND id_seance=".$seance['id_seance'];
				$stag_inscrit=queryValue($q,$h);
			}
			else if ($plan==7||$plan==23) {
				$q="SELECT COUNT(*) FROM convocations WHERE id_stagiaire=$id_stagiaire AND id_seance=".$seance['id_seance'];
				$stag_convoque=queryValue($q,$h);
			}
			else if ($plan==12||$plan==13) {
				$q="SELECT COUNT(*) FROM groupements,groupes WHERE groupements.id_seance=".$seance['id_seance']." AND groupements.id_groupe=groupes.id_groupe AND groupes.id_circo=$id_circo AND groupes.id_groupe=$id_groupe";
				$groupement=queryValue($q,$h);
			}
			else if ($plan==25||$plan==26||$plan==27) {
				$tri='';
				if ($id_liste) {
					$r4=query("SELECT tri FROM items WHERE id_liste=$id_liste AND id_seance=$id_seance",$h);
					if ($r4) {
						$row=@mysqli_fetch_row($r4);
						$tri=$row[0];
					}
				}
			}
			// Affichage ventuel de la circo d'origine puis du pulic; colonnes groupes si plusieurs dates
			$groupe='';
			if ($nb_dates>1) $groupe="rowspan=\"$nb_dates\"";
			print "<tr>\n";
			if($plan==0) { //affichage des circos partages (en gras les acceptes)
				$lib='';
				$r4=query("SELECT circos.libelle_court, accepte FROM partages, circos WHERE partages.id_seance=$id_seance AND partages.id_circo=circos.id_circo ORDER BY circos.libelle_court",$h);
				while ($circ=@mysqli_fetch_row($r4)) {
					if ($lib!='') $lib.=', ';
					if ($circ[1]>0) $lib.=sprintf("<b>%s</b>",htmlentities($circ[0],ENT_COMPAT,'ISO-8859-15'));
					else $lib.=htmlentities($circ[0],ENT_COMPAT,'ISO-8859-15');
				}
				if ($lib) 
					$lib.='.';
				else $lib='&nbsp;';
				print "<td $classe $groupe>$lib</td>\n"; 
			}
			else if ($plan==1||$plan==19||$plan==20||$plan==22) { //importation des animations: montrer la circo d'origine et le bouton d'importation si c'est une circo extrieure
					if ($seance['accepte']) {
							print "<td class=\"cadre_actif\" $groupe>\n";
							$stag_inscrit= queryValue(sprintf("SELECT COUNT(*) FROM inscriptions,stagiaires,ecoles WHERE inscriptions.id_seance=%d AND inscriptions.id_stagiaire=stagiaires.id_stagiaire AND stagiaires.id_ecole=ecoles.id_ecole AND ecoles.id_circo=$id_circo",$seance['id_seance']),$h);
							$stag_convoque=queryValue(sprintf("SELECT COUNT(*) FROM convocations,stagiaires,ecoles WHERE convocations.id_seance=%d AND convocations.id_stagiaire=stagiaires.id_stagiaire AND stagiaires.id_ecole=ecoles.id_ecole AND ecoles.id_circo=$id_circo",$seance['id_seance']),$h);
					}
					else print "<td $groupe>";
					if ($animation['id_circo']!=$id_circo) //n'afficher la checkbox que pour les animations importes
						if ($seance['accepte'] && ($stag_inscrit>0 || $stag_convoque>0)) print "<img src=\"images/transfert_impossible.png\" alt=\"Case barr&eacute;e\" />\n";
						else printf ("<input type=\"checkbox\" name=\"id_partages[]\" value=\"%s\" />",$seance['id_partage']);
						//printf ("<input type=\"checkbox\" name=\"id_partages[]\" value=\"%s\"%s />",$seance['id_partage'],$seance['accepte']>0?' checked="checked" ':'');
					print htmlentities($libelle_circo_origine,ENT_COMPAT,'ISO-8859-15');
					print "</td>\n";
			}	
			else if ($plan==2||$plan==3||$plan==4||$plan==5||$plan==6||$plan==7||$plan==8||$plan==9||$plan==10||$plan==11||$plan==12||$plan==13||$plan==14||$plan==15||$plan==16||$plan==21||$plan==23||$plan==24||$plan==25||$plan==26||$plan==27||$plan==28) {
					print "<td $classe $groupe>".htmlentities($libelle_circo_origine,ENT_COMPAT,'ISO-8859-15')."</td>\n";
			}
			//affichage du public
			$classe_p=$classe;
			if ($seance['cond']>0 && ($plan==0 || $plan==1 || $plan==2 ||$plan==8 || $plan==9 || $plan==10 || $plan==11 || $plan==12 || $plan==13||$plan==19 ||$plan==20||$plan==21||$plan==22||$plan==25||$plan==26||$plan==27)) $classe_p='class="seance_suppl"'; 
			print "<td $classe_p $groupe>\n";
			if ($seance['public'])
				print htmlentities($seance['public'],ENT_COMPAT,'ISO-8859-15');
			else print '&nbsp;';
			if ($seance['max']>0) {
				print "<br/>\n";
				print "Limit&eacute;  ".$seance['max']." stagiaires";
			}
			if ($seance['cond']>0) {
				print "<br/>\n";
				if ($nb_dates<=1)
					print "<em>S&eacute;ance suppl&eacute;mentaire, ouverte si besoin.</em>";
				else
					print "<em>S&eacute;ances suppl&eacute;mentaires, ouvertes si besoin.</em>";
				
			}
			print "</td>\n";
			// Y a-t-il une erreur et pas de dates ? Affiche les colonnes vides
			$afficher_tr=false;

			if ($nb_dates==0) {
				print "<td $classe>&nbsp;</td>\n"; //date
				print "<td $classe>&nbsp;</td>\n"; //lieu			
				print "<td $classe>&nbsp;</td>\n"; //intervenant
				print "<td $classe>&nbsp;</td>\n"; //remarque
				print "<td $classe>&nbsp;</td>\n"; //dure
				if ($plan==3 || $plan==8||$plan==11||$plan==25||$plan==26||$plan==27) {
					print "<td $classe>&nbsp;</td>\n"; //inscrits
					print "<td $classe>&nbsp;</td>\n"; //convoqus
				}
				else if ($plan==4 || $plan==5||$plan==6 ||$plan==7||$plan==16||$plan=23||$plan==24)
					print "<td $classe>&nbsp;</td>\n"; //inscrits ou convoqus ou absents
				else	if ($plan==9||$plan==10) {
						print "<td $classe>&nbsp;</td>\n"; //inscrits
						print "<td $classe>&nbsp;</td>\n"; //convoqus
						print "<td $classe>&nbsp;</td>\n"; //colonne vide pour icne stagiaire
				}
			}
			// affichage de chaque lment dates
			else while($datelieu=@mysqli_fetch_array($r3)) {
				if ($afficher_tr) print"<tr>\n";
				if ($datelieu['date']=='0000-00-00') $datelieu['date']='9999-12-31';
				// lire la liste des intervenants
				$datelieu['intervenants']=array();
				$r4=query("SELECT id_intervenant FROM interventions WHERE id_date=".$datelieu['id_date'],$h);
				while($int=@mysqli_fetch_row($r4)) $datelieu['intervenants'][]=$int[0];
				// afficher...
				$classe_date=$classe;
				if ($test_date>0 ) {
					switch( $test_date) {
						case 1: // <=
							if ($datelieu['date']<'9999-12-30' && $datelieu['date']<=$date ) $classe_date='class="date_surbrille"';
							break;
						case 2: // >=
							if ($datelieu['date']<'9999-12-30' && $datelieu['date']>=$date) $classe_date='class="date_surbrille"';
							break;
						case 3: // ==
							if ($date == $datelieu['date']) $classe_date='class="date_surbrille"';
							break;
						case 4: //  dfinir
							if ($datelieu['date'] == '9999-12-31') $classe_date='class="date_surbrille"';
							break;
						case 5: // FOAD
							if ($datelieu['date'] == '9999-12-30') $classe_date='class="date_surbrille"';
							break;
					}
				}
				printf("<td $classe_date>%s",dateSQLEnTexte($datelieu['date']));
				$horaire=horaireSqlEnHeure($datelieu['horaire']);		
				if ($horaire && $datelieu['date']<'9999-12-30') printf(" - %s",$horaire);
				
				print "</td>\n";
				// lieu
				$lieu='';
				if ($datelieu['date']=='9999-12-30')//FOAD ?
					if ($datelieu['lieu']=='') $lieu='&nbsp;-&nbsp;';
					else $lieu=lierPonctuation(htmlentities($datelieu['lieu'],ENT_COMPAT,'ISO-8859-15'));
				else 
					if ($datelieu['lieu']=='') $lieu=htmlentities(" dfinir",ENT_COMPAT,'ISO-8859-15');
					else $lieu=htmlentities($datelieu['lieu'],ENT_COMPAT,'ISO-8859-15');
				print("<td $classe>$lieu</td>\n");
				if (count($datelieu['intervenants'])==0)
					print"<td $classe>&nbsp;</td>\n";
				else 
					printf("<td $classe>%s</td>\n",htmlentities(intervenants($datelieu['intervenants'],$h),ENT_COMPAT,'ISO-8859-15'));
	
				$rem=lierPonctuation(htmlentities($datelieu['remarque'],ENT_COMPAT,'ISO-8859-15'));
				if ($rem=='') $rem='&nbsp;';
				else $rem=str_replace("\n","<br />",$rem);
				printf("<td $classe>%s</td>\n",$rem);
				printf("<td $classe>%s</td>\n",reelEnHeure($datelieu['duree']));
				if ($plan==0 || $plan==2||$plan==14||$plan==15||$plan==21) { //accolade finale si plus d'une date
					if ($nb_dates<=1) print "<td>&nbsp;</td>\n";
					else {
						$texte1="class=\"accolade\" ><p>$nb_dates s&eacute;ances<br/>group&eacute;es</p>";
						afficheUneFois($id_seance,$nb_dates,$texte1);
					}
					
				}
				else if ($plan==3||$plan==23) { //convoquer  un stagiaire -afficher une case  cocher
					$max=queryValue("SELECT max FROM seances WHERE id_seance=$id_seance",$h);
					$total_inscrits=queryValue("SELECT COUNT(*) FROM inscriptions WHERE id_seance=$id_seance",$h);
					$total_convoc=queryValue("SELECT COUNT(*) FROM convocations WHERE id_seance=$id_seance",$h);
					if ($max>0) $lib="($total_convoc/$max)";
					else $lib="($total_convoc)";
					$texte1='';
					$texte2='';
					if (!$seance['groupement']) {
						$cadre_actif='cadre_actif';
						$cadre_inactif='cadre_inactif';
					}
					else {
						$cadre_actif='cadre_groupe_actif';
						$cadre_inactif='cadre_groupe_inactif';
					}
					if ($stag_inscrit>=0) { // on veut afficher si le stagiaire est inscrit  une sance
								if ($stag_inscrit>0) $texte1="class=\"$cadre_actif\">oui ($total_inscrits)";
								else $texte1="class=\"$cadre_inactif\">non ($total_inscrits)";
					}
					if ($stag_convoque>=0) { // on veut afficher la case  cocher pour choisir ou convoquer un stagiaire
						if ($stag_convoque>0) $texte2="class=\"$cadre_actif\"><input type=\"checkbox\" name=\"convoquer[]\" value=\"$id_seance\" checked=\"checked\" />$lib";
						else {
							$autoriser_convoc_plafond=autoriserConvocPlafond($id_seance,$h);
							//s'il y a un maximum ET le stagiaire n'est pas inscrit ET l'organisateur interdit la convocation aux non-inscrits, alors impossible de convoquer 
	
							
							if ($max>0 && $autoriser_convoc_plafond==0 && !$stag_inscrit && $total_convoc<$max) 
								$texte2="class=\"$cadre_inactif\"><input class=\"bouton_interdit\" type=\"button\" onclick=\"javascript:popUp('adm_expl_convoc.php?id_seance=$id_seance','console',600,400)\" /><br/>$lib\n";
							
							else {
								if ($max>0 && $total_convoc>=$max) 
									$texte2="class=\"$cadre_inactif\">max. atteint<br/>$lib"; 
								else 
									$texte2="class=\"$cadre_inactif\"><input type=\"checkbox\" name=\"convoquer[]\" value=\"$id_seance\" />$lib";
							}
						}
					}
					afficheUneFois($id_seance,$nb_dates,$texte1,$texte2);
				} 
				else if ($plan==11||$plan==28) { //inscrire  un stagiaire -afficher une case  cocher
					$max=queryValue("SELECT max FROM seances WHERE id_seance=$id_seance",$h);
					$total_inscrits=queryValue("SELECT COUNT(*) FROM inscriptions WHERE id_seance=$id_seance",$h);
					$total_convoc=queryValue("SELECT COUNT(*) FROM convocations WHERE id_seance=$id_seance",$h);
					if ($max>0) $lib="($total_inscrits/$max)";
					else $lib="($total_inscrits)";
					$texte1='';
					$texte2='';
					if (!$seance['groupement']) {
						$cadre_actif='cadre_actif';
						$cadre_inactif='cadre_inactif';
					}
					else {
						$cadre_actif='cadre_groupe_actif';
						$cadre_inactif='cadre_groupe_inactif';
					}
					if ($stag_inscrit>=0) { // on veut afficher la case  cocher pour choisir ou convoquer un stagiaire
						if ($stag_inscrit>0) $texte1="class=\"$cadre_actif\"><input type=\"checkbox\" name=\"inscrire[]\" value=\"$id_seance\" checked=\"checked\" />$lib";
						else 
							if ($max>0 && $total_inscrits>=$max&&!$stag_convoque) // si on est convoqu et pas inscrit, on peut nanmoins s'inscrire vu le comptage effectu
								$texte1="class=\"$cadre_inactif\">max. atteint<br/>$lib"; 
							else 
								$texte1="class=\"$cadre_inactif\"><input type=\"checkbox\" name=\"inscrire[]\" value=\"$id_seance\" />$lib";
					}
					if ($stag_convoque>=0) { // on veut afficher si le stagiaire est convoque  une sance
						if ($stag_convoque>0) $texte2="class=\"$cadre_actif\">oui ($total_convoc)";
						else $texte2="class=\"$cadre_inactif\">non ($total_convoc)";
					}
					afficheUneFois($id_seance,$nb_dates,$texte1,$texte2);
				} 
				else if ($plan==4) { //inscription par le stagiaire lui-mme
					$max=queryValue("SELECT max FROM seances WHERE id_seance=$id_seance",$h);
					$total_inscrits=queryValue("SELECT COUNT(*) FROM inscriptions WHERE id_seance=$id_seance",$h);
					$total_inter=queryValue("SELECT COUNT(*) FROM inscriptions,convocations WHERE inscriptions.id_seance=$id_seance AND convocations.id_stagiaire=inscriptions.id_stagiaire AND convocations.id_seance=$id_seance",$h);
					$total_convoc=queryValue("SELECT COUNT(*) FROM convocations WHERE id_seance=$id_seance",$h);
					$total_inscrits+=($total_convoc-$total_inter);
					if ($max>0 && $total_inscrits>$max) $total_inscrits=$max; // a peut arriver; l'ter pour ne pas susciter l'incomprhension ou les ricannements des stagiaires
					
					if ($seance['cond']==0 || $total_inscrits>0) {
						$lib2="(<a href=\"javascript:ouvre('ins_liste_stagiaires.php?id_seance=$id_seance')\">$total_inscrits</a>)";
						if ($max>0) $lib="(<a href=\"javascript:ouvre('ins_liste_stagiaires.php?id_seance=$id_seance')\">$total_inscrits/$max</a>)";
						else if ($total_inscrits>0) $lib=$lib2;
						else $lib="(0)";
						if ($stag_inscrit>0) $texte1="class=\"cadre_actif\"><input type=\"checkbox\" name=\"inscrire[]\" value=\"$id_seance\" checked=\"checked\" /> $lib";
						else {
							if ($max==0 || $total_inscrits<$max) 
								$texte1="class=\"cadre_inactif\"><input type=\"checkbox\" name=\"inscrire[]\" value=\"$id_seance\" /> $lib";
							else
								$texte1="class=\"cadre_inactif\">clos: max. atteint $lib2";
						}
						afficheUneFois($id_seance,$nb_dates,$texte1);
					}
					else { // il y a une condition et le nombre d'inscrits est nul: voir si la sance est ouverte ou ferme
						$ouvert=false;
						$s='';
						if ($nb_seances>0) $s='s';
						if ($max_precedent>0 && $total_inscrits_precedent>0) 
							$ouvert=$total_inscrits_precedent+$seance['cond']-1>= $max_precedent;
						if ($ouvert)	
							$texte1="class=\"cadre_inactif\"><input type=\"checkbox\" name=\"inscrire[]\" value=\"$id_seance\" /> s&eacute;ance$s suppl&eacute;mentaire$s ouverte$s (0)";
						else
							$texte1="class=\"cadre_inactif\">s&eacute;ance$s suppl&eacute;mentaires ferm&eacute;e$s";
						afficheUneFois($id_seance,$nb_dates,$texte1);
					}
					$total_inscrits_precedent=$total_inscrits;
					$max_precedent=$max;
				}
				else if ($plan==5||$plan==6||$plan==24) { //Le stagiaire ne peut plus rien cocher, uniquement consulter.
					$max=queryValue("SELECT max FROM seances WHERE id_seance=$id_seance",$h);
					$total_inscrits=queryValue("SELECT COUNT(*) FROM inscriptions WHERE id_seance=$id_seance",$h);
					$total_inter=queryValue("SELECT COUNT(*) FROM inscriptions,convocations WHERE inscriptions.id_seance=$id_seance AND convocations.id_stagiaire=inscriptions.id_stagiaire AND convocations.id_seance=$id_seance",$h);
					$total_convoc=queryValue("SELECT COUNT(*) FROM convocations WHERE id_seance=$id_seance",$h);
					$total_inscrits+=$total_convoc-$total_inter;
					if ($plan==5 || $plan==6) {
						$lib2="(<a href=\"javascript:ouvre('ins_liste_stagiaires.php?id_seance=$id_seance')\">$total_inscrits</a>)";
						if ($max>0) $lib="(<a href=\"javascript:ouvre('ins_liste_stagiaires.php?id_seance=$id_seance')\">$total_inscrits/$max</a>)";
						else if ($total_inscrits>0) $lib=$lib2;
						else $lib="(0)";
					}
					else {
						$lib2="(<a href=\"javascript:ouvre('adm_voir_stagiaires.php?inscrits=$id_seance')\">$total_inscrits</a>)";
						if ($max>0) $lib="(<a href=\"javascript:ouvre('adm_voir_stagiaires.php?inscrits=$id_seance')\">$total_inscrits/$max</a>)";
						else if ($total_inscrits>0) $lib=$lib2;
						else $lib="(0)";
					
					
					}
					if ($stag_inscrit>0) $texte1="class=\"cadre_actif\">oui $lib";
					else 
						if ($max==0 || $total_inscrits<$max) 
							$texte1="class=\"cadre_inactif\">non $lib";
						else
							$texte1="class=\"cadre_inactif\">non - clos: max. atteint $lib2";
						afficheUneFois($id_seance,$nb_dates,$texte1);
				}
				else if ($plan==7) { //Consultation des convocations par le stagiaire
					$max=queryValue("SELECT max FROM seances WHERE id_seance=$id_seance",$h);
					$total_convoc=queryValue("SELECT COUNT(*) FROM convocations WHERE id_seance=$id_seance",$h);
					$lib2="(<a href=\"javascript:ouvre('ins_liste_stagiaires_convoques.php?id_seance=$id_seance')\">$total_convoc</a>)";
					if ($max>0) $lib="(<a href=\"javascript:ouvre('ins_liste_stagiaires_convoques.php?id_seance=$id_seance')\">$total_convoc/$max</a>)";
					else if ($total_convoc>0) $lib=$lib2;
					else $lib="(0)";
					if ($stag_inscrit>0||$stag_convoque>0) 
						$texte1="class=\"cadre_actif\">$lib";
					else $texte1="&nbsp;";
					// affichage aussi des abences ventelles du stagiaire
					$id_date=$datelieu['id_date'];
					
					$r=query("SELECT excuse FROM absences WHERE id_stagiaire=$id_stagiaire AND id_date=$id_date",$h);		
					if (@mysqli_num_rows($r)>0) {
						$row=@mysqli_fetch_row($r);
						$excuse=$row[0];
						if ($excuse==0) 
							$texte1.="<br/><b>Absent(e)</b>";
						else
							$texte1.="<br/><b>Excus&eacute;(e)</b>";
						
					}
					afficheUneFois($id_seance,$nb_dates,$texte1);
					
				}
				else if ($plan==8||$plan==25||$plan==26||$plan==27 ) { //montrer le nombre d'inscrits et de convoqus, et ouvrir un popup avec les noms
					$max=queryValue("SELECT max FROM seances WHERE id_seance=$id_seance",$h);
					$total_inscrits=queryValue("SELECT COUNT(*) FROM inscriptions WHERE id_seance=$id_seance",$h);
					$total_convoc=queryValue("SELECT COUNT(*) FROM convocations WHERE id_seance=$id_seance",$h);
					if ($max>0) {
						$libc="$total_convoc/$max";
						$libi="$total_inscrits/$max";
					}
					else {
						$libc="$total_convoc";
						$libi="$total_inscrits";
					}
					if ($total_inscrits>0)
						$texte1="class=\"cadre_inactif\"><a href=\"javascript:ouvre('adm_voir_stagiaires.php?inscrits=$id_seance') \">$libi</a>";
					else
						$texte1="class=\"cadre_inactif\">$libi";
					if ($total_convoc>0)
						$texte2="class=\"cadre_inactif\"><a href=\"javascript:ouvre('adm_voir_stagiaires.php?convoques=$id_seance') \">$libc</a>"; 
					else 
						$texte2="class=\"cadre_inactif\">$libc";
					$texte3='';
					if ($plan==25||$plan==26||$plan==27) { //affichage de la balise input texte pour cration des listes
						if (!$id_groupe) {
							if ($tri!='') 
								$texte3="class=\"cadre_actif\"><input type=\"text\" name=\"tri[$id_seance]\" size=\"4\" maxlength=\"6\" value=\"$tri\" />";
							else
								$texte3="class=\"cadre_inactif\"><input type=\"text\" name=\"tri[$id_seance]\" size=\"4\" maxlength=\"6\" />";
						}
						else {
							if ($seance['groupement']>0) 
								if ($tri !='') $texte3="class=\"cadre_groupe_actif\"><input type=\"text\" name=\"tri[$id_seance]\" size=\"4\" maxlength=\"6\" value=\"$tri\" />";
								else
									$texte3="class=\"cadre_groupe_inactif\"><input type=\"text\" name=\"tri[$id_seance]\" size=\"4\" maxlength=\"6\" />";
							else
								if ($tri!='') 
									$texte3="class=\"cadre_actif\"><input type=\"text\" name=\"tri[$id_seance]\" size=\"4\" maxlength=\"6\" value=\"$tri\" />";
								else
									$texte3="class=\"cadre_inactif\"><input type=\"text\" name=\"tri[$id_seance]\" size=\"4\" maxlength=\"6\" />";
						}
					}
					afficheUneFois($id_seance,$nb_dates,$texte1,$texte2,$texte3);
				} 
				else if ($plan==9||$plan==10) { //montrer le nombre d'inscrits et de convoqus, et afficher le lien stagiaires 
					$max=queryValue("SELECT max FROM seances WHERE id_seance=$id_seance",$h);
					$inscrits_circo=queryValue("SELECT COUNT(*) FROM inscriptions,stagiaires,ecoles WHERE inscriptions.id_seance=$id_seance AND inscriptions.id_stagiaire=stagiaires.id_stagiaire AND stagiaires.id_ecole=ecoles.id_ecole AND ecoles.id_circo=$id_circo",$h);
					$convoc_circo=queryValue("SELECT COUNT(*) FROM convocations,stagiaires,ecoles WHERE convocations.id_seance=$id_seance AND convocations.id_stagiaire=stagiaires.id_stagiaire AND stagiaires.id_ecole=ecoles.id_ecole AND ecoles.id_circo=$id_circo",$h);
					$nb_partages=queryValue("SELECT COUNT(*) FROM partages WHERE id_seance=$id_seance AND accepte=1",$h);
					if ($nb_partages>1) {
						$total_inscrits=queryValue("SELECT COUNT(*) FROM inscriptions WHERE id_seance=$id_seance",$h);
						$total_convoc=queryValue("SELECT COUNT(*) FROM convocations WHERE id_seance=$id_seance",$h);
						if ($max>0) {
							$libc="$convoc_circo/$max (total:&nbsp;$total_convoc)";
							$libi="$inscrits_circo/$max (total:&nbsp;$total_inscrits)";
						}
						else {
							$libc="$convoc_circo (total:&nbsp;$total_convoc)";
							$libi="$inscrits_circo (total:&nbsp;$total_inscrits)";
						}
					}
					else {
						if ($max>0) {
							$libc="$convoc_circo/$max";
							$libi="$inscrits_circo/$max";
						}
						else {
							$libc="$convoc_circo";
							$libi="$inscrits_circo";
						}
					}
					$texte1="class=\"cadre_inactif\">$libi";
					$texte2="class=\"cadre_inactif\">$libc";
					
					//lien vers page stagiaires
	  				if ($plan==9) 
						$texte3= "><a href=\"adm_convocations_faire.php?id_seance=$id_seance&amp;url_ret=adm_convocations_anim.php\"><img src=\"images/b_stagiaires.png\" alt=\"liste stagiaires\" /></a>";
					else //plan==10
						$texte3= "><a href=\"adm_inscriptions_faire.php?id_seance=$id_seance&amp;url_ret=adm_inscriptions_anim.php\"><img src=\"images/b_stagiaires.png\" alt=\"liste stagiaires\" /></a>";
								
					afficheUneFois($id_seance,$nb_dates,$texte1,$texte2,$texte3);
				}
				else if ($plan==12||$plan==13) { // affichage case a cocher "groupe"
					if ($groupement>0)
						$texte1= "class=\"cadre_actif\"><input type=\"checkbox\" name=\"groupement[]\" value=\"$id_seance\" checked=\"checked\"/>";
					else
						$texte1= "class=\"cadre_inactif\"><input type=\"checkbox\" name=\"groupement[]\" value=\"$id_seance\" />";
					afficheUneFois($id_seance,$nb_dates,$texte1);
				}
				else if ($plan==16) { // affichage de la case absences
					$id_date=$datelieu['id_date'];
					$id_abs=queryValue("SELECT id_abs FROM absences WHERE id_stagiaire=$id_stagiaire AND id_date=$id_date",$h);		
				
					if ($id_abs)
						$texte1="class=\"cadre_actif\"><input type=\"checkbox\" name=\"absence[]\" value=\"$id_date\" onclick=\"javascript:decocheExcuse(this)\" checked=\"checked\"/>";
					else
						$texte1= "class=\"cadre_inactif\"><input type=\"checkbox\" name=\"absence[]\" value=\"$id_date\" onclick=\"javascript:decocheExcuse(this)\" />";
					print "<td $texte1</td>";
					$excuse=0;
					if ($id_abs) $excuse=queryValue("SELECT excuse FROM absences WHERE id_abs=$id_abs",$h);
					if ($excuse)
						$texte2="class=\"cadre_actif\"><input type=\"checkbox\" name=\"excuse[]\" value=\"$id_date\" onclick=\"javascript:cocheAbsent(this)\" checked=\"checked\"/>";
					else
						$texte2= "class=\"cadre_inactif\"><input type=\"checkbox\" name=\"excuse[]\" value=\"$id_date\" onclick=\"javascript:cocheAbsent(this)\" />";
					print "<td $texte2</td>";
					
					
					
				}
				
				print "</tr>\n";
				$afficher_tr=true;
			}
		}
		$ok=true;
		print "</table>\n";
		break;
	}

	print "</td>\n";
	// affichage des inscriptions
	print "</tr>\n"; 
	print "</table>\n";
	$impair=!$impair;	
	return $ok;
}
/*
	id_circo: circo en cours
	plan: numro du plan
	test_date: 
		0 pas de test sur date, 
		1: >=, 2 = 3 <=  la date mentionne en $date.
		Mise en surbrillance des dates si correspondance au test.

// id_groupe est renseign uniquement si id_stagiaire vaut 0. Sinon, il faut rcuprer id_groupe dans la bdd
*/
function affichePlanFormation($id_circo,$h,$plan,$id_stagiaire=0,$url='',$id_groupe=0,$test_date=0,$date='',$annee=0,$id_circo_import=0,$id_liste=0)
{
	//debugInit();
	$numtheme=1;
	if ($date=='0000-00-00') $date='9999-31-12';
	if ($id_stagiaire>0 && $id_groupe==0) 
		$id_groupe=queryValue("SELECT id_groupe FROM stagiaires WHERE id_stagiaire=$id_stagiaire",$h);
	if ($id_groupe>0) {
		$nb=queryValue("SELECT COUNT(*) FROM groupements WHERE id_groupe=$id_groupe",$h);
		if ($nb==0) $id_groupe=0; // voir tout le plan de formation si un groupe ne contient aucune anim
	}
	if ($plan==17|| $plan==18) {
		affichePlanDate($id_circo,$h,$id_groupe,$annee,$url,$plan);
		return;
	}
	$impair=0;
	if ($plan==1|| $plan==19 || $plan==20||$plan==22) // montrer extrait du plan de formation import 
		$rd=query("SELECT id_domaine, libelle FROM domaines WHERE id_circo=$id_circo_import AND annee=$annee ORDER BY domaines.tri",$h);
	else
		$rd=query("SELECT id_domaine, libelle FROM domaines WHERE id_circo=$id_circo AND annee=$annee ORDER BY domaines.tri",$h);
	$compte=0;
	while ($domaine =@mysqli_fetch_array($rd)) {
		$id_domaine=$domaine['id_domaine'];
		if ($plan==0) 
			$q="SELECT animations.id_anim,positions.id_theme FROM animations, positions,themes WHERE positions.id_anim=animations.id_anim AND animations.id_circo=$id_circo AND positions.id_domaine=$id_domaine AND themes.id_theme=positions.id_theme ORDER BY themes.tri, positions.tri, positions.id_position";
		else if ($plan==1) 
			$q="SELECT animations.id_anim,positions.id_theme FROM partages,seances, animations, positions,themes WHERE partages.id_circo=$id_circo AND partages.id_seance=seances.id_seance AND seances.id_anim=animations.id_anim AND animations.id_circo=$id_circo_import AND animations.id_anim=positions.id_anim AND positions.id_domaine=$id_domaine AND themes.id_theme=positions.id_theme GROUP BY animations.id_anim ORDER BY themes.tri, positions.tri,positions.id_position";
		else if ($plan==19)
			$q="SELECT animations.id_anim,positions.id_theme FROM partages,seances, animations, positions,themes WHERE partages.id_circo=$id_circo AND partages.accepte=0 AND partages.id_seance=seances.id_seance AND seances.id_anim=animations.id_anim AND animations.id_circo=$id_circo_import AND animations.id_anim=positions.id_anim AND positions.id_domaine=$id_domaine AND themes.id_theme=positions.id_theme GROUP BY animations.id_anim ORDER BY themes.tri, positions.tri,positions.id_position";
		else if ($plan==20||$plan==22)
			$q="SELECT animations.id_anim,positions.id_theme FROM partages,seances, animations, positions,themes WHERE partages.id_circo=$id_circo AND partages.accepte=1 AND partages.id_seance=seances.id_seance AND seances.id_anim=animations.id_anim AND animations.id_circo=$id_circo_import AND animations.id_anim=positions.id_anim AND positions.id_domaine=$id_domaine AND themes.id_theme=positions.id_theme GROUP BY animations.id_anim ORDER BY themes.tri, positions.tri,positions.id_position";
		
		else if ($plan==2||$plan==3||$plan==11||$plan==15)
			$q="SELECT animations.id_anim,positions.id_theme FROM partages, seances, animations,positions,themes WHERE partages.id_circo=$id_circo AND partages.accepte=1 AND partages.id_seance=seances.id_seance AND seances.id_anim=animations.id_anim AND animations.id_anim=positions.id_anim AND positions.id_domaine=$id_domaine AND themes.id_theme=positions.id_theme GROUP BY animations.id_anim ORDER BY themes.tri, positions.tri,positions.id_position";
		else if ($plan==4 || $plan==5) {//stagiaire choisit/ consulte le plan qui lui est destin
			if ($id_groupe>0)
					$q="SELECT animations.id_anim, positions.id_theme, CASE WHEN inscriptions.id_inscr IS NULL  AND groupements.id_groupement IS NULL THEN 0 ELSE 1 END AS valide
	FROM (partages, seances, animations, positions, themes)
	LEFT JOIN inscriptions ON inscriptions.id_seance = seances.id_seance AND inscriptions.id_stagiaire =$id_stagiaire
	LEFT JOIN groupements ON groupements.id_groupe =$id_groupe AND groupements.id_seance = seances.id_seance
	WHERE partages.id_circo =$id_circo AND partages.id_seance = seances.id_seance AND partages.accepte <>0 AND seances.id_anim = animations.id_anim AND positions.id_anim=animations.id_anim AND positions.id_domaine =$id_domaine AND themes.id_theme = positions.id_theme 
	GROUP BY animations.id_anim, valide
	HAVING valide=1 
	ORDER BY themes.tri, positions.tri,positions.id_position";
			else
				$q="SELECT animations.id_anim,positions.id_theme FROM partages, seances, animations,positions, themes WHERE partages.id_circo=$id_circo AND partages.id_seance=seances.id_seance AND partages.accepte<>0 AND seances.id_anim=animations.id_anim AND animations.id_anim=positions.id_anim AND positions.id_domaine=$id_domaine AND themes.id_theme=positions.id_theme GROUP BY animations.id_anim ORDER BY themes.tri, positions.tri,positions.id_position";
		}else if ($plan==8||$plan==9||$plan==10||$plan==12||$plan==25)
			$q="SELECT animations.id_anim,positions.id_theme FROM partages, seances, animations, positions, themes WHERE partages.id_circo=$id_circo AND partages.id_seance=seances.id_seance AND partages.accepte<>0 AND seances.id_anim=animations.id_anim AND animations.id_anim=positions.id_anim AND positions.id_domaine=$id_domaine AND themes.id_theme=positions.id_theme GROUP BY animations.id_anim ORDER BY themes.tri, positions.tri,positions.id_position";
		else if ($plan==26) 
			$q="SELECT animations.id_anim,positions.id_theme FROM partages, seances, animations, positions, themes,items WHERE partages.id_circo=$id_circo AND partages.id_seance=seances.id_seance AND seances.id_seance=items.id_seance AND items.id_liste=$id_liste AND partages.accepte<>0 AND seances.id_anim=animations.id_anim AND animations.id_anim=positions.id_anim AND positions.id_domaine=$id_domaine AND themes.id_theme=positions.id_theme GROUP BY animations.id_anim ORDER BY themes.tri, positions.tri,positions.id_position";
		else if ($plan==6||$plan==24||$plan==28)
			$q="SELECT animations.id_anim, positions.id_theme FROM partages, seances, animations, positions,themes,inscriptions WHERE partages.id_circo=$id_circo AND partages.id_seance=seances.id_seance AND seances.id_anim=animations.id_anim AND animations.id_anim=positions.id_anim AND positions.id_domaine=$id_domaine AND themes.id_theme=positions.id_theme AND seances.id_seance=inscriptions.id_seance AND inscriptions.id_stagiaire=$id_stagiaire GROUP BY animations.id_anim ORDER BY  themes.tri, positions.tri,positions.id_position";
		else if ($plan==7||$plan==16||$plan==23)
			$q="SELECT animations.id_anim, positions.id_theme FROM partages, seances, animations, positions,themes,convocations WHERE partages.id_circo=$id_circo AND partages.id_seance=seances.id_seance AND seances.id_anim=animations.id_anim AND animations.id_anim=positions.id_anim AND positions.id_domaine=$id_domaine AND themes.id_theme=positions.id_theme AND seances.id_seance=convocations.id_seance AND convocations.id_stagiaire=$id_stagiaire GROUP BY animations.id_anim ORDER BY  themes.tri, positions.tri,positions.id_position";
		else if ($plan==13||$plan==27) 
			$q="SELECT animations.id_anim,positions.id_theme FROM groupements,partages, seances, animations, positions,themes WHERE groupements.id_groupe=$id_groupe AND  partages.id_circo=$id_circo AND partages.id_seance=seances.id_seance AND partages.accepte<>0  AND seances.id_seance=groupements.id_seance AND seances.id_anim=animations.id_anim AND animations.id_anim=positions.id_anim AND positions.id_domaine=$id_domaine AND themes.id_theme=positions.id_theme GROUP BY animations.id_anim ORDER BY themes.tri, positions.tri,positions.id_position";
		else if ($plan==14) 
			if ($id_groupe>0) 
				$q="SELECT animations.id_anim,positions.id_theme FROM partages, seances, animations, positions, themes, groupements WHERE groupements.id_groupe=$id_groupe AND groupements.id_seance=seances.id_seance AND partages.id_circo=$id_circo AND partages.id_seance=seances.id_seance AND seances.id_anim=animations.id_anim AND animations.id_anim=positions.id_anim AND positions.id_domaine=$id_domaine AND themes.id_theme=positions.id_theme GROUP BY animations.id_anim ORDER BY themes.tri, positions.tri,positions.id_position";
			else		
				$q="SELECT animations.id_anim,positions.id_theme FROM partages, seances, animations, positions, themes WHERE partages.id_circo=$id_circo AND partages.id_seance=seances.id_seance AND seances.id_anim=animations.id_anim AND animations.id_anim=positions.id_anim AND positions.id_domaine=$id_domaine AND themes.id_theme=positions.id_theme GROUP BY animations.id_anim ORDER BY themes.tri, positions.tri,positions.id_position";
		else if ($plan==21) 
			$q="SELECT positions.id_anim,positions.id_theme FROM positions,themes WHERE positions.id_domaine=$id_domaine AND positions.id_theme=themes.id_theme ORDER BY themes.tri,positions.tri,positions.id_position";
		else
			$q='';
		$id_theme_courant=0;
		$id_domaine_courant=0;
		if ($q) {
			$ra=query($q,$h); // toutes les animations partages par la circo en cours 
			
			$nb_rows=@mysqli_num_rows($ra);
			$nb_anim_themes=0;
			$position=0;
			while ($row=@mysqli_fetch_array($ra)) {
				if ($id_domaine!=$id_domaine_courant) {
					++$compte;
					$ancre="<a name=\"domaine$compte\" ></a>";
			
					if ($compte==1) 
						$haut="<a href=\"#haut\"><img src=\"images/fleche_haut2.png\" width=\"11\" height=\"11\" border=\"0\" alt=\"haut\" /></a>";
					else
						$haut=sprintf("<a href=\"#domaine%s\"><img src=\"images/fleche_haut2.png\" width=\"11\" height=\"11\" border=\"0\" alt=\"haut\"/></a>",$compte-1);
					$bas=sprintf("<a href=\"#domaine%s\"><img src=\"images/fleche_bas2.png\" width=\"11\" height=\"11\"  border=\"0\" alt=\"bas\" /></a>",$compte+1);
	
					printf("$ancre<h2>%s<span class=\"droite\">$haut$bas</span></h2>\n",htmlentities($domaine['libelle'],ENT_COMPAT,'ISO-8859-15'));
					$id_domaine_courant=$id_domaine;
					$position=0;
					$nb_anim_themes=0;
				}
				if ($row['id_theme']!=$id_theme_courant) {
					$id_theme_courant=$row['id_theme'];
					$libelle_theme=htmlentities(queryValue("SELECT libelle FROM themes WHERE id_theme=$id_theme_courant",$h),ENT_COMPAT,'ISO-8859-15');
					if ($plan==21) {
						if ($libelle_theme=='-') $libelle_theme='[th&egrave;me invisible]';
						if (!$url) print "<h3><a name=\"theme$numtheme\"></a><a href=\"adm_organise_themes.php?id_theme=$id_theme_courant&amp;id_domaine=$id_domaine_courant&amp;ancre=theme$numtheme\">$libelle_theme</a></h3>\n";
						else { 
							print "<h3><a name=\"theme$numtheme\"></a><a href=\"adm_organise_themes.php?id_theme=$id_theme_courant&amp;id_domaine=$id_domaine_courant&amp;ancre=theme$numtheme&amp;url_ret=$url\">$libelle_theme</a></h3>\n";
						}
						++$numtheme;
					}
					else
						if ($libelle_theme!='-') print "<h3>$libelle_theme</h3>\n";
					$position=0;
				}
				if ($plan==3||$plan==11||$plan==12||$plan==13||$plan==16||$plan==23||$plan==25||$plan==26||$plan==27||$plan==28) {
					print "<table class=\"invisible\"><tr><td>\n";
					afficheUneAnimation($row['id_anim'],$h,$impair,$url,$plan,$id_stagiaire,$id_groupe,$test_date,$date,$id_liste);
					print "</td><td><input type=\"submit\" name=\"valider\" value=\"1\" class=\"bouton_enregistre\" /></td></tr></table>\n";
				}
				else
					afficheUneAnimation($row['id_anim'],$h,$impair,$url,$plan,$id_stagiaire,$id_groupe,$test_date,$date,$id_liste);
					
				++$position;
			}
		}
	}
	if ($plan==4) {
		print '<div align="center"><p><input name="valider" type="submit" class="bouton_standard"  value="Valider mes choix" /></p></div>';
		print"\n";	
	}
	++$compte;
	print "<a name=\"domaine$compte\" />";
}
function affichePlanDate($id_circo,$h,$id_groupe,$annee,$url,$plan)
{
	if ($plan==17) 
		 $q="SELECT DISTINCT animations.id_anim, CASE WHEN dates.date='0000-00-00' THEN '9999-12-31' ELSE dates.date END AS date FROM animations,positions, seances, dates, domaines,themes WHERE domaines.id_circo=$id_circo AND domaines.annee=$annee AND positions.id_domaine=domaines.id_domaine AND themes.id_theme=positions.id_theme AND positions.id_anim=animations.id_anim AND animations.id_circo=$id_circo AND seances.id_anim=animations.id_anim AND dates.id_seance=seances.id_seance ORDER BY date ASC, domaines.tri ASC, themes.tri ASC";
	else if ($plan==18)
		$q="SELECT DISTINCT positions.id_anim, CASE WHEN dates.date='0000-00-00' THEN '9999-12-31' ELSE dates.date END AS date FROM partages, dates,seances,positions,domaines WHERE partages.id_circo=$id_circo AND partages.accepte<>0 AND partages.id_seance=seances.id_seance AND dates.id_seance=seances.id_seance AND positions.id_anim=seances.id_anim AND domaines.id_domaine=positions.id_domaine AND domaines.annee=$annee AND domaines.id_circo=$id_circo ORDER BY date ASC" ;
	else $q='';
	$r=query($q,$h);
	$date_prec='';
	$impair=0;
	$plan_anim=0;
	if ($plan==18) $plan_anim=2;
	
	while ($row=@mysqli_fetch_array($r)) {
		$id_anim=$row['id_anim'];
		$date=$row['date'];
		$date1=dateSQLEnTexte($date);
		if ($date!=$date_prec) {
			if ($plan==17) $q="SELECT COUNT(DISTINCT positions.id_anim) FROM domaines,positions, seances,dates WHERE domaines.annee=$annee AND domaines.id_circo=$id_circo AND positions.id_domaine=domaines.id_domaine AND positions.id_anim=seances.id_anim AND dates.id_seance=seances.id_seance ";
			
			else if ($plan==18) $q="SELECT COUNT(DISTINCT positions.id_anim) FROM partages, dates,seances,positions,domaines WHERE partages.id_circo=$id_circo AND partages.accepte<>0 AND partages.id_seance=seances.id_seance AND positions.id_anim=seances.id_anim AND positions.id_domaine=domaines.id_domaine AND domaines.annee=$annee AND dates.id_seance=seances.id_seance ";
			if ($date=='9999-12-31'||$date=='0000-00-00') $q.="AND (dates.date='9999-12-31' OR dates.date='0000-00-00')";
			else $q.="AND dates.date='$date'"; 
			
			$nb=queryValue($q,$h);
			print "<h2>$date1 ($nb animation";
			if ($nb>1) print "s";
			print ")</h2>\n";
			$date_prec=$date;
		}
		afficheUneAnimation($id_anim,$h,$impair,$url,$plan_anim,0,$id_groupe,3,$row['date'],0);
	
	}

}



/*
	AfficheUneFois
	n'affiche qu'une fois le texte pour une sance donne.
	$texte contient la suite  mettre aprs la balise <td... QUI EST OUVERTE. Il faut donc que $texte REFERME la balise <td...
	Exemple: class="qqchose">blablabla
	Le sous-programme rajoute </td>\n 
*/

function afficheUneFois($id_seance,$nb_dates,$texte1='',$texte2='',$texte3='')
{
	static $id_seance_prec=0;
	if ($id_seance==$id_seance_prec) return;
	$id_seance_prec=$id_seance;
	if ($nb_dates<=1) 
		$deb="<td ";
	else
		$deb="<td rowspan=\"$nb_dates\" ";
	if (!$texte1) 
		$texte1='>&nbsp;';
	print "$deb$texte1</td>\n";
	if ($texte2) 	print "$deb$texte2</td>\n";
	if ($texte3)  print "$deb$texte3</td>\n";
}

/* 
	Fonction de formatage d'une liste d'intervenants
	Circon'script PHP Script

*/

function intervenants($id_intervenants,$h)
{
	$id=implode(',',$id_intervenants);
	$r=query("SELECT civilite, nom, prenom, fonction FROM intervenants WHERE id_intervenant in ($id) ORDER BY nom ASC",$h);
	$int='';
	while ($row=@mysqli_fetch_row($r)) {
		$s='';
		$civ=$row[0];
		$nom=$row[1];
		$prenom=$row[2];
		$fonction=$row[3];
		if ($nom && $prenom) $s="$prenom $nom";
		else if ($nom) {
			if($civ==0) $s="M $nom";
			else if ($civ==1) $s.="Mme $nom";
			else $s=$nom;
		}
		if ($s && $fonction) $s.=" ($fonction)";
		if ($s) {
			if ($int) $int.=', ';
			$int.=$s;
		}
	}
	return $int;
}
/*	AfficherParDate
	Affichage du plan de formation d'un stagiaire
	$plan=1: affichage  partir des inscriptions
	$plan==2: affichage  partir des convocations (et signalement des absences)
	$plan==3: affichage  partir des absences
*/	
function afficherParDate($plan,$id_stagiaire,$h)
{
	if ($plan==1) $q="SELECT animations.intitule, animations.description, animations.remarque as anim_remarque,seances.public, CASE WHEN dates.date='0000-00-00' THEN '9999-12-31' ELSE dates.date END AS date,dates.lieu,dates.remarque as dates_remarque,dates.duree, dates.id_date, dates.horaire FROM animations,seances,dates,inscriptions WHERE inscriptions.id_stagiaire=$id_stagiaire AND seances.id_seance=inscriptions.id_seance AND seances.id_anim = animations.id_anim AND dates.id_seance=seances.id_seance ORDER BY date ASC";
	else if ($plan==2) $q="SELECT animations.intitule, animations.description, animations.remarque as anim_remarque,seances.public, CASE WHEN dates.date='0000-00-00' THEN '9999-12-31' ELSE dates.date END AS date,dates.lieu,dates.remarque as dates_remarque,dates.duree, dates.id_date, dates.horaire FROM animations,seances,dates,convocations WHERE convocations.id_stagiaire=$id_stagiaire AND seances.id_seance=convocations.id_seance AND seances.id_anim = animations.id_anim AND dates.id_seance=seances.id_seance ORDER BY date ASC";
	else if ($plan==3) 	$q="SELECT animations.intitule, animations.description, animations.remarque as anim_remarque,seances.public, CASE WHEN dates.date='0000-00-00' THEN '9999-12-31' ELSE dates.date END AS date,dates.lieu,dates.remarque as dates_remarque,dates.duree, dates.id_date, dates.horaire, absences.excuse FROM animations,seances,dates,absences WHERE absences.id_stagiaire=$id_stagiaire AND absences.id_date=dates.id_date AND dates.id_seance=seances.id_seance AND seances.id_anim = animations.id_anim AND dates.id_seance=seances.id_seance ORDER BY date ASC";
	else return;
	
	$r=query($q,$h);
	print "<table>\n";
	print "<tr class=\"table_entete\">\n";
	print "<td>Date</td>\n";
	print "<td>Lieu &amp; public</td>\n";
	print "<td>Animation</td>\n";
	print "</tr>\n";
	$count=1;	
	$date_prec='';
	$horaire_prec='';
	$duree_prec='';
	while ($row=@mysqli_fetch_array($r)) {
		$id_date=$row['id_date'];
		$r2=query("SELECT id_intervenant FROM interventions WHERE id_date=$id_date",$h);
		$int=array();
		while ($row2=@mysqli_fetch_row($r2)) $int[]=$row2[0];
		$intervenants=intervenants($int,$h);
		print "<tr class=\"ligne_bas\">\n";
		//date et remarque ventuelle
		print "<td class=\"survol\">";
		if ( ($plan==1 || $plan==2) && $date_prec==$row['date'] && $date_prec<'9999-12-30' && $date_prec!='0000-00-00') {
			if (intersectionHoraires($row['date'],$row['horaire'],$row['duree'],$date_prec,$horaire_prec,$duree_prec))
				print "<p class=\"erreur\">Attention: se chevauche avec l'animation pr&eacute;c&eacute;dente !</p>\n";
		}
		$date_prec=$row['date'];
		$horaire_prec=$row['horaire'];
		$duree_prec=$row['duree'];
		$id_abs=0;
		if ($plan==2||$plan==3)  $id_abs=queryValue("SELECT id_abs FROM absences WHERE id_stagiaire=$id_stagiaire AND id_date=$id_date",$h);
		$absent='';
		if ($id_abs>0) $absent=queryValue("SELECT excuse FROM absences WHERE id_abs=$id_abs",$h)==0?'<b>Absent(e)</b> - ':'<b>Excus&eacute;(e)</b> - ';
		$horaire=horaireSqlEnHeure($row['horaire']);
		if ($row['date']<'9999-12-30')
			if ($horaire)
				printf("<p>%d: %s%s &agrave; %s (dur&eacute;e %s)</p>\n", $count,$absent, dateSQLEnTexte($row['date']),$horaire,reelEnHeure($row['duree']));
			else 
				printf("<p>%d: %s%s (dur&eacute;e %s)</p>\n", $count,$absent, dateSQLEnTexte($row['date']),reelEnHeure($row['duree']));
		else // FOAD ou  dfinir
			printf("<p>%d: %s%s (dur&eacute;e %s)</p>\n",$count,$absent,dateSQLEnTexte($row['date']),reelEnHeure($row['duree']));
		if ($row['dates_remarque'])
			printf("<p class=\"remarque\">%s</p>\n",htmlentities($row['dates_remarque'],ENT_COMPAT,'ISO-8859-15'));
		print "</td>\n";
		//lieu
		print "<td class=\"survol\">";
		$lieu=htmlentities($row['lieu'],ENT_COMPAT,'ISO-8859-15');
		if ($row['date']!='9999-12-30' && $lieu=='') $lieu='&agrave; d&eacute;finir';
		if ($lieu && $row['public']) 
			printf("<p>%s (%s)</p>\n",$lieu,htmlentities($row['public'],ENT_COMPAT,'ISO-8859-15'));
		else  if ($row['public'])
			printf("<p>%s</p>\n",htmlentities($row['public'],ENT_COMPAT,'ISO-8859-15'));
		else if ($lieu) 
			printf("<p>%s</p>\n",$lieu);
		else print '<p>&nbsp;</p>';
		print "</td>\n";
		// animation et tous paramtres
		print "<td class=\"survol\">";
		printf("<h5>%s</h5>\n",lierPonctuation(htmlentities($row['intitule'],ENT_COMPAT,'ISO-8859-15')));		
			//intervenant:
		
		if ($intervenants) {
			if (count($int)>1)
				printf("<p class=\"remarque\">Intervenants : %s</p>\n",htmlentities($intervenants,ENT_COMPAT,'ISO-8859-15'));
			else
				printf("<p class=\"remarque\">Intervenant : %s</p>\n",htmlentities($intervenants,ENT_COMPAT,'ISO-8859-15'));
			
		}
		if ($row['description'])
			printf("<p>%s</p>\n",htmlentities($row['description'],ENT_COMPAT,'ISO-8859-15'));
		if ($row['anim_remarque'])
			printf("<p class=\"remarque\">%s</p>\n",htmlentities($row['anim_remarque'],ENT_COMPAT,'ISO-8859-15'));
		print "</td>\n";
		print "</tr>\n";
		++$count;
	}
	
	print "</table>\n";
}
function afficherLienExterne($id_circo,$annee,$h)
{
	$r=query("SELECT lien_externe$annee, legende_lien_externe$annee FROM circos WHERE id_circo=$id_circo",$h);
	if (!$r) return;
	$row=@mysqli_fetch_row($r);
	$lien=htmlentities($row[0],ENT_COMPAT,'ISO-8859-15');
	if (!$lien) return;
	$unlien="<a href=\"javascript:ouvreLien('$lien')\" title=\"Lien externe vers des informations. S'ouvre dans une nouvelle fen&ecirc;tre.\"><img src=\"images/lien_externe.png\" alt=\"lien externe\" width=\"16\" height=\"16\" />";
	$legende=htmlentities($row[1],ENT_COMPAT,'ISO-8859-15');
	if (!$legende) $legende=htmlentities("Lien externe vers des informations complmentaires.",ENT_COMPAT,'ISO-8859-15');
	$legende.='</a>';
	print "<div class=\"alaffiche\"><h2>Information</h2>\n<p>$unlien&nbsp;$legende</p></div>\n";
}
function lierPonctuation($texte)
{
	return str_replace(array(' !',' ?',' :'),array('&nbsp;!','&nbsp;?','&nbsp;:'),$texte); 
}
// renvoie true si les convocations sont autorises pour une sance donne; attention, la sance entre doit avoir un nombre de places plafonn
function autoriserConvocPlafond($id_seance,$h)
{
	// trouve le nombre de circos ayant import l'animation qui est encore en mode 'inscription'
	$etat_circos=queryValue("SELECT COUNT(*) FROM partages,circos WHERE partages.id_seance=$id_seance AND partages.accepte<>0 AND partages.id_circo=circos.id_circo AND circos.stag_etat=1",$h); 
	return $etat_circos==0; // renvoie true si aucune circo n'est plus en mode "inscription".
}
?>