<?php
/* 
	Cration d'un calendrier ICAL
	ce fichier ne ncessite ni _sqlconnect.inc, ni _fonctions.inc
	Circon'script PHP Script
	Version 7.0.3 
	CeCILL Copyright (C) 2008 Thierry Gangloff
	e-mail: thierry.gangloff@ac-strasbourg.fr
*/

 
 class MyEvent 
 {
	const DT_FORMAT = 'Ymd\THis\Z';
	protected $UTC,$ici;
	protected $dtStart,$dtEnd;
	protected $props=array();
	protected $littProps=array('summary','description','location','uid','comment');
	public function __construct() {
		global $timezone;
		$this->UTC= new DateTimeZone('UTC');
		$this->ici= new DateTimeZone($timezone);
	}
	
	protected function escape_string($str) {
		$str=str_replace(array("\\","\r"),'',$str);// prcaution, gomme \r et surtout tous les slashes 
		$str=str_replace("\n",'\\n',$str);
		$str=preg_replace("/\s+/", ' ', $str);
		return iconv("ISO-8859-15","UTF-8",trim(preg_replace('/([\,;])/','\\\$1', $str)));
	}
	protected function ical_split($preamble, $value) {
	  $value=$this->escape_string($value);	
	  $preamble_len = strlen($preamble);
	  $lines = array();
	  while (strlen($value)>(75-$preamble_len)) {
		$space = (75-$preamble_len);
		$mbcc = $space;
		while ($mbcc) {
		  $line = mb_substr($value, 0, $mbcc,'UTF-8');
		  $oct = strlen($line);
		  if ($oct > $space) {
			$mbcc -= $oct-$space;
		  }
		  else {
			if ($oct>0 && $line[$oct-1]=="\\") {
				--$mbcc;
			}
			else {
				$lines[] = $line;
				$preamble_len = 1; // Still take the tab into account
				$value = mb_substr($value, $mbcc,mb_strlen($value,'UTF-8'),'UTF-8');
				break;
			}
		  }
		}
	  }
	  if (!empty($value)) {
		$lines[] = $value;
	  }
	  return join($lines, "\r\n\t");
	}	
	
	public function setDates( $strDate,$strHoraire,$dblDuree)
	{
		global $timezone;
		$dblDuree=doubleVal($dblDuree);
		$dtStart=new DateTime($strDate.' '.$strHoraire,$this->ici);
		$dtStart->setTimezone($this->UTC);
		$heures=intval($dblDuree);
		$minutes=round(($dblDuree-$heures)*60,0);
		$strIntervalle='PT';
		if ($heures>0) $strIntervalle.=$heures.'H';
		if ($minutes>0) $strIntervalle.=$minutes.'M';
		$dtEnd= clone $dtStart;
		$dtEnd->add(new DateInterval($strIntervalle));
		$this->props["DTSTART"]=$dtStart->format(self::DT_FORMAT);
		$this->props["DTEND"]=$dtEnd->format(self::DT_FORMAT);
	}
	public function setLastModified($timestamp)
	{
		$dt= new DateTime($timestamp,$this->ici );
		$dt->setTimezone($this->UTC);
		$this->props['DTSTAMP']=$dt->format(self::DT_FORMAT);
	}
	public function setText($preambule,$texte)
	{
		if (in_array($preambule,$this->littProps)) $this->props[strtoupper($preambule)]=$this->ical_split(strtoupper($preambule).':',$texte);
	}
	public function exporter()
	{
		$exp="BEGIN:VEVENT\r\n";
		foreach($this->props as $k=>$v) 
			$exp.="$k:$v\r\n";
		$exp.="END:VEVENT\r\n";
		return $exp;
	}
 }
 class MyICS
 {
	protected $events=array();
	public function __construct() {
	}
	public function addEvent($e)
	{
		$this->events[]=$e;
	}
	public function exporter()
	{
		global $timezone;
		$domaine=isset($_SERVER['HTTP_HOST'])?$_SERVER['HTTP_HOST']:'';
		if (!$domaine) $domaine="Circonscript";
		$exp="BEGIN:VCALENDAR\r\n";
		$exp.="VERSION:2.0\r\n";
		$exp.="CALSCALE:GREGORIAN\r\n";
		$exp.="PRODID:-//$domaine//Circonscript//FR\r\n";
		foreach ($this->events as $e) $exp.=$e->exporter();
		$exp.="END:VCALENDAR\r\n";
		return $exp;
	}
 }
 function exporterICALIntervenant($h)
{
	global $id_intervenant,$url_site;
	$q="SELECT NOW() AS dt_modif, interventions.id_date, dates.date, dates.lieu, dates.horaire,dates.duree, dates.remarque as date_remarque, animations.intitule, animations.description, dates.remarque, seances.public, animations.remarque as anim_remarque, seances.id_seance FROM (interventions, dates, seances, animations, positions,domaines, circos) 
	WHERE interventions.id_intervenant=$id_intervenant AND interventions.id_date=dates.id_date AND dates.date <'9999-12-30' AND dates.id_seance=seances.id_seance AND seances.id_anim=animations.id_anim AND animations.annule=0 AND positions.id_anim=animations.id_anim AND positions.id_domaine= domaines.id_domaine AND domaines.id_circo=circos.id_circo AND animations.id_circo=domaines.id_circo AND domaines.annee=0 ORDER BY dates.date ASC, dates.horaire ASC";
	if ($url_site=='') {
		$domaine=$_SERVER['HTTP_HOST'];
		$path=$_SERVER['SCRIPT_NAME'];
		$t=explode('/',$path);
		if (sizeof($t)>1) {
			unset($t[sizeof($t)-1]);
			$path=implode('/',$t);
		}
		else $path='';
		$http='http';
		if (isset($_SERVER['HTTPS']) && $_SERVER['HTTPS']=='on') $http='https';
		$site="$http://$domaine$path";
	}
	else $site=$url_site;
	$r=@mysqli_query($h,$q);
	if (!$r) return '';
	if (@mysqli_num_rows($r)==0) return'';
	$ics=new MyICS();
	while ($row=@mysqli_fetch_array($r)) {
		$id_date=$row['id_date'];
		$id_seance=$row['id_seance'];
		$e=new MyEvent;
		$e->setText('uid',"Circoncript$id_date@$site");
		$titre=$row['intitule'];
		@mysqli_query($h,"SET @k:=0");
		$r2=@mysqli_query($h,"SELECT rang, @k as nb FROM 
		( SELECT @k:=@k+1 as rang, dates.id_date FROM dates,interventions WHERE dates.id_seance=$id_seance AND dates.date<'9999-12-30' AND dates.id_date=interventions.id_date AND interventions.id_intervenant=$id_intervenant ORDER BY dates.date ASC, dates.horaire ASC) AS t WHERE t.id_date=$id_date;");
		$num=$nbDates=1;
		$row2=@mysqli_fetch_row($r2);
		if (isset($row2)) {
			$num=$row2[0];
			$nbDates=$row2[1];
		}
		if($nbDates>1) $titre.=" ($num/$nbDates)";
		$e->setText('summary',$titre); 
		$descr=$row['description'];
		if ($row['anim_remarque']) {
			if ($descr) $descr.="\r\n";
			$descr.=$row['anim_remarque'];
		}
		if ($row['public']) {
			if ($descr) $descr.="\r\n";
			$descr.="Public : ".$row['public'];
		}
		if ($row['remarque']) {
			if ($descr) $descr.="\r\n";
			$descr.="Remarque : ".$row['remarque'];
		}
		$int=listeIntervenants("SELECT civilite, nom, prenom, fonction FROM intervenants, interventions WHERE interventions.id_date=$id_date AND interventions.id_intervenant=intervenants.id_intervenant AND intervenants.id_intervenant<>$id_intervenant ORDER BY nom ASC",$h);
		if ($int) {
			if ($descr) $descr.="\r\n";
			$descr.="Co-intervenant(s) : ".$int;
		}
		$r1=@mysqli_query($h, "SELECT COUNT(*) FROM inscriptions WHERE id_seance=$id_seance");
		$row1=@mysqli_fetch_row($r1);
		$nb_inscr=$row1[0];
		$r1=@mysqli_query($h, "SELECT COUNT(*) FROM convocations WHERE id_seance=$id_seance");
		$row1=@mysqli_fetch_row($r1);
		$nb_conv=$row1[0];
		if ($descr) $descr.="\r\n";
		$descr.="Nb. inscrits: $nb_inscr\r\nNb. convoqus: $nb_conv";
		$e->setText('description',$descr);
		$e->setText('location',$row['lieu']);
		$e->setDates($row['date'],$row['horaire'],$row['duree']);
		$e->setLastModified($row['dt_modif']);
		$ics->addEvent($e);
	}
	return $ics->exporter();
}
function listeIntervenants($q,$h)
{
	$r=@mysqli_query($h,$q);
	$int='';
	while ($row=@mysqli_fetch_row($r)) {
		$s='';
		$civ=$row[0];
		$nom=$row[1];
		$prenom=$row[2];
		$fonction=$row[3];
		if ($nom && $prenom) $s.="$prenom $nom";
		else if ($nom) {
			if($civ==0) $s.="M $nom";
			else if ($civ==1) $s.="Mme $nom";
			else $s.=$nom;
		}
		if ($s && $fonction) $s.=" ($fonction)";
		if ($s) {
			if ($int) $int.=', ';
			$int.=$s;
		}
	}
	return $int?$int.'.':'';
}
?>