<?php
/* 
	Connexions et accs  la base de donnes, dbuggage	
	Circon'script PHP Script
	Version 7.0.3
	CeCILL Copyright (C) 2008 Thierry Gangloff
	e-mail: thierry.gangloff@ac-strasbourg.fr
*/


function connect()
{
	global $host,$user,$password,$bdd,$erreur;
	srand((float)microtime()*1000000);
	$h= @mysqli_connect($host,$user,$password);
	if (!$h) {
		header( 'Location: erreur.php?erreur=bdd1');
		exit;
	}
	if (!@mysqli_select_db($h,$bdd)) {
		header( 'Location: erreur.php?erreur=bdd2');
	   exit;
	}
	@mysqli_set_charset($h,'latin1');
	return $h;
}
function myEscapeString($h,$esc)
{
	return @mysqli_real_escape_string($h,$esc);
}
/*
Si le site est ferm, et que nous ne sommes pas admin, retour a la page d'accueil et suppression de toutes les sessions.
Si le site est ouvert, vrifie que id_uti existe toujours (car il peut tre dtruit par l'administrateur  tout moment)
*/
function ejecteSiFerme($h)
{
	if (isset($_SESSION['circonscript7_administration'])) return;
	$ferme=false;
	$r=@mysqli_query($h,"SELECT ferme FROM general");
	if ($r) {
		$row=@mysqli_fetch_row($r);
		if ($row[0]==1) $ferme=true;
	}
	if ($ferme) {
		detruireSession();
		header('Location: erreur.php?erreur=acces_site');
		exit;	
	}
	if (isset($_SESSION['circonscript7_id_uti'])) {
		$id_uti=$_SESSION['circonscript7_id_uti'];
		$n=queryValue("SELECT COUNT(*) FROM utilisateurs WHERE id_uti=$id_uti",$h);
		if (!$n) {
			detruireSession();
			header('Location: erreur.php?erreur=utilisateur');
			exit;	
		}
	}
}
function detruireSession()
{
	foreach($_SESSION as $k=>$v) {
		$_SESSION[$k]='';
		unset($_SESSION[$k]);
	}
	
	$_SESSION = array();
	if (ini_get("session.use_cookies")) {
		$params = session_get_cookie_params();
		setcookie(session_name(), '', time() - 42000,
		$params["path"], $params["domain"],
        $params["secure"], $params["httponly"]);
	}
	session_destroy();

}
function detruireVariablesSession()
{
	$garder=array('circonscript7_id_circo','circonscript7_administration','circonscript7_id_uti','circonscript7_id_admin','circonscript7_compte_dtconnexion','circonscript7_sso');
	foreach($_SESSION as $k=>$v) 
		if (!in_array($k,$garder)) unset($_SESSION[$k]);
}

/* query
	Effectue @mysqli_query
	Stocke l'erreur dans la variable globale $Erreur
*/
function query($q,$h)
{
	global $erreur;
	$b=@mysqli_query($h,$q);
	if (!$b) $erreur.=@mysqli_error($h);
	debug($q);
	if ($erreur) debug($erreur);
	return $b;
}
function queryRow($q,$h)
{
	$b=query($q,$h);
	if( !$b) return array();
	return @mysqli_fetch_row($b);
}
function queryArray($q,$h)
{
	$b=query($q,$h);
	if( !$b) return array();
	return @mysqli_fetch_array($b);
}
function queryValue($q,$h)
{
	$b=query($q,$h);
	if( !$b) return '';
	$row=@mysqli_fetch_row($b);
	return $row[0];
}

function normalise($s)
{
	if (!isset($s)) return '';
	return trim(str_replace("\\",'',$s));
	//return trim(stripslashes($s)); //stripslashes laisse traner des doubles slashes : "\\"
}
//test htmlentities( ( ) ())

function normaliseT($s,$t)
{
	$x=normalise($s);
	if (strlen($x)>$t) return substr($x,0,$t);
	else return $x;
}
function debug($s)
{
	global $debug;
	if (!$debug) return;	
	$f=fopen("debug.txt","a");
	fputs($f,$s);
	fputs($f,"\r\n");
	fclose($f);

}
function debugInit()
{
	global $debug;
	if (!$debug) return;	
	$f=fopen("debug.txt","w");
	fclose($f);
}
function debugArray($arr, $name)
{
	global $debug;
	if (!$debug) return;	
	$f=fopen("debug.txt","a");
	if (!isset($arr)) fputs($f,"$name n'est pas mis\r\n");
	else if (!is_array($arr)) fputs($f,"$name n'est pas un tableau\r\n");
	else if (sizeof($arr)==0) fputs($f,"$name est vide\r\n");
	else foreach($arr as $k=>$v) {
		fputs($f,sprintf("%s[%s]='%s'\r\n",$name,$k,$v ));
	}
	fclose($f);

}

//renvoie nombre dcimal avec 2 dcimes

function decimal($n)
{
	if ($n=='') return '';
	$n=str_replace(',','.',$n); // transforme virgule ',' en '.'
	return sprintf("%.2f",$n);

}
// Version: renvoie la version de MySQL dans un double (majeur.mineur)
function version($h)
{
	$vers=queryValue("SELECT VERSION()",$h);
	$t=explode('.',$vers);
	return doubleval($t[0].'.'.$t[1]);	
}

// pour les recherches avec LIKE, escape aussi les signes % et _.
function myLikeEscapeString($h,$w)
{
	return addcslashes(myEscapeString($h,$w),'%_');
}	
?>