<?php
/* 
	Exportation des absences	
	Circon'script PHP Script
	Version 7.0.3
	CeCILL Copyright (C) 2008 Thierry Gangloff
	e-mail: thierry.gangloff@ac-strasbourg.fr
*/

	require('_session.php');
	if (isset($_GET['url_ret'])) {
		$url_ret_adm_absences_export=strip_tags($_GET['url_ret']);
		$_SESSION['circonscript7_url_ret_adm_absences_export']=$url_ret_adm_absences_export;
	}
	else if (isset($_SESSION['circonscript7_url_ret_adm_absences_export'])) {
		$url_ret_adm_absences_export=$_SESSION['circonscript7_url_ret_adm_absences_export'];
	}
	else $url_ret_adm_absences_export="adm_absences.php";
	
	$erreur='';
	require '_sqlconnect.inc.php';
	require '_fonctions.inc.php';
	require '_fonctions_animation.inc.php';
	if (!isset($_SESSION['circonscript7_id_circo'])) {
		header( 'Location: erreur.php?erreur=expiree');
		exit;
	}		
	$id_circo=$_SESSION['circonscript7_id_circo'];
	
	debugInit();
	$h=connect();
	ejecteSiFerme($h);
	$id_anim=0;
	if (isset($_SESSION['circonscript7_adm_absences_export_date_sql'])) 
		$adm_absences_export_date_sql=$_SESSION['circonscript7_adm_absences_export_date_sql'];
	else 
		$adm_absences_export_date_sql='';
	if (isset($_POST['cbDate'])) {
		$adm_absences_export_date_sql=normalise($_POST['cbDate']);
		$_SESSION['circonscript7_adm_absences_export_date_sql']=$adm_absences_export_date_sql;
		$id_anim=0;
		while ($adm_absences_export_date_sql!='') {
			$q="SELECT seances.id_anim FROM partages, seances,  dates WHERE partages.accepte<>0 AND partages.id_circo=$id_circo AND partages.id_seance=seances.id_seance AND dates.date='$adm_absences_export_date_sql' AND dates.id_seance=seances.id_seance
		GROUP BY seances.id_anim";
			$r=query($q,$h);
			$nb_rows=@mysqli_num_rows($r);
			if ($nb_rows!=1) break;
			$row=@mysqli_fetch_row($r);
			$id_anim=$row[0];
			break;
		}
	}
	if (isset($_POST['export_inscr'])) {
		if (isset($_POST['animations'])) $id_anim=abs(intval($_POST['animations']));
		exportInscriptions($h,$id_anim);	
	
	
	}
	else 	if (isset($_POST['export_conv'])) {
		if (isset($_POST['animations'])) $id_anim=abs(intval($_POST['animations']));
		exportConvocations($h,$id_anim,$adm_absences_export_date_sql);	
	}
 
function exportConvocations($h,$id_anim,$date_sql)
{
	global $erreur,$id_circo;
	while (!$erreur) {
		$file=tempnam("./temp","csv");		
		if (!$file) {
			$erreur="Impossible de crer un nom de fichier temporaire.";
			break;
		}
		$fp=fopen($file,'w');
		if (!$fp) {
			$erreur="Impossible de crer un fichier temporaire.";
			break;
		}
		$q="SELECT stagiaires.nom, prenom,stagiaires.courriel,niveau,quotite,stagiaires.quota_reel as quota,ecoles.nom as ecole, circos.libelle_court as circo, animations.intitule as animation, categories.codage, dates.date as date_seance, dates.duree, CASE WHEN absences.id_abs IS NULL THEN 0 ELSE 1 END as absence, groupes.libelle as groupe, dates.horaire, CASE WHEN absences.id_abs IS NULL THEN 0 ELSE absences.excuse END as excuse		
		FROM (stagiaires, ecoles,positions,domaines,seances,dates,convocations,circos,partages,animations)
		LEFT JOIN absences ON absences.id_stagiaire=stagiaires.id_stagiaire AND absences.id_date=dates.id_date
		LEFT JOIN groupes ON groupes.id_groupe=stagiaires.id_groupe
		LEFT JOIN categories ON categories.id_categorie=animations.id_categorie 
		WHERE partages.id_circo=$id_circo AND partages.accepte<>0 AND partages.id_seance=seances.id_seance AND stagiaires.id_ecole=ecoles.id_ecole AND ecoles.id_circo=circos.id_circo AND convocations.id_stagiaire=stagiaires.id_stagiaire AND convocations.id_seance=seances.id_seance AND positions.id_anim=seances.id_anim AND dates.id_seance=seances.id_seance AND domaines.id_domaine=positions.id_domaine AND domaines.annee=0 AND domaines.id_circo=$id_circo";
		if ($id_anim>0) $q.=" AND positions.id_anim=$id_anim";
		if ($date_sql!='') $q.= " AND dates.date='$date_sql'";
  		$q.=" AND positions.id_anim=animations.id_anim";
		$q.=" ORDER BY stagiaires.nom, dates.tri";
		$r=query($q,$h);
		exporte($fp,$r,$h);
		fclose($fp);
		exportFichier($file,"Absences_");
		exit;
	}		
}

function exporte($fp,$r,$h)
{
	global $erreur,$id_circo;
	$nb_groupes=queryValue("SELECT COUNT(*) FROM groupes WHERE id_circo=$id_circo",$h);
	
	fputs($fp,'"nom";"prnom";"courriel_stag";"niveau";');
	if ($nb_groupes>0) fputs($fp,'"groupe";');
	fputs($fp,'"quotit";"quota";"cole";"circo";"animation";"catgorie";"date_sance";"dure";"horaire";"absences"');		
	fputs($fp,"\n");

//	fputs($fp,'"nom";"prnom";"courriel_stag";"niveau";"quotit";"quota";"cole";"circo";"animation";"date_sance";"dure";"absences"');		
//	fputs($fp,"\n");
	while ($row=@mysqli_fetch_array($r)) {
		$nom='"'.$row['nom'].'"';
		$prenom='"'.$row['prenom'].'"';
		$courriel='"'.$row['courriel'].'"';
		$niveau='"'.$row['niveau'].'"';
		$quotite='"'.str_replace('.',',',$row['quotite']).'"';
		$quota='"'.str_replace('.',',',$row['quota']).'"';
		$groupe='"'.str_replace('"','""',$row['groupe']).'"';
		$ecole='"'.$row['ecole'].'"';
		$circo='"'.$row['circo'].'"';
		$animation='"'.str_replace('"','""',$row['animation']).'"';
		$categorie='"'.str_replace('"','""',$row['codage']).'"';
		$date_seance='"'.dateSQLEnSaisie($row['date_seance']).'"';
		$duree='"'.str_replace('.',',',$row['duree']).'"';

		if ($row['horaire']!='00:00:00')
			$horaire='"'.substr($row['horaire'],0,5).'"';
		else $horaire='""';
		$absence='""';
		if ($row['absence']>0) {
			if ($row['excuse']>0) $absence='"excus"';
			else $absence='"absent"';
		}
		fputs($fp,"$nom;$prenom;$courriel;$niveau;");
		if ($nb_groupes>0) fputs($fp,"$groupe;");
		fputs($fp,"$quotite;$quota;$ecole;$circo;$animation;$categorie;$date_seance;$duree;$horaire;$absence\n");
		//fputs($fp,"$nom;$prenom;$courriel;$niveau;$quotite;$quota;$ecole;$circo;$animation;$date_seance;$duree;$absence\n");
	}
	
}

function afficheAnims($h,$id_anim,$date_sql)
{
	global $id_circo;
	if ($date_sql=='')
		$q="SELECT positions.id_anim, animations.intitule FROM partages, seances, positions,domaines,animations WHERE partages.accepte<>0 AND partages.id_circo=$id_circo AND partages.id_seance=seances.id_seance AND seances.id_anim=positions.id_anim AND domaines.id_domaine=positions.id_domaine AND domaines.annee=0 AND domaines.id_circo=$id_circo AND animations.id_anim=positions.id_anim GROUP BY animations.id_anim ORDER BY animations.intitule";
	else
		$q="SELECT animations.id_anim, animations.intitule FROM partages, seances, positions,dates,domaines,animations WHERE partages.accepte<>0 AND partages.id_circo=$id_circo AND partages.id_seance=seances.id_seance AND seances.id_anim=animations.id_anim AND dates.id_seance=seances.id_seance AND dates.date='$date_sql'AND domaines.id_domaine=positions.id_domaine AND domaines.annee=0 AND domaines.id_circo=$id_circo AND animations.id_anim=positions.id_anim GROUP BY animations.id_anim ORDER BY animations.intitule";
	
	
	$r=query($q,$h);
	$nb_anim=@mysqli_num_rows($r);
	if ($nb_anim>1)
		print "<option value=\"0\">Toutes</option>\n";
	
	while ($row=@mysqli_fetch_row($r)) {
		$id_anim_cour=$row[0];
		$intitule=$row[1];
		if (strlen($intitule)>63) $intitule=substr($intitule,0,60).'...';
		$intitule=htmlentities($intitule,ENT_COMPAT,'ISO-8859-15');
		if ($id_anim==$id_anim_cour)
			print "<option value=\"0\" selected=\"selected\">$intitule</option>\n";
		else
			print "<option value=\"$id_anim_cour\">$intitule</option>\n";
	}
}


function afficherDates($h,$date_sql)
{
	global $id_circo;
	$q="SELECT DISTINCT(dates.date) FROM seances,dates,partages, positions,domaines WHERE dates.id_seance=seances.id_seance AND partages.id_circo=$id_circo AND partages.id_seance=seances.id_seance AND partages.accepte<>0 AND dates.date<>'9999-12-31' AND dates.date<>'0000.00.00' AND positions.id_anim=seances.id_anim AND domaines.id_domaine=positions.id_domaine AND domaines.annee=0 AND domaines.id_circo=$id_circo ORDER BY dates.date ASC";
	$r=query($q,$h);
	$ok=false;
	print "<option value=\"\">Toutes</option>\n";
	while ($row=@mysqli_fetch_row($r)) {
		$date=$row[0];
		$sel='';
		if ($date==$date_sql) {
			$ok=true;
			$sel=" selected=\"selected\"";
		}
		printf("<option value=\"$date\"$sel>%s",dateSqlEnSaisie($date));
		print "</option>\n";
	}
	if (!$ok) $sel=" selected=\"selected\"";
	else $sel='';
}	
	 
	 
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="fr" lang="fr">
	<head>
		<title><?php print htmlentities($titre_site,ENT_COMPAT,'ISO-8859-15') ?></title>
		<meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-15" />
		<link rel="stylesheet" href="styles.css" type="text/css" /> <link rel="shortcut icon" type="image/x-icon" href="favicon.ico" /></head>
	<body>
		<div id="conteneur">
			<?php 
				include('menu_principal.inc.php');
			?>
			<div class="menu_secondaire">
				<ul class="menu2">
	  				<li><a href="<?php print $url_ret_adm_absences_export?>">retour</a></li>
	  				<li><a href="#bas">bas</a></li>
				</ul>
			</div>
			<div id="corps">	 
			  <h1>Exportation des convocations et des absences au format csv </h1>
			      <?php if ($erreur) print "<p class=\"erreur\">$erreur</p>";?> 
			    <form method="post" action="">
			      Choix de la date:
			      <select name="cbDate" id="cbDate" onchange="javascript:submit()">
      <?php afficherDates($h,$adm_absences_export_date_sql)?>
			      </select>
		      </form>
		      <form method="post" action="">
			      Animations &agrave; exporter: 
			      <select name="animations" id="animations">
                        <?php afficheAnims($h,$id_anim,$adm_absences_export_date_sql) ?>
		          </select>
                  <h2>Exporter les convocations avec les absences
                    <input name="export_conv" type="submit" class="bouton_standard" id="export_conv" value="Exporter !" />
                  </h2>
                              <p>Pour chaque stagiaire <em>(de la circo ou ext&eacute;rieur) </em>, les animations auxquelles il est convoqu&eacute;. Une convocation par ligne. La colonne &quot;absence&quot; rend compte des absences. Elle peut contenir &quot;absent&quot; si le stagiaire est absent non excus&eacute;, ou &quot;excus&eacute;&quot; si le stagiaire a &eacute;t&eacute; absent mais a &eacute;t&eacute; excus&eacute;. </p>
                </form>
		      <h2>&nbsp;</h2>
	      </div>
			<div class="menu_secondaire">
				<ul class="menu2">
	  				<li><a href="<?php print $url_ret_adm_absences_export?>">retour</a></li>
		  			<li><a href="#haut">haut</a></li>
				</ul>
			</div>
			<a name="bas" id="bas"></a>	
		</div>
	</body>
</html>