<?php
/* 
	Exportation des plans de formation au format xml
	Circon'script PHP Script
	Version 7.0.3
	CeCILL Copyright (C) 2012 Thierry Gangloff
	e-mail: thierry.gangloff@ac-strasbourg.fr
*/
	require('_session.php');
	if (isset($_GET['url_ret'])) {
		$url_ret_adm_adm_plan_export_xml=strip_tags($_GET['url_ret']);
		$_SESSION['circonscript7_url_ret_adm_adm_plan_export_xml']=$url_ret_adm_adm_plan_export_xml;
	}
	else if (isset($_SESSION['circonscript7_url_ret_adm_adm_plan_export_xml'])) {
		$url_ret_adm_adm_plan_export_xml=$_SESSION['circonscript7_url_ret_adm_adm_plan_export_xml'];
	}
	else $url_ret_adm_adm_plan_export_xml="administration.php";
	if (!isset($_SESSION['circonscript7_administration'])) {
		header( 'Location: erreur.php?erreur=expiree');
		exit;
	}
	
	$erreur='';
	require '_sqlconnect.inc.php';
	require '_fonctions.inc.php';
	require '_fonctions_animation.inc.php';
	debugInit();
	$h=connect();
	$annee=0;
	$version=1;
	if (isset($_SESSION['adm_adm_plan_export_xml_annee'])) $annee=$_SESSION['adm_adm_plan_export_xml_annee'];
	if (isset($_SESSION['adm_adm_plan_export_xml_version'])) $annee=$_SESSION['adm_adm_plan_export_xml_version'];

	if (isset($_POST['Submit'])) {
		if (isset($_POST['annee'])) {
			$annee=abs(intval($_POST['annee']));
			if ($annee!=0) $annee=1;
		}
		else $annee=0;
		$_SESSION['adm_adm_plan_export_xml_annee']=$annee;
		if (isset($_POST['version'])) {
			$version=abs(intval($_POST['version']));
			if ($version!=1) $version=2;
		}
		else $version=1;
		$_SESSION['adm_adm_plan_export_xml_version']=$version;

		if (isset($_POST['circos'])) while (1) {
			// URL de la dtd
			$domaine=$_SERVER['HTTP_HOST'];
			$path=$_SERVER['SCRIPT_NAME'];
			$t=explode('/',$path);
			if (sizeof($t)>1) {
				unset($t[sizeof($t)-1]);
				$path=implode('/',$t);
			}
			else $path='';
			$http='http';
			if (isset($_SERVER['HTTPS']) && $_SERVER['HTTPS']=='on') $http='https';
			if ($version==1) $url_dtd="$http://$domaine$path/plan.dtd";
			else $url_dtd="$http://$domaine$path/plan2.dtd";
			$implementation= new DOMImplementation();
			$dtd=$implementation->createDocumentType('plan','', $url_dtd);
			
			$dom = $implementation->createDocument('','',$dtd);
			$dom->formatOutput=true;
			$dom->encoding="UTF-8";
			$dom->standalone=true;
			foreach($_POST['circos'] as $id_circo) {
				$id_circo=intval($id_circo);
				if ($version==1) {
					if(!ecrireAnimationsV1($id_circo,$dom,$annee,$h))break;
				}
				else {
					if(!ecrireAnimationsV2($id_circo,$dom,$annee,$h))break;
				
				}				
			}
			//$dom->validateOnParse=true;
			//if (!$dom->validate()) $erreur="Validation DOM incorrecte";
			if ($erreur) break;
			$file=tempnam("./temp","xml");
			if (!$file) {
				$erreur="Impossible de crer un nom de fichier temporaire.";
				break;
			}
			if (!$dom->save($file)){
				$erreur="Impossible de crer le fichier xml dans le dossier temporaire.";
				break;
			}
			$nouvFile="Plans_actuels_";
			if ($annee) $nouvFile="Plans_futurs_";
			exportFichier($file,$nouvFile,"xml");
			exit;
		
		}
		else $erreur="Aucune circo slectionne";
	}
	
	$erreur=htmlentities($erreur,ENT_COMPAT,'ISO-8859-15');

function ecrireAnimationsV1($id_circo,&$dom,$annee,$h)
{
	global $erreur;
	if (!$id_circo ) {
		$erreur="id_circo erron ($id_circo)";
		return false;
	}
	// afficher toutes les animations et leurs exportations.
	$q="SELECT animations.id_anim,categories.codage AS categorie, domaines.libelle as domaine, domaines.id_domaine,intitule, themes.libelle as theme, themes.id_theme, description, animations.remarque, circos.libelle_court, animations.annule  
		FROM (positions, animations, themes, domaines, circos) 
		LEFT JOIN categories ON categories.id_categorie=animations.id_categorie 
		WHERE animations.id_circo=$id_circo AND positions.id_anim=animations.id_anim AND positions.id_domaine=domaines.id_domaine AND domaines.id_circo=$id_circo AND domaines.annee=$annee AND positions.id_theme=themes.id_theme AND animations.id_circo=circos.id_circo
		ORDER BY domaines.tri, themes.tri, positions.tri, animations.intitule ";
	$r=query($q,$h);
	$plan=$dom->createElement("plan");
	while ($row=@mysqli_fetch_array($r)) {
		$id_anim=$row['id_anim'];
		$animation=$dom->createElement("animation");
		$animation->setAttribute("circo",encode($row['libelle_court']));
		$animation->setAttribute("id_anim",$id_anim);	
		$animation->setAttribute("annule",$row['annule']?'oui':'non');		
		$e=$dom->createElement("domaine");
		$t=$dom->createTextNode(encode($row['domaine']));
		$e->setAttribute("id_domaine",$row['id_domaine']);	
		
		$e->appendChild($t);
		$animation->appendChild($e);
		$e=$dom->createElement("theme");
		$t=$dom->createTextNode(encode($row['theme']));
		$e->appendChild($t);
		$e->setAttribute("id_theme",$row['id_theme']);	
		$animation->appendChild($e);
		if ($row['categorie']) {
			$e=$dom->createElement("categorie");
			$t=$dom->createTextNode(encode($row['categorie']));
			$e->appendChild($t);
			$animation->appendChild($e);
		}

		$e=$dom->createElement("intitule");
		$t=$dom->createTextNode(encode($row['intitule']));
		$e->appendChild($t);
		$animation->appendChild($e);

		if ($row['description']) {
			$e=$dom->createElement("description");
			$t=$dom->createTextNode(encode($row['description']));
			$e->appendChild($t);
			$animation->appendChild($e);
		}
		if ($row['remarque']) {
			$e=$dom->createElement("remarque");
			$t=$dom->createTextNode(encode($row['remarque']));
			$e->appendChild($t);
			$animation->appendChild($e);
		}
		$q="SELECT id_seance, max, public, cond FROM seances WHERE id_anim=$id_anim ORDER BY tri";
		$r2=query($q,$h);
		while ($row=@mysqli_fetch_array($r2)) {
			$id_seance=$row['id_seance'];
			$seance= $dom->createElement("seance");
			$seance->setAttribute("id_seance",$id_seance);	
	
			$max=intval($row['max']);
			$cond=intval($row['cond']);
			if ($max>0) {
				$e=$dom->createElement("max");
				$t=$dom->createTextNode($max);
				$e->appendChild($t);
				$seance->appendChild($e);
			}
			if ($row['public']) {
				$e=$dom->createElement("public");
				$t=$dom->createTextNode(encode($row['public']));
				$e->appendChild($t);
				$seance->appendChild($e);
			}
			if ($cond>0) {
				$e=$dom->createElement("condition_ouverture");
				if ($cond==1) $s="max";
				else $s='max-'.($cond-1);
				$t=$dom->createTextNode($s);
				$e->appendChild($t);
				$seance->appendChild($e);
			}
			// ici circos concernes
			$r5=query("SELECT circos.libelle_court FROM partages, circos WHERE partages.id_seance=$id_seance AND partages.id_circo=circos.id_circo ORDER BY circos.libelle_court ASC" ,$h);
			$circ='';
			while ($row=@mysqli_fetch_row($r5)) {
				if ($circ) $circ.=',';
				$circ.=$row[0];
			}
			$e=$dom->createElement("circos_concernees");
			$t=$dom->createTextNode(encode($circ));
			$e->appendChild($t);
			$seance->appendChild($e);
			
			$r3=query("SELECT id_date,date, horaire, lieu, duree, remarque FROM dates WHERE id_seance=$id_seance ORDER BY tri",$h);
			while ($row=@mysqli_fetch_array($r3)) {
				$date=$dom->createElement("date");
				$duree=doubleval($row['duree']);
				$id_date=$row['id_date'];
				$date->setAttribute("id_date",$id_date);				
				if ($row['date'] && $row['date']!='9999-12-31') {
					$e=$dom->createElement("date_seance");
					if( $row['date']=='9999-12-30') 
						$t=$dom->createTextNode(encode("Tlformation"));

					else
						$t=$dom->createTextNode($row['date']);
					$e->appendChild($t);
					$date->appendChild($e);
				}		
				if ($row['date']<'9999-12-30') {
					$e=$dom->createElement("horaire");
					$t=$dom->createTextNode($row['horaire']);
					$e->appendChild($t);
					$date->appendChild($e);
				}					
				$e=$dom->createElement("duree");
				$t=$dom->createTextNode($duree);
				$e->appendChild($t);
				$date->appendChild($e);

				if ($row['lieu']) {
					$e=$dom->createElement("lieu");
					$t=$dom->createTextNode(encode($row['lieu']));
					$e->appendChild($t);
					$date->appendChild($e);
				}			
				if ($row['remarque']) {
					$e=$dom->createElement("remarque_seance");
					$t=$dom->createTextNode(encode($row['remarque']));
					$e->appendChild($t);
					$date->appendChild($e);
				}
				$r4=query("SELECT civilite, nom, prenom,fonction,courriel FROM intervenants, interventions WHERE interventions.id_date=$id_date AND interventions.id_intervenant=intervenants.id_intervenant",$h);
				while ($row=@mysqli_fetch_array($r4)) {
					$intervenant=$dom->createElement("intervenant");
					$civ='';
					if ($row['civilite']==0) $civ='M.';
					else if($row['civilite']==1) $civ='Mme';
					$e=$dom->createElement("civ");
					$t=$dom->createTextNode($civ);
					$e->appendChild($t);
					$intervenant->appendChild($e);
					
					$e=$dom->createElement("nom");
					$t=$dom->createTextNode(encode($row['nom']));
					$e->appendChild($t);
					$intervenant->appendChild($e);
					
					if ($row['prenom']) {
						$e=$dom->createElement("prenom");
						$t=$dom->createTextNode(encode($row['prenom']));
						$e->appendChild($t);
						$intervenant->appendChild($e);
					}
					if ($row['fonction']) {
						$e=$dom->createElement("fonction");
						$t=$dom->createTextNode(encode($row['fonction']));
						$e->appendChild($t);
						$intervenant->appendChild($e);
					}
					if ($row['courriel']) {
						$e=$dom->createElement("courriel");
						$t=$dom->createTextNode(encode($row['courriel']));
						$e->appendChild($t);
						$intervenant->appendChild($e);
					}
					$date->appendChild($intervenant);
				}
				$seance->appendChild($date);
			}
			$animation->appendChild($seance);
		}
		$plan->appendChild($animation);
		$dom->appendChild($plan);
	}	
	return !$erreur;
}
function ecrireAnimationsV2($id_circo,&$dom,$annee,$h)
{
	global $erreur;
	if (!$id_circo ) {
		$erreur="id_circo erron ($id_circo)";
		return false;
	}
	// afficher toutes les animations et leurs exportations.
	$q="SELECT animations.id_anim,categories.codage AS categorie, domaines.libelle as domaine, domaines.id_domaine,intitule, themes.libelle as theme, themes.id_theme, description, animations.remarque, circos.libelle_court 
		FROM (positions, animations, themes, domaines, circos) 
		LEFT JOIN categories ON categories.id_categorie=animations.id_categorie 
		WHERE animations.id_circo=$id_circo AND positions.id_anim=animations.id_anim AND positions.id_domaine=domaines.id_domaine AND domaines.id_circo=$id_circo AND domaines.annee=$annee AND positions.id_theme=themes.id_theme AND animations.id_circo=circos.id_circo
		ORDER BY domaines.tri, themes.tri, positions.tri, animations.intitule ";
	$r=query($q,$h);
	$plan=$dom->createElement("plan");
	$domaine=NULL;
	$theme=NULL;
	$id_domaine_prec=0;
	$id_theme_prec=0;
	while ($row=@mysqli_fetch_array($r)) {
		$id_anim=$row['id_anim'];
		$animation=$dom->createElement("animation");
		$animation->setAttribute("circo",encode($row['libelle_court']));
		$animation->setAttribute("id_anim",$id_anim);	
		if ($row['categorie']) {
			$e=$dom->createElement("categorie");
			$t=$dom->createTextNode(encode($row['categorie']));
			$e->appendChild($t);
			$animation->appendChild($e);
		}

		$e=$dom->createElement("intitule");
		$t=$dom->createTextNode(encode($row['intitule']));
		$e->appendChild($t);
		$animation->appendChild($e);

		if ($row['description']) {
			$e=$dom->createElement("description");
			$t=$dom->createTextNode(encode($row['description']));
			$e->appendChild($t);
			$animation->appendChild($e);
		}
		if ($row['remarque']) {
			$e=$dom->createElement("remarque");
			$t=$dom->createTextNode(encode($row['remarque']));
			$e->appendChild($t);
			$animation->appendChild($e);
		}
		$q="SELECT id_seance, max, public, cond FROM seances WHERE id_anim=$id_anim ORDER BY tri";
		$r2=query($q,$h);
		while ($row2=@mysqli_fetch_array($r2)) {
			$id_seance=$row2['id_seance'];
			$seance= $dom->createElement("seance");
			$seance->setAttribute("id_seance",$id_seance);	
	
			$max=intval($row2['max']);
			$cond=intval($row2['cond']);
			if ($max>0) {
				$e=$dom->createElement("max");
				$t=$dom->createTextNode($max);
				$e->appendChild($t);
				$seance->appendChild($e);
			}
			if ($row2['public']) {
				$e=$dom->createElement("public");
				$t=$dom->createTextNode(encode($row2['public']));
				$e->appendChild($t);
				$seance->appendChild($e);
			}
			if ($cond>0) {
				$e=$dom->createElement("condition_ouverture");
				if ($cond==1) $s="max";
				else $s='max-'.($cond-1);
				$t=$dom->createTextNode($s);
				$e->appendChild($t);
				$seance->appendChild($e);
			}
			// ici circos concernes
			$r5=query("SELECT circos.libelle_court FROM partages, circos WHERE partages.id_seance=$id_seance AND partages.id_circo=circos.id_circo ORDER BY circos.libelle_court ASC" ,$h);
			$circ='';
			while ($row3=@mysqli_fetch_row($r5)) {
				if ($circ) $circ.=',';
				$circ.=$row3[0];
			}
			$e=$dom->createElement("circos_concernees");
			$t=$dom->createTextNode(encode($circ));
			$e->appendChild($t);
			$seance->appendChild($e);
			
			$r3=query("SELECT id_date,date, horaire, lieu, duree, remarque FROM dates WHERE id_seance=$id_seance ORDER BY tri",$h);
			while ($row3=@mysqli_fetch_array($r3)) {
				$date=$dom->createElement("date");
				$duree=doubleval($row3['duree']);
				$id_date=$row3['id_date'];
				$date->setAttribute("id_date",$id_date);				
				if ($row3['date'] && $row3['date']!='9999-12-31') {
					$e=$dom->createElement("date_seance");
					if ($row3['date']=='9999-12-30')
						$t=$dom->createTextNode(encode("Tlformation"));
					else
						$t=$dom->createTextNode($row3['date']);
					$e->appendChild($t);
					$date->appendChild($e);
				}
				if ($row3['date']<'9999-12-30') {
					$e=$dom->createElement("horaire");
					$t=$dom->createTextNode($row3['horaire']);
					$e->appendChild($t);
					$date->appendChild($e);
				}					
				$e=$dom->createElement("duree");
				$t=$dom->createTextNode($duree);
				$e->appendChild($t);
				$date->appendChild($e);

				if ($row3['lieu']) {
					$e=$dom->createElement("lieu");
					$t=$dom->createTextNode(encode($row3['lieu']));
					$e->appendChild($t);
					$date->appendChild($e);
				}			
				if ($row3['remarque']) {
					$e=$dom->createElement("remarque_seance");
					$t=$dom->createTextNode(encode($row3['remarque']));
					$e->appendChild($t);
					$date->appendChild($e);
				}
				$r4=query("SELECT civilite, nom, prenom,fonction,courriel FROM intervenants, interventions WHERE interventions.id_date=$id_date AND interventions.id_intervenant=intervenants.id_intervenant",$h);
				while ($row4=@mysqli_fetch_array($r4)) {
					$intervenant=$dom->createElement("intervenant");
					$civ='';
					if ($row4['civilite']==0) $civ='M.';
					else if($row4['civilite']==1) $civ='Mme';
					$e=$dom->createElement("civ");
					$t=$dom->createTextNode($civ);
					$e->appendChild($t);
					$intervenant->appendChild($e);
					
					$e=$dom->createElement("nom");
					$t=$dom->createTextNode(encode($row4['nom']));
					$e->appendChild($t);
					$intervenant->appendChild($e);
					
					if ($row4['prenom']) {
						$e=$dom->createElement("prenom");
						$t=$dom->createTextNode(encode($row4['prenom']));
						$e->appendChild($t);
						$intervenant->appendChild($e);
					}
					if ($row4['fonction']) {
						$e=$dom->createElement("fonction");
						$t=$dom->createTextNode(encode($row4['fonction']));
						$e->appendChild($t);
						$intervenant->appendChild($e);
					}
					if ($row4['courriel']) {
						$e=$dom->createElement("courriel");
						$t=$dom->createTextNode(encode($row4['courriel']));
						$e->appendChild($t);
						$intervenant->appendChild($e);
					}
					$date->appendChild($intervenant);
				}
				$seance->appendChild($date);
			}
			$animation->appendChild($seance);
		}
		$id_domaine=$row['id_domaine'];
		$id_theme=$row['id_theme'];
		if ($id_theme!=$id_theme_prec) {
			if ($theme && $domaine) {
				$domaine->appendChild($theme);
			}
			$id_theme_prec=$id_theme;
			$theme=$dom->createElement("theme");
			$theme->setAttribute("id_theme",$row['id_theme']);	
			$e=$dom->createElement("theme_nom");
			$t=$dom->createTextNode(encode($row['theme']));
			$e->appendChild($t);
			$theme->appendChild($e);
		}
		debug("$id_domaine,$id_domaine_prec,$id_theme,$id_theme_prec");
		$theme->appendChild($animation);
		if ($id_domaine!=$id_domaine_prec) {
			if ($domaine) {
				$domaine->appendChild($theme);
				$plan->appendChild($domaine);
			}
			$id_domaine_prec=$id_domaine;
			$id_theme_prec=0;
			$domaine=$dom->createElement("domaine");
			$domaine->setAttribute("id_domaine",$row['id_domaine']);	
			$e=$dom->createElement("domaine_nom");
			$t=$dom->createTextNode(encode($row['domaine']));
			$e->appendChild($t);
			$domaine->appendChild($e);
		}		
	}
	if ($domaine && $theme) {
		$domaine->appendChild($theme);
		$plan->appendChild($domaine);
	}	
	$dom->appendChild($plan);	
	return !$erreur;
}

function encode( $s)
{
	return iconv('ISO-8859-15','UTF-8',str_replace(chr(146),'\'',$s));
}	
function afficherCircos($h)
{
	global $erreur;
	$r=query("SElECT id_circo, rne, libelle, libelle_court FROM circos ORDER BY libelle ASC",$h);
	while ($row=@mysqli_fetch_row($r)) {
		printf("<p><input type=\"checkbox\" name=\"circos[]\" value=\"%s\" />%s (%s) - %s</p>\n",$row[0],htmlentities($row[2],ENT_COMPAT,'ISO-8859-15'),htmlentities($row[3],ENT_COMPAT,'ISO-8859-15'),htmlentities($row[1],ENT_COMPAT,'ISO-8859-15'));
	
	}
}	

?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="fr" lang="fr">
	<head>
		<title><?php print htmlentities($titre_site,ENT_COMPAT,'ISO-8859-15') ?></title>
		<meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-155" />
		<link rel="stylesheet" href="styles.css" type="text/css" /> <link rel="shortcut icon" type="image/x-icon" href="favicon.ico" />
    <script type="text/JavaScript" charset="ISO-8859-15">
<!--
function cocheTout(obj)
{
  // on rcupre le formulaire des objets  modifier
  leForm = obj.form

  laListe = leForm["circos[]"]

  if (laListe != null){
	if (laListe.length != null){
	  // on modifie tous les lments
	  for(i=0; i < laListe.length; i++) {
		laListe[i].checked = obj.checked
	  }
	} else {
	  laListe.checked = obj.checked
	}
  }
}
//-->
        </script>
	</head>
	<body>
		<div id="conteneur">
			<?php 
				include('menu_principal.inc.php');
			?>
			<div class="menu_secondaire">
				<ul class="menu2">
	  				<li><a href="<?php print $url_ret_adm_adm_plan_export_xml?>">retour</a></li>
	  				<li><a href="#bas">bas</a></li>
				</ul>
			</div>
			<div id="corps">	 
			  <h1>Exportation des plans de formation au format XML 
			  </h1>
			    <?php if ($erreur) print "<p class=\"erreur\">$erreur</p>";?> 
		      Seules sont export&eacute;es les animations <em>&eacute;labor&eacute;es</em> par les circos. Les animations import&eacute;es par les circos ne sont pas concern&eacute;es.
		      Si vous souhaitez obtenir les plans de formation complets des circos, incluant les animations import&eacute;es, au format xml, il faut vous rendre dans la section &quot;animations&quot; des circos concern&eacute;es.
		      <form name="form1" method="post" action="">
		        <h2>S&eacute;lection des circonscriptions </h2>
		        <p>
		          <input type="checkbox" name="checkbox" value="checkbox" onclick="javascript:cocheTout(this)" />
		          Cocher tout 
		        </p>
		        <?php afficherCircos($h) ?>
		        <h2>Type de plan &agrave; exporter </h2>
		        <p>
<input type="radio" name="annee" value="0" <?php if($annee==0) print 'checked="checked" '?>/>	            
plan actuel </p>
		        <p>
		          <input type="radio" name="annee" value="1" <?php if($annee==1) print 'checked="checked" '?>/>
		        plan futur </p>
		        <h2>Version du plan &agrave; exporter</h2>
		        <p>
		          <input type="radio" name="version" value="1" <?php if ($version==1) print 'checked="checked"'?> /> 
		          Version 1: liste des animations, chacune contient son domaine et son th&egrave;me.
A utiliser si on veut retravailler un plan de formation &agrave; partir du fichier xml, en prenant l'animation comme entit&eacute; de r&eacute;f&eacute;rence. Il n'est ainsi pas n&eacute;cessaire de d&eacute;placer une animation dans le plan, puisque le domaine et le th&egrave;me sont r&eacute;f&eacute;renc&eacute;s dans l'animation. </p>
		        <p>
		          <input type="radio" name="version" value="2" <?php if ($version==2) print 'checked="checked"'?> />
		        Version 2: organisation hi&eacute;rachique conforme &agrave; l'organisation du plan, en domaines, th&egrave;mes, animations. A utiliser pour afficher les plans de formations dans diff&eacute;rents logiciels. Les circos peuvent exporter ce type de plan. </p>
		        <p>
		          <input name="Submit" type="submit" class="bouton_standard" value="Exporter en XML !" />
		        </p>
		      </form>
	      </div>
			<div class="menu_secondaire">
				<ul class="menu2">
	  				<li><a href="<?php print $url_ret_adm_adm_plan_export_xml?>">retour</a></li>
		  			<li><a href="#haut">haut</a></li>
				</ul>
			</div>
			<a name="bas" id="bas"></a>	
		</div>
	</body>
</html>