<?php
/* 
	Ajout d'une circo
	Circon'script PHP Script
	Version 7.0.3
	CeCILL Copyright (C) 2008 Thierry Gangloff
	e-mail: thierry.gangloff@ac-strasbourg.fr
*/

	require('_session.php');
	if (isset($_GET['url_ret'])) {
		$url_ret_adm_circo_ajoute=strip_tags($_GET['url_ret']);
		$_SESSION['circonscript7_url_ret_adm_circo_ajoute']=$url_ret_adm_circo_ajoute;
	}
	else if (isset($_SESSION['circonscript7_url_ret_adm_circo_ajoute'])) {
		$url_ret_adm_circo_ajoute=$_SESSION['circonscript7_url_ret_adm_circo_ajoute'];
	}
	else $url_ret_adm_circo_ajoute="administration.php";
	
	$erreur='';
	$resultat='';
	require '_sqlconnect.inc.php';
	require '_fonctions.inc.php';
	require '_fonctions_mdp.inc.php';
	require '_fonctions_stagiaire.inc.php';
	debugInit();
	if (!isset($_SESSION['circonscript7_administration'])) {
		header( 'Location: erreur.php?erreur=expiree');
		exit;
	}
	$h=connect();
	ejecteSiFerme($h);
	$rne='';
	$libelle='';
	$libelle_court='';
	$courriel='';
	$quota='';
	$duree_seance='';
	$horaire_defaut='';
	$type_circo=0;
	$inscriptions=0;
	$r=query("SELECT quota, duree_seance, horaire_defaut FROM general",$h);
	if ($r) {
		$row=@mysqli_fetch_row($r);
		$quota=$row[0];
		$duree_seance=$row[1];
		$horaire_defaut=$row[2];
	}
			
	if (isset($_POST['ajouter'])) {
		if (isset($_POST['type_circo'])) {
			$type_circo=intval($_POST['type_circo']);
			if ($type_circo<0 || $type_circo>2) $type_circo=0;
		}
		else $erreur.='Type circo invalide. ';
		if (isset($_POST['rne_circo'])) {
			$rne=strtoupper(normaliseT($_POST['rne_circo'],8));
			if (strlen($rne)!=8 || !preg_match("#([0-9]){7}[a-zA-Z]#",$rne)) $erreur.="RNE invalide. ";
		}
		else $erreur.='RNE invalide. ';
		$inscriptions=isset($_POST['inscriptions'])?1:0;
		if ($type_circo!=0) $inscriptions=0;
		if (isset($_POST['libelle_circo'])) {
			$libelle=normaliseT($_POST['libelle_circo'],255);
			if (!nomValide($libelle)) $erreur.="Libell long non valide. ";
		}
		else $erreur.='Libelle long invalide. ';
		if (isset($_POST['libelle_court_circo'])) {
			$libelle_court=normaliseT($_POST['libelle_court_circo'],7);
			if (!nomValide($libelle_court)) $erreur.="Libell court invalide. ";
		}
		else $erreur.='Libell court invalide. ';
	
		if (isset($_POST['courriel_circo'])) {
			$courriel=normaliseT($_POST['courriel_circo'],255);
			if ($courriel!='' && !testeEmail($courriel)) $erreur.="Courriel invalide. ";
		}
		if (isset($_POST['quota_circo'])) $quota=normaliseT($_POST['quota_circo'],7);
		if (isset($_POST['duree_seance_circo'])) $duree_seance=normaliseT($_POST['duree_seance_circo'],7);
		$b=settype($quota,"double");
		if (!$b||$quota<=0) $erreur.="Quota: nombre d'heures invalide. ";
		$b=settype($duree_seance,"double");
		if (!$b||$duree_seance<=0) $erreur.="Dure sance: nombre d'heures invalide. ";
		if (isset($_POST['horaire_defaut'])) {
			$horaire_defaut=horaireSaisiEnSql(normaliseT($_POST['horaire_defaut'],16));
			if ($horaire_defaut=='') $erreur.="Horaire incorrect. ";
		}
		else $erreur.='Horaire dfaut.';
		if (!$erreur) {	
			$n=queryValue("SELECT COUNT(*) FROM circos WHERE rne='$rne'",$h);
			if ($n>0) $erreur="Une circonscription avec ce RNE existe dj. ";
			else {	
				$suffixedefaut=suffixeDefaut($h);
				$q=sprintf("INSERT INTO circos(rne,libelle,libelle_court,courriel,quota, duree_seance,horaire_defaut,type_circo,inscriptions_autorisees) VALUES('$rne','$libelle','$libelle_court','$courriel','$quota','$duree_seance','$horaire_defaut','$type_circo','$inscriptions')",$h);
				query($q,$h);
				if (!$erreur) {
					$resultat.=" Circo ajoute. ";
					$rne='';
					$libelle='';
					$libelle_court='';
					$courriel='';
				}
			}
		}
	
	}
	
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="fr" lang="fr">
	<head>
		<title><?php print htmlentities($titre_site,ENT_COMPAT,'ISO-8859-15') ?></title>
		<meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-15" />
		<link rel="stylesheet" href="styles.css" type="text/css" /> <link rel="shortcut icon" type="image/x-icon" href="favicon.ico" />
	</head>
	<body>
		<div id="conteneur">
			<?php 
				include('menu_principal.inc.php');
			?>
			<div class="menu_secondaire">
				<ul class="menu2">
	  				<li><a href="<?php print $url_ret_adm_circo_ajoute?>">retour</a></li>
                    <li><a href="#bas">bas</a></li>
</ul>
			</div>
		  <div id="corps">
		  <?php if ($erreur) print "<p class=\"erreur\">$erreur</p>\n";		  	 
		  	if ($resultat) print "<p class=\"erreur\">$resultat</p>\n";?>
		    <h1>Ajout d'une  circonscription </h1>
		    <form name="form1" method="post" action="">
		      <p>Type : 
			  <input name="type_circo" type="radio" value='0' <?php if ($type_circo==0) print 'checked="checked"'?>> relle
			  <input name="type_circo" type="radio" value='1' <?php if ($type_circo==1) print 'checked="checked"'?>> virtuelle
			  <input name="type_circo" type="radio" value='2' <?php if ($type_circo==2) print 'checked="checked"'?>> virtuelle  transfert			  </p>
		      <p>
		        <input name="inscriptions" type="checkbox" id="inscriptions" value="1" />
		        gestion des inscriptions (si circo r&eacute;elle)
		      </p>
		      <p>RNE *:
		        <input name="rne_circo" type="text" id="rne_circo" value="<?php print htmlentities($rne,ENT_COMPAT,'ISO-8859-15')?>" size="8" maxlength="8"> <em>Pour une circo non relle, tapez un RNE fictif</em></p>
		      <p>Libell&eacute; long* :
                <input name="libelle_circo" type="text" id="libelle_circo" value="<?php print htmlentities($libelle,ENT_COMPAT,'ISO-8859-15')?>" size="60" maxlength="255" />
		      </p>
		      <p>Libell&eacute; court* :
                <input name="libelle_court_circo" type="text" id="libelle_court_circo" value="<?php print htmlentities($libelle_court,ENT_COMPAT,'ISO-8859-15')?>" size="7" maxlength="7" />
		      <em>Maximum 7 caract&egrave;res, pour les listes.</em> </p>
		      <p>Adresse de courriel officielle:
		        <input name="courriel_circo" type="text" id="courriel_circo" value="<?php print htmlentities($courriel,ENT_COMPAT,'ISO-8859-15')?>" size="100" maxlength="255" />
		      </p>
		      <p>Nombre minimal d'heures d'animations pour un stagiaire travaillant &agrave; temps plein *:
                <input name="quota_circo" type="text" id="quota_circo" value="<?php print htmlentities($quota,ENT_COMPAT,'ISO-8859-15')?>" size="7" maxlength="7" />
		        <em>Nombre d&eacute;cimal (utilisez le point d&eacute;cimal pour la virgule) </em></p>
		      <p>Dur&eacute;e standard d'une s&eacute;ance* : 
		        <input name="duree_seance_circo" type="text" id="duree_seance_circo" value="<?php print htmlentities($duree_seance,ENT_COMPAT,'ISO-8859-15')?>" size="7" maxlength="7" />
		      </p>
		      <p>Horaire par d&eacute;faut du d&eacute;but des s&eacute;ances :
                <input name="horaire_defaut" type="text" id="horaire_defaut" value="<?php print horaireSqlEnHeure($horaire_defaut)?>" size="7" maxlength="7" />
		      </p>
		      <hr />
		      <p align="center">
		        <input name="ajouter" type="submit" class="bouton_standard" id="ajouter" onclick="javascript:confirme()" value="Ajouter"/>
		        &nbsp;
		        <input name="Submit2" type="reset" class="bouton_standard" value="R&eacute;tablir" onclick="javascript:confirme()"/>
		      </p>
	        </form>

		  </div>
			<div class="menu_secondaire">
				<ul class="menu2">
	  				<li><a href="<?php print $url_ret_adm_circo_ajoute?>">retour</a></li>
                    <li><a href="#bas">bas</a></li>
                </ul>
			</div>
			<a name="bas" id="bas"></a>	
		</div>
</body>
</html>