 <?php
/* 
	Importation de toutes les circos pour admin
	Circon'script PHP Script
	Version 7.0.3
	CeCILL Copyright (C) 2008 Thierry Gangloff
	e-mail: thierry.gangloff@ac-strasbourg.fr
*/

	require('_session.php');
	if (isset($_GET['url_ret'])) {
		$url_ret_adm_circos_import=strip_tags($_GET['url_ret']);
		$_SESSION['circonscript7_url_ret_adm_circos_import']=$url_ret_adm_circos_import;
	}
	else if (isset($_SESSION['circonscript7_url_ret_adm_circos_import'])) {
		$url_ret_adm_circos_import=$_SESSION['circonscript7_url_ret_adm_circos_import'];
	}
	else $url_ret_adm_circos_import="administration.php";
	if (!isset($_SESSION['circonscript7_administration'])) {
		header( 'Location: erreur.php?erreur=expiree');
		exit;
	}
	
	$erreur='';
	require '_sqlconnect.inc.php';
	require '_fonctions.inc.php';
	require '_fonctions_stagiaire.inc.php';
	@set_time_limit(0); // pas de limitation pour le calcul, qui peut tre long...
	
	$h=connect();
	debugInit();
	$fait=0;
	$nb_circos_inserees=0;
	$nb_circos_remplacees=0;

	while ( isset($_POST['upload']) ) // si formulaire soumis
	{
		$tmp_file = $_FILES['fichier']['tmp_name'];
		if( !is_uploaded_file($tmp_file) )
		{
			$erreur="Le fichier est introuvable";
			break;
		}
		$remplacer=false;
		if (isset($_POST['chk_remplacer'])) $remplacer=true;
		$fp=fopen($tmp_file,"r");
		if ($fp==NULL) {
			$erreur="Impossible d'ouvrir le fichier";
			break;
		}
		// recherche les champs
		$ligne1=fgetcsv($fp,2000,";");
		$rne=-1;
		$libelle=-1;
		$libelle_court=-1;
		$saisie_courriel=-1;
		$quota=-1;
		$duree_seance=-1;
		$horaire_defaut=-1;
		$regle_calcul=-1;
		$couriel=-1;
		$type=-1;
		$r=query("SELECT quota,duree_seance,horaire_defaut FROM general",$h);
		$general=@mysqli_fetch_array($r);
		
		for($i=0;$i<count($ligne1);++$i) {
			$v=trim(strtolower($ligne1[$i]));
			if (strcmp($v,'rne')==0) $rne=$i;
			else if (strcmp($v,'libelle')==0) $libelle=$i;			
			else if (strcmp($v,'libelle_court')==0) $libelle_court=$i;			
			else if (strcmp($v,'saisie_courriel')==0) $saisie_courriel=$i;			
			else if (strcmp($v,'quota')==0) $quota=$i;			
			else if (strcmp($v,'duree_seance')==0) $duree_seance=$i;			
			else if (strcmp($v,'horaire_defaut')==0) $horaire_defaut=$i;			
			else if (strcmp($v,'regle_calcul')==0) $regle_calcul=$i;			
			else if (strcmp($v,'courriel')==0) $courriel=$i;			
			else if (strcmp($v,'type_circo')==0) $type=$i;			
		}
		if ($rne<0) $erreur.="Champ RNE absent. ";
		if ($libelle<0) $erreur.="Champ LIBELLE absent. ";
		if ($libelle_court<0) $erreur.="Champ LIBELLE_COURT absent. ";
		while (!$erreur && $ligne=fgetcsv($fp,2000,";")) {
			$c_type=0;
			if ($type>=0) {
				$s=strtolower(trim($ligne[$type]));
				switch($s) {
					case 'virtuelle':
						$c_type=1;
						break;
					case 'transfert':
						$c_type=2;
						break;
				}
			}
			$c_rne=trim($ligne[$rne]);
			if (!testRNE($c_rne)) {
				$erreur=sprintf("RNE incorrect ligne %d",$i+1);
				break;
			}
			$c_libelle=myEscapeString($h,trim($ligne[$libelle]));
			if ($c_libelle=='') continue;
			$c_libelle_court=myEscapeString($h,trim($ligne[$libelle_court]));
			if ($c_libelle_court=='') continue;
			if($saisie_courriel>=0) switch(strtolower(trim($ligne[$saisie_courriel]))) {
				case 'acadmique': $c_saisie_courriel=2;break;
				case 'obligatoire': $c_saisie_courriel=1;break;
				case 'facultatif': $c_saisie_courriel=0;break;
				default: $c_saisie_courriel=2;
			}
			else $c_saisie_courriel=2;
			if ($courriel>=0) {
				$c_courriel=strtolower(trim($ligne[$courriel]));
				if (!testeEMail($c_courriel)) $c_courriel='';
			}
			else $c_courriel='';
			if ($quota>=0) {
				$c_quota=doubleval(trim(str_replace(',','.',trim($ligne[$quota]))));
				if ($c_quota==0) $c_quota=$general['quota'];
			}
			else $c_quota=$general['quota'];
			if ($duree_seance>=0) {
				$c_duree_seance=doubleval(trim(str_replace(',','.',trim($ligne[$duree_seance]))));
				if ($c_duree_seance==0) $c_duree_seance=$general['duree_seance'];
			}
			else $c_duree_seance=$general['duree_seance'];
			if ($horaire_defaut>=0) {
				$c_horaire_defaut=trim(str_replace(',','.',trim($ligne[$horaire_defaut])));
			}
			else $c_horaire_defaut=$general['horaire_defaut'];
			
			if ($regle_calcul>=0) {
				$c_regle_calcul=intval(trim(str_replace(',','.',trim($ligne[$regle_calcul]))));
				if ($c_regle_calcul<0 ||$c_regle_calcul>5) $c_regle_calcul=1;
			}
			else $c_regle_calcul=1;
			$id_circo=queryValue("SELECT id_circo FROM circos WHERE rne='$c_rne'",$h);
			
			if ($id_circo>0) {
				if ($remplacer) {
					$q="UPDATE circos SET ";
					$q.="rne='$c_rne', quota='$c_quota', duree_seance='$c_duree_seance', horaire_defaut='$c_horaire_defaut' , libelle='$c_libelle',libelle_court='$c_libelle_court', courriel='$c_courriel', type_circo=$c_type WHERE id_circo=$id_circo";
					query($q,$h); 
					if (!$erreur) ++$nb_circos_remplacees;
				}
			}
			else {
				query("INSERT INTO circos(rne,quota,duree_seance,horaire_defaut,libelle,libelle_court, courriel,type_circo) VALUES( '$c_rne','$c_quota','$c_duree_seance','$c_horaire_defaut','$c_libelle','$c_libelle_court','$c_courriel','$c_type')",$h); 
				if (!$erreur) ++$nb_circos_inserees;
			}
		}
		fclose($fp);
		$fait=1;
		break;
	}
	if ($fait && !$erreur) {
		$erreur="$nb_circos_inserees circos insres, $nb_circos_remplacees circos remplaces";
		
	}	
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="fr" lang="fr">
	<head>
		<title><?php print htmlentities($titre_site,ENT_COMPAT,'ISO-8859-15') ?></title>
		<meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-15" />
		<link rel="stylesheet" href="styles.css" type="text/css" /> <link rel="shortcut icon" type="image/x-icon" href="favicon.ico" /></head>
	<body>
		<div id="conteneur">
			<?php 
				include('menu_principal.inc.php');
			?>
			<div class="menu_secondaire">
				<ul class="menu2">
	  				<li><a href="<?php print $url_ret_adm_circos_import?>">retour</a></li>
	  				<li><a href="#bas">bas</a></li>
				</ul>
			</div>
			<div id="corps">	 
			
<?php if ($erreur) print "<p class=\"erreur\">$erreur</p>";?>				
	<h1>Importation des circonscriptions</h1>
	<p>Les circonscriptions sont pr&eacute;sentes dans un fichier CSV.  L'ordre des champs n'a pas d'importance. La casse (majuscules ou minuscules) dans le nom des champs n'a pas d'importance. Les champs sont s&eacute;par&eacute;s par des points-virgule. </p>
	<p>Renommez les champs de votre CSV s'ils ne correspondent pas &agrave; la syntaxe demand&eacute;e. Les autres champs seront ignor&eacute;s. </p>
	<h3>Les champs requis (en vert, les champs obligatoires) </h3>
	<table border="1" cellpadding="1" cellspacing="2">
      <tr>
        <td bgcolor="#33CC33">RNE</td>
        <td><p>Num&eacute;ro RNE de la circo </p></td>
        <td><p>Doit &ecirc;tre renseign&eacute;. </p></td>
      </tr>
      <tr>
        <td bgcolor="#33CC33">LIBELLE</td>
        <td><p>Nom complet de la circonscription: exemple: <em>Strasbourg 9 </em></p></td>
        <td>&nbsp;</td>
      </tr>
      <tr>
        <td bgcolor="#33CC33">LIBELLE_COURT</td>
        <td><p>Nom abr&eacute;g&eacute; de la circonscription, pour les listes:<em> Stras9 </em></p></td>
        <td>&nbsp;</td>
      </tr>
      <tr>
        <td>TYPE_CIRCO</td>
        <td> <p>Type de la circo: r&eacute;elle, virtuelle, transfert </p>
        </td>
        <td>&nbsp;</td>
      </tr>
      <tr>
        <td>COURRIEL</td>
        <td><p>Adresse de courriel officielle </p>        </td>
        <td>&nbsp;</td>
      </tr>
      <tr>
        <td>SAISIE_COURRIEL</td>
        <td><p>Mani&egrave;re dont les stagiaires doivent saisir le courriel:</p></td>
        <td>Trois valeurs possibles: <em>facultatif, obligatoire, acad&eacute;mique. </em></td>
      </tr>
      <tr>
        <td>QUOTA</td>
        <td><p>Nombre d'heures dues par les stagiaires (nombre d&eacute;cimal) </p></td>
        <td>Si vide, sera remplac&eacute; par le quota standard </td>
      </tr>
      <tr>
        <td>DUREE_SEANCE</td>
        <td><p>Dur&eacute;e par d&eacute;faut d'une s&eacute;ance (nombre d&eacute;cimal) </p></td>
        <td>Si non renseign&eacute;, sera remplac&eacute; par l'horaire standard </td>
      </tr>
      <tr>
        <td>HORAIRE_DEFAUT</td>
        <td><p>Horaire par d&eacute;faut des s&eacute;ances </p></td>
        <td>&nbsp;</td>
      </tr>
      <tr>
        <td>REGLE_CALCUL</td>
        <td><p>N&deg; de la r&egrave;gle de calcul employ&eacute;e pour le calcul des arrondis</p></td>
        <td>Nombre entier de 1 &agrave; 5. </td>
      </tr>
    </table>
	<h2>Option suppl&eacute;mentaire </h2>
	<form name="form1" method="post"  enctype="multipart/form-data" action="">
	  <p>&nbsp;</p>
	  <p>
	    <input name="chk_remplacer" type="checkbox" id="chk_remplacer" value="1" />
	    Remplacer les circos existantes par celles provenant du fichier	  </p>
	  <h3>Chemin du fichier</h3>
	  <p>Indiquez ici le chemin du fichier csv ou cliquez sur Parcourir pour le charger.</p>
	  <p>Cliquez sur Valider pour lancer la proc&eacute;dure. </p>
	  <p>
	    <input name="fichier" type="file" class="bouton_standard" size="30" />
	    <input name="upload" type="submit" class="bouton_standard" value="Valider" />
</p>
	</form>
		  </div>
			<div class="menu_secondaire">
				<ul class="menu2">
					<li><a href="<?php print $url_ret_adm_circos_import?>">retour</a></li>
					<li><a href="#haut">haut</a></li>
				</ul>
			</div>
			<a name="bas" id="bas"></a>	
		</div>
	</body>
</html>