<?php
/* 
	Ajout et modification des coles
	Circon'script PHP Script
	Version 7.0.3
	CeCILL Copyright (C) 2008 Thierry Gangloff
	e-mail: thierry.gangloff@ac-strasbourg.fr
*/

	require('_session.php');
	if (isset($_GET['url_ret'])) {
		$url_ret_adm_ecoles=strip_tags($_GET['url_ret']);
		$_SESSION['circonscript7_url_ret_adm_ecoles']=$url_ret_adm_ecoles;
	}
	else if (isset($_SESSION['circonscript7_url_ret_adm_ecoles'])) {
		$url_ret_adm_ecoles=$_SESSION['circonscript7_url_ret_adm_ecoles'];
	}
	else $url_ret_adm_ecoles="adm_configuration.php";
	
	$erreur='';
	require '_sqlconnect.inc.php';
	require '_fonctions.inc.php';
	
	if (!isset($_SESSION['circonscript7_id_circo'])) {
		header( 'Location: erreur.php?erreur=expiree');
		exit;
	}		
	$id_circo=$_SESSION['circonscript7_id_circo'];
	$id_ecole=0; // ecole en cours: 0 si ajout.
	$erreur='';
	$h=connect();
	ejecteSiFerme($h);
	debugInit();
	$rne='';
	$nom='';
	$courriel='';
	$nombre=queryValue("SELECT COUNT(*) FROM ecoles WHERE id_circo=$id_circo",$h);
	if (isset($_SESSION['circonscript7_edition'])) 
		$edition=$_SESSION['circonscript7_edition'];
	else
		$edition=0;
	if (isset($_POST['valider'])|| (isset($_POST['commande']) && $_POST['commande']=='valider')) 	while (1) {
		$rne=str_replace('"','',strtoupper(normalise($_POST['rne_ecole'])));
		if (strlen($rne)!=8 || !preg_match("#([0-9]){7}[a-zA-Z]#",$rne)) $erreur.="RNE invalide. ";
		$nom=str_replace('"','',normaliseT(nettoyerApostrophes($_POST['nom_ecole']),200));
		if ($nom=='') $erreur.='Nom de l\'cole absent.';
		$courriel=str_replace('"','',strtolower(normaliseT($_POST['courriel_ecole'],200)));
		if (!testeEmail($courriel)) $erreur="Courriel incorrect";
		if ($erreur) break;
		if ($edition) {
			$id_ecole=$edition;
			$q="SELECT id_circo FROM ecoles WHERE id_ecole<>$id_ecole AND rne='$rne'";
			$r=query($q,$h);
			if (!$r) break;
			if (@mysqli_num_rows($r)>0) {
				$row=@mysqli_fetch_row($r);
				if($row[0]==$id_circo) $erreur="Il existe dj une cole qui a ce RNE dans la circonscription. ";
				else $erreur="Il existe dj une cole avec ce RNE en-dehors de la circonscription. ";
				break;
			}
			$q=sprintf("SELECT COUNT(*) FROM ecoles WHERE id_circo=$id_circo AND id_ecole<>$id_ecole AND nom LIKE '%s'",myEscapeString($h,$nom));
			$nb=queryValue($q,$h);
			if ($nb>0) {
				$erreur="Il existe dj une cole portant ce nom dans la circonscription.";
				break;
			}	
			if ($courriel!='') {
				$q=sprintf("SELECT COUNT(*) FROM ecoles WHERE id_circo=$id_circo AND id_ecole<>$id_ecole AND courriel LIKE '%s'",myEscapeString($h,$courriel));
				$nb=queryValue($q,$h);
				if ($nb>0) {
					$erreur="Il existe dj une cole ayant ce courriel dans la circonscription.";
					break;
				}	
			}
			$q=sprintf("UPDATE ecoles SET rne='%s',nom='%s',courriel='%s' WHERE id_ecole=$id_ecole",myEscapeString($h,$rne),myEscapeString($h,$nom),myEscapeString($h,$courriel),$id_circo);
			query($q,$h);
			$rne='';
			$nom='';
			$courriel='';
			$edition=0;
			break;
		}
		else { // ajout d'une cole
			$q=sprintf("SELECT COUNT(*) FROM ecoles WHERE rne='%s'",myEscapeString($h,$rne));
			$nb=queryValue($q,$h);
			if ($nb>0) {
				$erreur="Une cole avec ce RNE existe dj dans la base";
				break;
			}
			$q=sprintf("SELECT COUNT(*) FROM ecoles WHERE nom LIKE '%s' AND id_circo=$id_circo",myEscapeString($h,$nom));
			$nb=queryValue($q,$h);
			if ($nb>0) {
				$erreur="Une cole avec ce nom existe dj";
				break;
			}
			$q=sprintf("INSERT INTO ecoles(rne,nom,courriel,id_circo) VALUES ('%s','%s','%s','%d')",myEscapeString($h,$rne),myEscapeString($h,$nom),myEscapeString($h,$courriel),$id_circo);
			query($q,$h);
			$rne='';
			$nom='';
			$courriel='';
			break;
		}
	}
	else if (isset($_POST['commande']) && $_POST['commande']=='supprimer' && isset($_POST['supprime'])) while (1) {
		$edition=0;
		$nonfaits=0;
		foreach($_POST['supprime'] as $id_ecole) {
			$id_ecole=abs(intval($id_ecole));
			// test si l'id_ecole est bien valide
			$count=queryValue("SELECT COUNT(*) FROM ecoles WHERE id_ecole=$id_ecole AND id_circo=$id_circo",$h);
			if (!$count) {
				++$nonfaits;
				continue;
			}
			$count=queryValue("SELECT COUNT(*) FROM stagiaires WHERE id_ecole=$id_ecole",$h);
			if ($count>0) {
				++$nonfaits;
				continue;
			}
			$q="DELETE FROM regles WHERE id_ecole=$id_ecole";  //supprime les rgles faisant allusion  cette cole
			query($q,$h);
			if ($erreur!='') break;
			$q="DELETE FROM ecoles WHERE id_ecole=$id_ecole";
			query($q,$h);
			if ($erreur!='') break;
			
		}
		if ($nonfaits>0) $erreur="$nonfaits cole(s) n'ont pas t supprimes car des stagiaires y sont attachs.";
		break;
	}
	else if (isset($_POST['courriel_auto'])|| (isset($_POST['commande']) && $_POST['commande']=='auto')) 	while (1) {
		$rne=strtoupper(normalise($_POST['rne_ecole']));
		if (strlen($rne)!=8) $erreur.=' RNE absent ou incorrect. ';
		$nom=normaliseT($_POST['nom_ecole'],200);
		if ($erreur) break;
		$suffixe=suffixeDefaut($h);
		if (!$suffixe) {
			$erreur="Fonction indisponible car le suffixe courriel par dfaut n'a pas t programm.";
			break;
		}
		$rne2=strtolower($rne);
		$courriel=sprintf("ce.%s@%s",$rne2,$suffixe);
		break;
	}
	else if (isset($_POST['undo'])) {
		$edition=0;
	}
	else if (isset($_GET['editer'])) while(1) { // entre en mode modification
		$id_ecole=abs(intval($_GET['editer'])); 
		// vrifie la donne
		$q="SELECT id_circo,rne,nom,courriel FROM ecoles WHERE id_ecole=$id_ecole";
		$row=queryRow($q,$h);
		
		if ($row[0]!=$id_circo) {
			$erreur="Ecole inconnue";
			break;
		}
		$rne=$row[1];
		$nom=$row[2];
		$courriel=$row[3];
		// on a le droit de editer cette cole: il faut l'afficher  la suite.
		$edition=$id_ecole;
		break;
	}
	$erreur=htmlentities($erreur,ENT_COMPAT,'ISO-8859-15');
	if ($rne=='' || $nom=='' ) $edition=0;
	$_SESSION['circonscript7_edition']=$edition;
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="fr" lang="fr">
	<head>
		<title><?php print htmlentities($titre_site,ENT_COMPAT,'ISO-8859-15') ?></title>
		<meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-15" />
		<link rel="stylesheet" href="styles.css" type="text/css" /> <link rel="shortcut icon" type="image/x-icon" href="favicon.ico" />
		<script type="text/javascript" src="popup.js"></script>
		<script type="text/javascript">
		<!--			
			function envoie2(event)
			{
				if (event.keyCode==13) {
					document.formulaire.commande.value="auto";
					document.formulaire.submit();
				}
			}
			function envoie(event)
			{
				if (event.keyCode==13) {
					document.formulaire.commande.value="valider";
					document.formulaire.submit();
				}
			}
			function cocheTout(obj)
			{
			  // on rcupre le formulaire des objets  modifier
			  leForm = obj.form
			
			  laListe = leForm["supprime[]"]
			
			  if (laListe != null){
				if (laListe.length != null){
				  // on modifie tous les lments
				  for(i=0; i < laListe.length; i++) {
					laListe[i].checked = obj.checked
				  }
				} else {
				  laListe.checked = obj.checked
				}
			  }
			}
			function confirme()
			{
			  
			  leForm = document.formulaire;
			  laListe = leForm["supprime[]"];
				n=0;
				if (laListe != null) {
					if (laListe.length != null) {
						for (i=0;i<laListe.length; ++i) if (laListe[i].checked) ++n;
					}
					else {
						if (laListe.checked) ++n;
					}
				}
				if (n==0) alert("Il faut cocher les coles  supprimer");
				else {
					b=window.confirm("Voulez-vous vraiment suprimer les coles coches ?");
					if (b) {	
						document.formulaire.commande.value="supprimer";
						document.formulaire.submit();
					}
				}				
			}
		//-->	
		</script>					
	</head>
	<body onload= "document.getElementById('rne_ecole').focus()">
		<div id="conteneur">
			<?php 
				include('menu_principal.inc.php');
			?>
			<div class="menu_secondaire">
				<ul class="menu2">
	  				<li><a href="<?php print $url_ret_adm_ecoles?>">retour</a></li>
					<li><a href="#bas">bas</a></li>
					<li><a href="adm_ecoles_importe.php?url_ret=adm_ecoles.php">importer</a></li>
				</ul>
			</div>
		  <div id="corps">	 

			  <h1>Liste des &eacute;coles de la circonsription (<?php print $nombre ?>)</h1>
		     
			  <?php if ($erreur) print"<p class=\"erreur\">$erreur</p>";
			
			?>
	<form name="formulaire" method="post" action="">
				<table>
      <tr class="table_entete">
        <td>RNE</td>
        <td>Nom</td>
        <td>Courriel</td>
		<td>Mod.</td>
		<td>Suppr.<input type="checkbox" name="cochetout" value="0" onclick="cocheTout(this)" /></td>
      </tr>
      <?php
	$r=query("SELECT id_ecole,rne,nom,courriel FROM ecoles WHERE id_circo=$id_circo ORDER BY nom",$h);
	while ($row=@mysqli_fetch_array($r)) {
		print "<tr class=\"survol\" >\r\n";
		print " <td>";
		print $row['rne'];
		print "</td>\r\n";
		print " <td>";
		print htmlentities($row['nom'],ENT_COMPAT,'ISO-8859-15');
		print "</td>\r\n";
		print " <td>";
		print htmlentities($row['courriel'],ENT_COMPAT,'ISO-8859-15');
		print "</td>\r\n";
		print " <td class=\"controle\">";
		printf ("<a href=\"adm_ecoles.php?editer=%s\"><img src=\"images/b_edit.png\" alt=\"edite\" /></a>",$row['id_ecole']);
	  
		//printf ("<a href=\"javascript:popUp('adm_ecoles_modif.php?id_ecole=%s','console',400,250);\"><img src=\"images/b_edit.png\" alt=\"editer\" /></a>",$row['id_ecole']);
		print "</td>\r\n";
		print " <td class=\"controle\">";
	  	printf ("<input type=\"checkbox\" name=\"supprime[]\" value=\"%s\" />",$row['id_ecole']);
		print "</td>\r\n";
		print "</tr>\r\n";
	}
	 ?>
      <tr class="survol">
        <td><input name="commande" type="hidden" id="commande" value="0" />
        <input name="rne_ecole" id="rne_ecole" type="text" value="<?php print htmlentities($rne,ENT_COMPAT,'ISO-8859-15')?>" size="8" maxlength="8" onkeypress="javascript:envoie(event)" /></td>
        <td><input name="nom_ecole" type="text" id="nom_ecole" value="<?php print htmlentities($nom,ENT_COMPAT,'ISO-8859-15')?>" size="50" maxlength="200" onkeypress="javascript:envoie(event)" /></td>
        <td><input name="courriel_ecole" type="text" id="courriel_ecole" value="<?php print htmlentities($courriel,ENT_COMPAT,'ISO-8859-15')?>" size="40" maxlength="200" onkeypress="javascript:envoie2(event)" />
          <input name="courriel_auto" type="submit" class="bouton_standard" id="courriel_auto" value="Auto" onkeypress="javascript:envoie(event)" /></td>
       <td class="controle"><input name="valider" type="submit" class="<?php print $edition?'bouton_editer':'bouton_ajoute'?>" value="Ajouter"/></td>
        <?php
			if (!$edition) print "<td class=\"controle\"><input name=\"supprimer\" type=\"button\" class=\"bouton_supprimer\" value=\"Supprimer\" onclick=\"confirme()\" /></td>\n";
			else print "<td class=\"controle\"><input name=\"undo\" type=\"submit\" class=\"bouton_undo\" value=\"D&eacute;faire\" /></td>\n";
/*				
			
			if ($edition) print "<td class=\"controle\"><a href=\"adm_ecoles.php?undo=1\"><img src=\"images/b_undo.png\" /></a></td>\n";
			else print "<td class=\"controle\"><a href=\"#haut\" onclick=\"confirme()\"><img src=\"images/b_supprime.png\" /></a></td>\n";
*/
		?>
      </tr>
    </table>
	<div align="center"></div>
	</form>
		<?php if ($erreur) print"<p class=\"erreur\">$erreur</p>";?>
		  </div>
		  <div class="menu_secondaire"><ul class="menu2"><li><a href="<?php print $url_ret_adm_ecoles?>">retour</a></li>
<li><a href="#haut">haut</a></li>
					<li><a href="adm_ecoles_importe.php?url_ret=adm_ecoles.php">importer</a></li>
</ul>
		  </div>
			<a name="bas" id="bas"></a>	
	<?php if (isset($_POST['valider'])||isset($_GET['editer'])) { ?>
	<script language="javascript" type="text/javascript">
		document.location.href="#bas";
	</script>
	<?php } ?>
		</div>
</body>
</html>