<?php
/* 
	Importation des coles de la circo
	Circon'script PHP Script
	Version 7.0.3
	CeCILL Copyright (C) 2008 Thierry Gangloff
	e-mail: thierry.gangloff@ac-strasbourg.fr
*/

	require('_session.php');
	if (isset($_GET['url_ret'])) {
		$url_ret_adm_ecoles_importe=strip_tags($_GET['url_ret']);
		$_SESSION['circonscript7_url_ret_adm_ecoles_importe']=$url_ret_adm_ecoles_importe;
	}
	else if (isset($_SESSION['circonscript7_url_ret_adm_ecoles_importe'])) {
		$url_ret_adm_ecoles_importe=$_SESSION['circonscript7_url_ret_adm_ecoles_importe'];
	}
	else $url_ret_adm_ecoles_importe="adm_configuration.php";
	
	$erreur='';
	require '_sqlconnect.inc.php';
	require '_fonctions_stagiaire.inc.php';
	require '_fonctions.inc.php';
	
	if (!isset($_SESSION['circonscript7_id_circo'])) {
		header( 'Location: erreur.php?erreur=expiree');
		exit;
	}		
	$id_circo=$_SESSION['circonscript7_id_circo'];
	$h=connect();
	ejecteSiFerme($h);
	debugInit();
	$fait=0;
	while ( isset($_POST['upload']) ) // si formulaire soumis
	{
		$tmp_file = $_FILES['fichier']['tmp_name'];
		if( !is_uploaded_file($tmp_file) )
		{
			$erreur="Le fichier est introuvable";
			break;
		}
		$commune=false;		
		if (isset($_POST['chk_commune'])) $commune=true;
		$formater=false;
		if (isset($_POST['chk_formater'])) $formater=true;
		$remplacer=false;
		if (isset($_POST['chk_remplacer'])) $remplacer=true;
		$fp=fopen($tmp_file,"r");
		if ($fp==NULL) {
			$erreur="Impossible d'ouvrir le fichier";
			break;
		}
		// recherche les champs
		$ligne1=fgetcsv($fp,2000,";");
		$numrne=-1;
		$sig=-1;
		$denom=-1;
		$email=-1;
		$commu_ec=-1;
		$codcirco=-1;
		for($i=0;$i<count($ligne1);++$i) {
			$v=trim(strtolower($ligne1[$i]));
			if (strcmp($v,'numrne')==0) $numrne=$i;
			else if (strcmp($v,'sig')==0) $sig=$i;
			else if (strcmp($v,'ecole')==0) $denom=$i;		
			else if (strcmp($v,'courriel_ec')==0) $email=$i;			
			else if (strcmp($v,'codcirco')==0) $codcirco=$i;
			else if (strcmp($v,'commu_ec')==0) $commu_ec=$i;		
		}
		if ($numrne<0) $erreur.="Champ RNE absent. ";
		if ($denom<0) $erreur.="Champ ECOLE absent. ";
		if ($erreur) break;

		$rne_circo='';
		if ($codcirco>=0) {
			$rne_circo=queryValue("SELECT rne FROM circos WHERE id_circo=$id_circo",$h);
		}	
		$suffixe_courriel=suffixeDefaut($h);

		$nb_rempl=0;
		$nb_ins=0;
		while (!$erreur && $ligne=fgetcsv($fp,2000,";")) {
			if ($rne_circo && strcasecmp($ligne[$codcirco],$rne_circo)!=0) continue;
			$rne=trim($ligne[$numrne]);
			if (!$rne) continue;
			if (strlen($rne)!=8 || !preg_match("#([0-9]){7}[a-zA-Z]#",$rne)) {
				$erreur.="RNE invalide: ".htmlentities($rne,ENT_COMPAT,'ISO-8859-15');
				break;
			}
			$sigle='';
			if ($sig>=0)$sigle=str_replace('"','',trim($ligne[$sig]));
			$nom_ec=str_replace('"','',trim($ligne[$denom]));
			if ($commu_ec>=0 && $commune) {
				$nom_ec.=' ';
				$nom_ec.=str_replace('"','',trim($ligne[$commu_ec]));
			}
			if ($formater) $nom_ec=majusculeChiffresRomains(majuscule($nom_ec));
			if ($sigle) $nom_ec="$sigle $nom_ec";
			$nom_ec=trim($nom_ec);
			if ($nom_ec=='') {	
				$erreur="Le nom de l'cole est absent";		
				break;
			}
			
			$courriel='';
			if ($email>=0) $courriel=trim($ligne[$email]);
			if ($courriel=='') {
				if ($suffixe_courriel=='') {
					$erreur="Suffixe de courriel par dfaut non dfini; demandez  l'administrateur principal de dfinir un suffixe de courriel par dfaut.";
					break;
				
				}			
				$courriel="ce.$rne@$suffixe_courriel";
			}
			$id_ecole=queryValue("SELECT id_ecole FROM ecoles WHERE rne='$rne' AND id_circo=$id_circo",$h);
			$nom_ec=myEscapeString($h,$nom_ec);
			$rne=myEscapeString($h,$rne);
			$courriel=myEscapeString($h,strtolower($courriel));
			if ($id_ecole) { // l'cole existe
				if ($remplacer) {
					query("UPDATE ecoles SET nom='$nom_ec', courriel='$courriel' WHERE id_ecole=$id_ecole",$h);
					++$nb_rempl;
				}
			}
			else {
				query("INSERT INTO ecoles(nom,courriel,rne,id_circo) VALUES ('$nom_ec','$courriel','$rne',$id_circo)",$h);
				++$nb_ins;
			}
		}
		fclose($fp);
		$fait=1;
		break;
	}
	if ($fait && !$erreur) 
		$erreur="$nb_ins cole(s) insre(s), $nb_rempl ecole(s) remplace(s)";
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="fr" lang="fr">
	<head>
		<title><?php print htmlentities($titre_site,ENT_COMPAT,'ISO-8859-15') ?></title>
		<meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-15" />
		<link rel="stylesheet" href="styles.css" type="text/css" /> <link rel="shortcut icon" type="image/x-icon" href="favicon.ico" /></head>
	<body>
		<div id="conteneur">
			<?php 
				include('menu_principal.inc.php');
			?>
			<div class="menu_secondaire">
				<ul class="menu2">
	  				<li><a href="<?php print $url_ret_adm_ecoles_importe?>">retour</a></li>
	  				<li><a href="#bas">bas</a></li>
				</ul>
			</div>
			<div id="corps">	 
			
<?php if ($erreur) print "<p class=\"erreur\">$erreur</p>";?>				
	<h1>Importation des &eacute;coles				</h1>
	<p>Les &eacute;coles sont pr&eacute;sentes dans un fichier CSV. L'ordre des champs n'a pas d'importance. La casse (majuscules ou minuscules) dans le nom des champs n'a pas d'importance. Les champs sont s&eacute;par&eacute;s par des points-virgule. </p>
	<p>Renommez les champs de votre CSV s'ils ne correspondent pas &agrave; la syntaxe demand&eacute;e. </p>
	<h3>Les champs requis (en vert, les champs obligatoires) </h3>
	<table border="1" cellpadding="1" cellspacing="2">
      <tr>
        <td bgcolor="#33CC33">NUMRNE</td>
        <td><p>Num&eacute;ro RNE de l'&eacute;cole </p>        </td>
        <td><p>Doit &ecirc;tre renseign&eacute;. </p>        </td>
      </tr>
      <tr>
        <td>SIG</td>
        <td><p>Sigle (E.E.PU, E.M.PU, etc)</p>        </td>
        <td rowspan="3"><p>Les trois champs seront associ&eacute;s pour la d&eacute;nomination de l'&eacute;cole: </p>
          <p>SIG DENOM (COMMU_EC si la case ci-dessous est coch&eacute;e) </p>        </td>
      </tr>
      <tr>
        <td bgcolor="#33CC33">ECOLE</td>
        <td><p>Nom de l'&eacute;cole </p>        </td>
      </tr>
      <tr>
        <td>COMMU_EC</td>
        <td><p>Commune de l'&eacute;cole </p>        </td>
      </tr>
      <tr>
        <td>CODCIRCO</td>
        <td><p>RNE de la circo</p></td>
        <td><p>Si CODCIRCO ne correspond pas au RNE de la circo, la ligne est ignor&eacute;e. <br />
          </p>
          </td>
      </tr>
      
      <tr>
        <td>COURRIEL_EC</td>
        <td><p>Courriel de l'&eacute;cole. Si le champ est absent, ou si l'&eacute;cole n'a pas de courriel, un courriel acad&eacute;mique sera automatiquement calcul&eacute; &agrave; partir du RNE. L'administrateur g&eacute;n&eacute;ral doit avoir param&eacute;tr&eacute; le suffixe de courriel par d&eacute;faut. </p>        </td>
        <td>&nbsp;</td>
      </tr>
    </table>
	<form name="form1" method="post"  enctype="multipart/form-data" action="">
	  <h3>Champ optionnel &agrave; choisir  </h3>
	  <p>
	    <input name="chk_commune" type="checkbox" id="chk_commune" value="1" checked="checked" />
	    ajoute la ville de l'&eacute;cole (champ COMMU_EC) derri&egrave;re le nom de l'&eacute;cole</p>
	  <h3>Option suppl&eacute;mentaire </h3>
	  <p>
	    <input name="chk_formater" type="checkbox" id="chk_formater" value="1" checked="checked" />
      Formater le nom de l'&eacute;cole (E.E.PU CONSEIL DES XV STRASBOURG devient &quot;E.E.PU. Conseil des XV Strasbourg&quot; - attention, le logiciel n'ajoute pas les accents mais il respecte les chiffres romains de I &agrave; XX et les &eacute;crit  int&eacute;gralement en majuscules) </p>
	  <h3>Concernant les &eacute;coles d&eacute;j&agrave; dans la base...</h3>
	  <p>
	    <input name="chk_remplacer" type="checkbox" id="chk_remplace" value="1" /> 
      Remplacer les &eacute;coles d&eacute;j&agrave; pr&eacute;sentes par celles provenant du fichier</p>
	  <h3>Chemin du fichier</h3>
	  <p>Indiquez ici le chemin du fichier csv ou cliquez sur Parcourir pour le charger.</p>
	  <p>Cliquez sur Valider pour lancer la proc&eacute;dure. </p>
	  <p>
	    <input name="fichier" type="file" class="bouton_standard" size="30" />
	    <input name="upload" type="submit" class="bouton_standard" value="Valider" />
</p>
	</form>
		  </div>
			<div class="menu_secondaire">
				<ul class="menu2">
					<li><a href="<?php print $url_ret_adm_ecoles_importe?>">retour</a></li>
					<li><a href="#haut">haut</a></li>
				</ul>
			</div>
			<a name="bas" id="bas"></a>	
		</div>
	</body>
</html>