<?php
/*	
	Edition des intervenants
	Circon'script PHP Script
	Version 7.0.3 
	CeCILL Copyright (C) 2008 Thierry Gangloff
	e-mail: thierry.gangloff@ac-strasbourg.fr
*/
	require('_session.php');
	if (isset($_GET['url_ret'])) {
		$url_ret_adm_intervenant_edite=strip_tags($_GET['url_ret']);
		$_SESSION['circonscript7_url_ret_adm_intervenant_edite']=$url_ret_adm_intervenant_edite;
	}
	else if (isset($_SESSION['circonscript7_url_ret_adm_intervenant_edite'])) {
		$url_ret_adm_intervenant_edite=$_SESSION['circonscript7_url_ret_adm_intervenant_edite'];
	}
	else $url_ret_adm_intervenant_edite="adm_seance_modif.php";
	
	$erreur='';
	require '_sqlconnect.inc.php';
	require '_fonctions.inc.php';
	require '_fonctions_stagiaire.inc.php';
	require '_fonctions_mdp.inc.php';
	
	if (!isset($_SESSION['circonscript7_id_circo'])) {
		header( 'Location: erreur.php?erreur=expiree');
		exit;
	}		
	$id_circo=$_SESSION['circonscript7_id_circo'];
	if (!isset($_GET['id_intervenant'])) {
		header('Location: erreur.php?erreur=id_intervenant');
		exit;
	}
	$id_intervenant=abs(intval($_GET['id_intervenant']));
	//faire des tests pour vrifier si l'intervenant est plausible
	
	$h=connect();
	ejecteSiFerme($h);
	debugInit();

	$q="SELECT civilite, nom, prenom, courriel, fonction, ouvert, id_circo FROM intervenants WHERE id_intervenant=$id_intervenant";
	$r=query($q,$h);
	if (!$r || @mysqli_num_rows($r)==0) {
		header('Location: erreur.php?erreur=id_intervenant');
		exit;
	}
	$row=@mysqli_fetch_array($r);
	if ($id_circo!=$row['id_circo']) {
		header('Location: erreur.php?erreur=id_intervenant');
		exit;
	}
	$civilite=$row['civilite'];
	$nom=$row['nom'];
	$prenom=$row['prenom'];
	$fonction=$row['fonction'];
	$courriel=$row['courriel'];
	if ($row['ouvert']) 
		$erreur.="Un accs personnel a t ouvert pour cet intervenant. Vous ne pouvez plus modifier ses paramtres. ";
	$nb=queryValue("SELECT COUNT(*) FROM interventions, dates,seances, animations WHERE interventions.id_intervenant=$id_intervenant AND interventions.id_date=dates.id_date AND dates.id_seance=seances.id_seance AND seances.id_anim=animations.id_anim AND animations.id_circo <>$id_circo",$h);
	if ($nb>0) 
		$erreur.="Trop tard ! Vous ne pouvez plus modifier la fiche de cet intervenant car une autre circonscription l'a inscrit dans son plan de formation. ";
	
	$intervenants=array();
	if (!$erreur && isset($_POST['commande']) && $_POST['commande']=='supprimer') {
		// supprimer un intervenant. Les tests de faisabilit ont t dj effectus ci-dessus;
		query("DELETE FROM interventions WHERE id_intervenant=$id_intervenant",$h);
		query("DELETE FROM intervenants WHERE id_intervenant=$id_intervenant",$h);
		$datelieu=$_SESSION['circonscript7_datelieu'];
		if (in_array($id_intervenant,$datelieu['intervenants'])) {
			$index=array_search($id_intervenant,$datelieu['intervenants']);
			unset($datelieu['intervenants'][$index]);
			$_SESSION['circonscript7_datelieu']=$datelieu;
		}				
		header("Location: $url_ret_adm_intervenant_edite");
		exit;
	}
	else if (!$erreur && isset($_POST['valider'])) while(1){
		$forcer_ajout=false;
		if (isset($_POST['rbIntervenant'])) {
			$id_intervenant_nouv=abs(intval($_POST['rbIntervenant']));
			if ($id_intervenant_nouv==0) $forcer_ajout=true;
			else {
				// remplacer l'ancien par le nouveau
				$datelieu=$_SESSION['circonscript7_datelieu'];
				//if (!in_array($id_intervenant,$datelieu['intervenants'])) $datelieu['intervenants'][]=$id_intervenant;
				remplacerIntervenant($id_intervenant_nouv,$id_intervenant,$datelieu,$h);
				if (!$erreur) {
					$_SESSION['circonscript7_datelieu']=$datelieu;
					header("Location: $url_ret_adm_intervenant_edite");
					exit;
				}
				break;	
			}
		}
		if (!isset($_POST['civilite'])) {
			$erreur.="Civilit absente. ";
			$civilite=-1;
		}
		else {
			$civilite=intval($_POST['civilite']);
			if ($civilite<0) $civilite=0;
			else if ($civilite>2) $civilite=2;
		}
		$nom=$_POST['nom'];
		if ($nom=='') {
			$erreur.="Nom absent. ";
		}	
		if (!$erreur && !nomValide($nom)) {
			$erreur.="Nom incorrect. Les caractres spciaux sont interdits. ";
		}
		if ($civilite<2) $nom=majuscule(normaliseT($nom,25));
		else $nom=normaliseT($nom,25);
		if (isset($_POST['prenom']) && $_POST['prenom']!='') {
			if (!nomValide($_POST['prenom'])) {
				$erreur.="Prnom incorrect. Les caractres spciaux sont interdits. ";
			}
			if ($civilite<2) $prenom=majuscule(normaliseT($_POST['prenom'],25));
			else $prenom=normaliseT($_POST['prenom'],25);
		}
		else $prenom='';
		if (isset($_POST['fonction']) && $_POST['fonction']!='') 
			$fonction=normaliseT($_POST['fonction'],20);
		else $fonction='';
		if (isset($_POST['courriel']) && $_POST['courriel']!='') {
			$courriel=strtolower(normaliseT($_POST['courriel'],255));
			if (!testeEmail($courriel)) {
				$erreur.="Courriel incorrect. ";
				break;	
			}
		}
		else $courriel='';
		if ($erreur) break;
		
		// pas d'erreur. Vrifie si l'intervenatn est dj ds la base
		$nom_f=normaliseNom($nom);
		$prenom_f='';
		if ($prenom) $prenom_f=normaliseNom($prenom);
		$r=query("SELECT courriel,id_uti FROM intervenants WHERE id_intervenant=$id_intervenant",$h);
		$row=@mysqli_fetch_row($r);
		$id_uti=$row[1];
		$courriel_anc=$row[0];
		$q="SELECT id_intervenant, nom, prenom, fonction,courriel, civilite FROM intervenants WHERE id_intervenant<>$id_intervenant AND ((nom_f LIKE '$nom_f'";
		if ($prenom_f) $q.=" AND prenom_f LIKE '$prenom_f'";
		$q.=')';
		if ($courriel) $q.=" OR courriel LIKE '$courriel'";
		$q.=')';
		$r=query($q,$h);
		$n=@mysqli_num_rows($r);
		if ($n==0||$forcer_ajout==true) {
			//  on modifie l'intervenant 
			$q=sprintf("UPDATE intervenants SET civilite=%d,nom='%s',prenom='%s',nom_f='%s',prenom_f='%s',fonction='%s',courriel='%s',id_circo=%d WHERE id_intervenant=$id_intervenant",
				$civilite,
				myEscapeString($h,$nom),
				myEscapeString($h,$prenom),
				myEscapeString($h,$nom_f),
				myEscapeString($h,$prenom_f),
				myEscapeString($h,$fonction),
				$courriel,
				$id_circo
				);
			$r=query($q,$h);
			// faut-il modifier le compte utilisateur aussi ?
			if ($courriel!=$courriel_anc) {
				if ($courriel) $login=$courriel;
				else $login='utilisateur'.$id_uti;
				
				// si le courriel a chang et que le compte utilisateur n'est reli qu'au compte intervenant
				if (nbConnexions($id_uti,$h)==1) {
					// Si le login a chang, il existe peut-tre un utilisateur avec ce login dans la base. Dans ce cas on s'en sert.
					$id_uti_new=queryValue("SELECT id_uti FROM utilisateurs WHERE login='$login'",$h);
					if ($id_uti_new>0 && $id_uti_new!=$id_uti) {
						query("UPDATE intervenants SET id_uti=$id_uti_new WHERE id_intervenant=$id_intervenant",$h);
						// le compte utilisateur ancien risque d'tre orphelin mais par prcaution il n'est pas dtruit
					
					}
					else query("UPDATE utilisateurs SET login='$login' WHERE id_uti=$id_uti",$h); 	
				}
			}
			if (!$erreur) {
				header("Location: $url_ret_adm_intervenant_edite");
				exit;
			}
		}
		// il y a dj des intervenants qui ressemblent: on affiche avec des cases  cocher
		else{
			$intervenants=array();
			while ($row=@mysqli_fetch_row($r)) $intervenants[]=$row;
		}
		
		
		
		break;
			
	}

function remplacerIntervenant($id_intervenant_nouv,$id_intervenant_anc,&$datelieu,$h)
{
	global $erreur, $id_circo;
	$nb=queryValue("SELECT COUNT(*) FROM intervenants WHERE id_intervenant=$id_intervenant_nouv",$h);
	if ($nb==0) {
		$erreur="Cet intervenant n'existe pas/plus dans la base.";
		return;
	}
	// remplace toutes les occurences de id_intervenant_anc dans les interventions de la circo
	$r=query("SELECT id_intervention FROM interventions, dates,seances,animations WHERE interventions.id_intervenant=$id_intervenant_anc AND interventions.id_date=dates.id_date AND dates.id_seance=seances.id_seance AND seances.id_anim=animations.id_anim AND animations.id_circo=$id_circo",$h);
	while ($row=@mysqli_fetch_row($r)) {
		$id_intervention=$row[0];
		query("UPDATE interventions SET id_intervenant=$id_intervenant_nouv WHERE id_intervention=$id_intervention",$h);
	}
	// supprime le cas chant l'ancien enregistrement.
	$nb=queryValue("SELECT COUNT(*) FROM interventions WHERE id_intervenant=$id_intervenant_anc",$h);
	if ($nb>0) return;
	$ouvert=queryValue("SELECT ouvert FROM intervenants WHERE id_intervenant=$id_intervenant_anc",$h);
	if ($ouvert==false) {
		$id_uti=queryValue("SELECT id_uti FROM intervenants WHERE id_intervenant=$id_intervenant_anc",$h);
		query("DELETE FROM intervenants WHERE id_intervenant=$id_intervenant_anc",$h);
		if (orphelin($id_uti,$h)) query("DELETE FROM utilisateurs WHERE id_uti=$id_uti",$h);
	}
	// remplace l'intervenant dans le datelieu en cours
	if (in_array($id_intervenant_nouv,$datelieu['intervenants'])) {
		// le nouveau est dj prsent, pas besoin de l'y mettre. Supprimer l'ancien ?
		if (in_array($id_intervenant_anc,$datelieu['intervenants'])) {
			$index=array_search($id_intervenant_anc,$datelieu['intervenants']);
			unset($datelieu['intervenants'][$index]);
		}
	}
	else if (in_array($id_intervenant_anc,$datelieu['intervenants'])) {
		$index=array_search($id_intervenant_anc,$datelieu['intervenants']);
		$datelieu['intervenants'][$index]=$id_intervenant_nouv;
	}
	else 
		$datelieu['intervenants'][]=$id_intervenant_nouv;
}


function afficherintervenants($intervenants, $courriel)
{
	if (count($intervenants)==0) return;
	//si l'adresse de courriel existe dj parmi les intervenants proposs, ne pas proposer de rajouter le nouvel intervenant
	$courriel_existe=false;
	if ($courriel) foreach($intervenants as $row) 
		if ($row[4]==$courriel) {
			$courriel_existe=true;
			break;
		}
	if ($courriel_existe) {
	 	print "<h1>Il existe d&eacute;j&agrave; des intervenants avec cette adresse de courriel.</h1>\n";
		print "<p>Vous pouvez cocher cet intervenant dans la liste ci-dessous, ou changer l'adresse de courriel dans la partie Edition d'un intervenant, car vous ne pouvez pas ajouter un intervenant ayant une adresse de courriel dj dans la base.</p>\n";
	
	}
	else {
		print "<h1>La liste contient d&eacute;j&agrave; des intervenants avec ces param&egrave;tres</h1>\n";
		print "<p>Cochez un intervenant ou une action &agrave; effectuer, ou modifiez les param&egrave;tres saisis, puis validez.</p>\n";
	}
	foreach($intervenants as $row) {
		$id_intervenant=$row[0];
		$nom=htmlentities($row[1],ENT_COMPAT,'ISO-8859-15');
		$prenom=htmlentities($row[2],ENT_COMPAT,'ISO-8859-15');
		$fonction=htmlentities($row[3],ENT_COMPAT,'ISO-8859-15');
		$courriel=htmlentities($row[4],ENT_COMPAT,'ISO-8859-15');
		if ($row[5]==0) $civilite="M. ";
		else if ($row[5]==1) $civilite="Mme ";
		else $civilite='';
		printf("<p><input type=\"radio\" name=\"rbIntervenant\" value=\"%d\" />",$id_intervenant);
		print "$civilite$nom";
		if ($prenom) print " $prenom";
		if ($fonction) print " ($fonction)";
		if ($courriel) print " <i>[$courriel]</i>";
		print "</p>\n";
	
	}
	if (!$courriel_existe) 
		print "<p><input type=\"radio\" name=\"rbIntervenant\" value=\"0\" />Je souhaite conserver les param&egrave;tres ci-dessous car ils correspondent bien &agrave; une autre personne que celle(s) list&eacute;e(s) ci-dessus.</p>";
	
}		
function afficheFonctions($h)
{
	$q="SELECT fonction FROM intervenants GROUP BY fonction";
	$r=query($q,$h);
	while ($row=@mysqli_fetch_row($r)) {
		$fonction=htmlentities($row[0],ENT_COMPAT,'ISO-8859-15');
		print "<option value=\"$fonction\">$fonction</option>\n";
	
	}
}
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="fr" lang="fr">
	<head>
		<title><?php print htmlentities($titre_site,ENT_COMPAT,'ISO-8859-15') ?></title>
		<meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-15" />
		<link rel="stylesheet" href="styles.css" type="text/css" /> <link rel="shortcut icon" type="image/x-icon" href="favicon.ico" />
		<script type="text/javascript">
		<!--
			function jsFonction(value)
			{
				if (value!='*') document.form1.fonction.value=value;
			}
			function jsSupprimer()
			{
			  
				b=window.confirm("Voulez-vous vraiment supprimer cette fiche ? Cet intervenant disparatra de TOUTES les sances du plan de formation o il est cens intervenir.");
				if (b) {	
					document.form1.commande.value='supprimer';
					document.form1.submit();
				}				
				
			}
		//-->	
		</script>					
	</head>
		
	<body>
		<div id="conteneur">
			<?php 
				include('menu_principal.inc.php');
			?>
			<div class="menu_secondaire">
				<ul class="menu2">
	  				<li><a href="<?php print $url_ret_adm_intervenant_edite?>">retour</a></li>
	  				<li><a href="#bas">bas</a></li>
				</ul>
			</div>
			<div id="corps">	 
				<form id="form1" name="form1" method="post" action="">
				
				  <?php if ($erreur) printf("<p class=\"erreur\">%s</p>\n", htmlentities($erreur,ENT_COMPAT,'ISO-8859-15'));
					afficherintervenants($intervenants, $courriel);
				
				?>
			  <h1>Edition d'un intervenant			      </h1>
			  <p>Attention: les changements effectu&eacute;s ici se r&eacute;percutent sur <em>toutes les s&eacute;ances</em> o&ugrave; intervient cet intervenant.  </p>
			  <h3>			    Utilisez ce formulaire uniquement pour RECTIFIER le nom, le pr&eacute;nom, la fonction ou le courriel ! <br />
			    NE CHANGEZ PAS L'INTERVENANT ! </h3>
			  <p>Pour changer d'intervenant, retournez sur la page pr&eacute;c&eacute;dente, d&eacute;cochez l'intervenant &agrave; &ocirc;ter et <em>cherchez</em> ou ajoutez (bouton <em>nouveau) </em>le nouvel intervenant. </p>
			  <table  border="0">
                    <tr>
                      <td><p>Civilit&eacute; *: </p></td>
                      <td><p>
                        <input name="civilite" type="radio" value="0" <?php if ($civilite==0) print "checked=\"checked\"" ?> />
                        M,
                        <input name="civilite" type="radio" value="1" <?php if ($civilite==1) print "checked=\"checked\"" ?>/>
                        Mme ou Mlle,
  <input name="civilite" type="radio" value="2" <?php if ($civilite==2) print "checked=\"checked\"" ?>/>
                      Autre (organisme, ...) </p></td>
                    </tr>
                    <tr>
                      <td><p>Nom *: </p></td>
                      <td><p>
                        <input name="nom" type="text" id="nom" value="<?php print htmlentities($nom,ENT_COMPAT,'ISO-8859-15') ?>" size="25" maxlength="25" />
                      </p></td>
                    </tr>
                    <tr>
                      <td><p>Pr&eacute;nom:</p></td>
                      <td><p>
                        <input name="prenom" type="text" id="prenom" value="<?php print htmlentities($prenom,ENT_COMPAT,'ISO-8859-15') ?>" size="25" maxlength="25" />
                      </p></td>
                    </tr>
                    <tr>
                      <td><p>Fonction: </p></td>
                      <td><p>
                        <select name="fonctions" id="fonctions" onclick="javascript:jsFonction(fonctions.value)">
                          <option value="*">Fonctions d&eacute;j&agrave; disponibles (choisissez)</option>
                          <?php afficheFonctions($h) ?>
                        </select>
                        <img src="images/b_import.png" width="22" height="22" />
                        <input name="fonction" type="text" id="fonction" value="<?php print htmlentities($fonction,ENT_COMPAT,'ISO-8859-15') ?>" size="20" maxlength="20" />
                      </p></td>
                    </tr>
                    <tr>
                      <td><p>Courriel: </p></td>
                      <td><p>
                        <input name="courriel" type="text" id="courriel" value="<?php print htmlentities($courriel,ENT_COMPAT,'ISO-8859-15')?>" size="50" maxlength="250" />
                      </p></td>
                    </tr>
                  </table>
			      <p>&nbsp;</p>
			      <p align="center">
			        <input name="commande" type="hidden" id="commande" value="0" />
			        <input name="valider" type="submit" class="bouton_standard" id="valider" value="Valider" />
			        &nbsp;&nbsp;
			        <input name="supprimer" type="button" class="bouton_standard" id="supprimer" value="Supprimer la fiche" onclick="javascript:jsSupprimer()" />
			      </p>
			    </form>
		    </div>
			<div class="menu_secondaire">
				<ul class="menu2">
					<li><a href="<?php print $url_ret_adm_intervenant_edite?>">retour</a></li>
					<li><a href="#haut">haut</a></li>
				</ul>
			</div>
			<a name="bas" id="bas"></a>	
		</div>
	</body>
</html>
