<?php
/* 
	Exportation du plan de formation au format csv
	Circon'script PHP Script
	Version 7.0.3
	CeCILL Copyright (C) 2008 Thierry Gangloff
	e-mail: thierry.gangloff@ac-strasbourg.fr
*/

	require('_session.php');
	if (isset($_GET['url_ret'])) {
		$url_ret_adm_plan_export=strip_tags($_GET['url_ret']);
		$_SESSION['circonscript7_url_ret_adm_plan_export']=$url_ret_adm_plan_export;
	}
	else if (isset($_SESSION['circonscript7_url_ret_adm_plan_export'])) {
		$url_ret_adm_plan_export=$_SESSION['circonscript7_url_ret_adm_plan_export'];
	}
	else $url_ret_adm_plan_export="adm_animations.php";
	
	$erreur='';
	require '_sqlconnect.inc.php';
	require '_fonctions.inc.php';
	require '_fonctions_animation.inc.php';
	if (!isset($_SESSION['circonscript7_id_circo'])) {
		header( 'Location: erreur.php?erreur=expiree');
		exit;
	}		
	$id_circo=$_SESSION['circonscript7_id_circo'];
	debugInit();
	$h=connect();
	ejecteSiFerme($h);
	$autoriser_plan_futur=queryValue("SELECT autoriser_plan_futur FROM circos WHERE id_circo=$id_circo",$h);
	if ($autoriser_plan_futur && isset($_SESSION['circonscript7_annee'])) $annee=$_SESSION['circonscript7_annee'];
	else $annee=0;
	if (isset($_POST['plan_final'])) 
		exportFinal($h);
	else if (isset($_POST['animations']))
		exportAnimations($h);
	
function exportAnimations($h)
{
	global $erreur,$id_circo,$annee;
	while (!$erreur) {
		$file=tempnam("./temp","csv");
		if (!$file) {
			$erreur="Impossible de crer un nom de fichier temporaire.";
			break;
		}
		$fp=fopen($file,'w');
		if (!$fp) {
			$erreur="Impossible de crer un fichier temporaire.";
			break;
		}

		// la liste de toutes les circos
		$q="SELECT id_circo, libelle_court FROM circos WHERE 1";
		$r=query($q,$h);
		$circos=array();
		while ($row=@mysqli_fetch_row($r)) $circos[$row[0]]=str_replace('"','""',$row[1]);
		fputs($fp,'"categorie";"domaine";"theme";"intitule";"annul";"description";"remarque";"lien";"max";"public";"date";"horaire";"lieu";"remarque_seance";"intervenants";"duree"');
		foreach($circos as $k=>$v) 
			fputs($fp,";\"$v\"");
		fputs($fp,"\n");
		// afficher toutes les animations et leurs exportations.
		$q="SELECT categories.codage, dates.id_date,seances.id_seance,domaines.libelle as domaine, intitule, annule,themes.libelle as theme, description, animations.remarque,animations.lien, max, public, seances.id_seance, date, lieu, dates.remarque as remarque_dates, duree, dates.horaire
			FROM (positions, animations,themes, seances, dates, domaines) 
			LEFT JOIN categories ON categories.id_categorie=animations.id_categorie 
			WHERE domaines.id_circo=$id_circo AND domaines.annee=$annee AND positions.id_domaine=domaines.id_domaine AND themes.id_theme= positions.id_theme AND animations.id_circo=$id_circo AND seances.id_anim=animations.id_anim AND dates.id_seance=seances.id_seance AND animations.id_anim=positions.id_anim
			ORDER BY domaines.tri, themes.tri, positions.tri, seances.tri, dates.tri";
		$r=query($q,$h);
		while ($row=@mysqli_fetch_array($r)) {
			$id_date=$row['id_date'];
			$r2=query("SELECT civilite, nom, prenom, fonction FROM intervenants, interventions WHERE interventions.id_intervenant=intervenants.id_intervenant AND interventions.id_date=$id_date",$h);
			$intervenants='';
			while ($row2=@mysqli_fetch_row($r2)) {
				$int=formateIntervenant($row2[0],$row2[1],$row2[2],$row2[3]);
				if ($int) {
					if ($intervenants) $intervenants.=', ';
					$intervenants.=$int;
				}
			}
			$categorie='"'.str_replace('"','""',$row['codage']).'"';
			fputs($fp,$categorie);
			fputs($fp,';');
			
			$domaine='"'.str_replace('"','""',$row['domaine']).'"';
			fputs($fp,$domaine);
			fputs($fp,';');
			
			$theme='"'.str_replace('"','""',$row['theme']).'"';
			fputs($fp,$theme);
			fputs($fp,';');
	
			$intitule='"'.str_replace('"','""',$row['intitule']).'"';
			fputs($fp,$intitule);
			fputs($fp,';');
			
			if ($row['annule']) fputs($fp,'"oui"');
			else fputs($fp,'"non"');
			fputs($fp,';');
			
			$description='"'.str_replace('"','""',$row['description']).'"';
			$description=str_replace("\r\n","\n",$description);
			fputs($fp,$description);
			fputs($fp,';');
	
			$remarque='"'.str_replace('"','""',$row['remarque']).'"';
			$remarque=str_replace("\r\n","\n",$remarque);
			fputs($fp,$remarque);
			fputs($fp,';');
			
			$lien='"'.$row['lien'].'"';
			fputs($fp,$lien);
			fputs($fp,';');
			
			$max=sprintf("\"%d\";",$row['max']);
			fputs($fp,$max);
		
			$public='"'.str_replace('"','""',$row['public']).'"';
			fputs($fp,$public);
			fputs($fp,';');
	
			$date=sprintf("\"%s\";",dateSqlEnSaisie($row['date']));
			fputs($fp,$date);
			
			if ($row['horaire']!='00:00:00')
				$horaire='"'.substr($row['horaire'],0,5).'";';
			else $horaire='"";';
			fputs($fp,$horaire);

			$lieu='"'.str_replace('"','""',$row['lieu']).'"';
			fputs($fp,$lieu);
			fputs($fp,';');
	
			$remarque_dates='"'.str_replace('"','""',$row['remarque_dates']).'"';
			$remarque_dates=str_replace("\r\n","\n",$remarque_dates);
			fputs($fp,$remarque_dates);
			fputs($fp,';');
	
			$intervenants='"'.str_replace('"','""',$intervenants).'"';
			fputs($fp,$intervenants);
			fputs($fp,';');
	
			$duree='"'.str_replace('.',',',$row['duree']).'"';// mettre virgule au lieu de point dcimal
			fputs($fp,$duree);
		
			$id_seance=$row['id_seance'];
			
			// pour chaque circo, indique OUI s'il y a partage accept, NON s'il y a partage refus, RIEN s'il n'y a pas de partage
			foreach($circos as $k=>$v) {
				$acc=queryValue("SELECT accepte FROM partages WHERE id_seance=$id_seance AND id_circo=$k",$h);
				if ($acc=='') fputs($fp,";\"\"");
				else if ($acc==0) fputs($fp,";\"non\"");
				else fputs($fp,";\"oui\"");
			}
			
			fputs($fp,"\n");
			
			
		}
		
		fclose($fp);
		exportFichier($file,"Animations_");
		exit;

	}		 

}	 
function exportFinal($h)
{
	global $erreur,$id_circo,$annee;
	while (!$erreur) {
		$file=tempnam("./temp","csv");
		if (!$file) {
			$erreur="Impossible de crer un nom de fichier temporaire.";
			break;
		}
		$fp=fopen($file,'w');
		if (!$fp) {
			$erreur="Impossible de crer un fichier temporaire.";
			break;
		}
		fputs($fp,'"catgorie";"domaine";"theme";"intitule";"annul";"description";"remarque";"lien";"max";"public";"date";"horaire";"lieu";"remarque_sance";"intervenants";"dure";"org";"nb_inscr";"nb_conv";"nb_inscr circo";"nb_conv circo"');
		fputs($fp,"\n");

		$q="SELECT categories.codage, dates.id_date,seances.id_seance,domaines.libelle as domaine, intitule, annule,themes.libelle as theme, description, animations.remarque, animations.lien, max, public, seances.id_seance, date, lieu, dates.remarque as remarque_dates, duree,circos.libelle_court AS org, dates.horaire
			FROM (partages,seances,dates,animations,positions,domaines,themes,circos)
			LEFT JOIN categories ON categories.id_categorie=animations.id_categorie 
			WHERE partages.id_circo=$id_circo AND partages.accepte<>0 AND partages.id_seance=seances.id_seance AND seances.id_anim=animations.id_anim AND dates.id_seance=seances.id_seance AND positions.id_anim=animations.id_anim AND positions.id_domaine=domaines.id_domaine AND domaines.id_circo=$id_circo AND domaines.annee=$annee AND positions.id_theme=themes.id_theme AND animations.id_circo=circos.id_circo
			ORDER BY domaines.tri,themes.tri,positions.tri,seances.tri,dates.tri"; 
		$r=query($q,$h);
		ecrireLigne($fp,$r);
		if ($fp) {
			fclose($fp);	
			exportFichier($file,"PlanFinal_");
			exit;
		}
		break;
	}	
}

function ecrireLigne($fp,$r)
{
	global $h,$id_circo;
	while ($row=@mysqli_fetch_array($r)) {
		$id_date=$row['id_date'];
		$r2=query("SELECT civilite, nom, prenom, fonction FROM intervenants, interventions WHERE interventions.id_intervenant=intervenants.id_intervenant AND interventions.id_date=$id_date",$h);
		$intervenants='';
		while ($row2=@mysqli_fetch_row($r2)) {
			$int=formateIntervenant($row2[0],$row2[1],$row2[2],$row2[3]);
			if ($int) {
				if ($intervenants) $intervenants.=', ';
				$intervenants.=$int;
			}
		}
		$categorie='"'.str_replace('"','""',$row['codage']).'"';
		fputs($fp,$categorie);
		fputs($fp,';');
		
		$domaine='"'.str_replace('"','""',$row['domaine']).'"';
		fputs($fp,$domaine);
		fputs($fp,';');
		
		$theme='"'.str_replace('"','""',$row['theme']).'"';
		fputs($fp,$theme);
		fputs($fp,';');

		$intitule='"'.str_replace('"','""',$row['intitule']).'"';
		fputs($fp,$intitule);
		fputs($fp,';');
		
		if ($row['annule']) fputs($fp,'"oui"');
		else fputs($fp,'"non"');
		fputs($fp,';');

		$description='"'.str_replace('"','""',$row['description']).'"';
		$description=str_replace("\r\n","\n",$description);
		fputs($fp,$description);
		fputs($fp,';');

		$remarque='"'.str_replace('"','""',$row['remarque']).'"';
		$remarque=str_replace("\r\n","\n",$remarque);
		fputs($fp,$remarque);
		fputs($fp,';');
		
		$lien='"'.$row['lien'].'"';
		fputs($fp,$lien);
		fputs($fp,';');

		$max=sprintf("\"%d\";",$row['max']);
		fputs($fp,$max);
	
		$public='"'.str_replace('"','""',$row['public']).'"';
		fputs($fp,$public);
		fputs($fp,';');

		$date=sprintf("\"%s\";",dateSqlEnSaisie($row['date']));
		fputs($fp,$date);
		
		if ($row['horaire']!='00:00:00')
			$horaire='"'.substr($row['horaire'],0,5).'";';
		else $horaire='"";';
		fputs($fp,$horaire);

		$lieu='"'.str_replace('"','""',$row['lieu']).'"';
		fputs($fp,$lieu);
		fputs($fp,';');

		$remarque_dates='"'.str_replace('"','""',$row['remarque_dates']).'"';
		$remarque_dates=str_replace("\r\n","\n",$remarque_dates);
		fputs($fp,$remarque_dates);
		fputs($fp,';');

		$intervenants='"'.str_replace('"','""',$intervenants).'"';
		fputs($fp,$intervenants);
		fputs($fp,';');

		$duree='"'.str_replace('.',',',$row['duree']).'"';// mettre virgule au lieu de point dcimal
		fputs($fp,$duree);
		fputs($fp,';');
		
		$org='"'.str_replace('"','""',$row['org']).'"';
		fputs($fp,$org);
		fputs($fp,';');
		
		$id_seance=$row['id_seance'];
		$inscr=queryValue("SELECT COUNT(*) FROM inscriptions WHERE id_seance=$id_seance",$h);		
		$conv=queryValue("SELECT COUNT(*) FROM convocations WHERE id_seance=$id_seance",$h);	
		$inscrCirco=queryValue("SELECT COUNT(*) FROM inscriptions,stagiaires,ecoles WHERE inscriptions.id_seance=$id_seance AND inscriptions.id_stagiaire=stagiaires.id_stagiaire AND stagiaires.id_ecole=ecoles.id_ecole AND ecoles.id_circo=$id_circo",$h);		
		$convCirco=queryValue("SELECT COUNT(*) FROM convocations,stagiaires,ecoles WHERE convocations.id_seance=$id_seance AND convocations.id_stagiaire=stagiaires.id_stagiaire AND stagiaires.id_ecole=ecoles.id_ecole AND ecoles.id_circo=$id_circo",$h);		
		
		fputs($fp,'"'.$inscr.'";');
		fputs($fp,'"'.$conv.'";');
		fputs($fp,'"'.$inscrCirco.'";');
		fputs($fp,'"'.$convCirco.'"');
		fputs($fp,"\n");
		
	} 
}
function formateIntervenant($civ,$nom, $prenom, $fonction)
{
	if ($nom=='' && $prenom=='') return'';
	$s='';
	if ($prenom=='') {
		if ($civ==0) $s.='M. ';
		else if ($civ==1) $s.='Mme ';
		$s.=$nom;
	}
	else $s.="$nom $prenom";
	if ($fonction) $s.=sprintf(" (%s)",$fonction);
	return $s;

}

?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="fr" lang="fr">
	<head>
		<title><?php print htmlentities($titre_site,ENT_COMPAT,'ISO-8859-15') ?></title>
		<meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-155" />
		<link rel="stylesheet" href="styles.css" type="text/css" /> <link rel="shortcut icon" type="image/x-icon" href="favicon.ico" />
	</head>
	<body>
		<div id="conteneur">
			<?php 
				include('menu_principal.inc.php');
			?>
			<div class="menu_secondaire">
				<ul class="menu2">
	  				<li><a href="<?php print $url_ret_adm_plan_export?>">retour</a></li>
	  				<li><a href="#bas">bas</a></li>
				</ul>
			</div>
			<div id="corps">	 
			  <h1>Exportation du plan de formation au format csv <?php 
			  	if ($annee) print '(plan futur)';
				?>
			  </h1>
			    <?php if ($erreur) print "<p class=\"erreur\">$erreur</p>";?> 
			      <form name="form1" method="post" action="">
			        <h2>Le plan de formation final
			          <input name="plan_final" type="submit" class="bouton_standard" id="plan_final" value="Exporter!" />
                    </h2>
			        <p>C'est le plan final pr&eacute;sent&eacute; aux stagaires de la circonscription, contenant aussi les animations import&eacute;es.</p>
			        <h2>Les animations propos&eacute;es par la circonscription
			          <input name="animations" type="submit" class="bouton_standard" id="animations" value="Exporter!" />
                    </h2>
			        <p>La liste de toutes les animations &eacute;labor&eacute;es par la circo, comprenant celles sp&eacute;cifiques  et celles export&eacute;es. Ne contient pas les animations import&eacute;es. Les animations accept&eacute;es par les autres circonscriptions sont indiqu&eacute;es par &quot;oui&quot;, celles refus&eacute;es sont indiqu&eacute;es par &quot;non&quot;. S'il n'y a pas d'exportation propos&eacute;e vers une circo, la case concern&eacute;e est vide. </p>
              </form>
			      </div>
			<div class="menu_secondaire">
				<ul class="menu2">
	  				<li><a href="<?php print $url_ret_adm_plan_export?>">retour</a></li>
		  			<li><a href="#haut">haut</a></li>
				</ul>
			</div>
			<a name="bas" id="bas"></a>	
		</div>
	</body>
</html>
