<?php
/* 
	Exportation du plan de formation au format csv
	Circon'script PHP Script
	Version 7.0.3
	CeCILL Copyright (C) 2008 Thierry Gangloff
	e-mail: thierry.gangloff@ac-strasbourg.fr
*/

	require('_session.php');
	if (isset($_GET['url_ret'])) {
		$url_ret_adm_plan_export_ical=strip_tags($_GET['url_ret']);
		$_SESSION['circonscript7_url_ret_adm_plan_export_ical']=$url_ret_adm_plan_export_ical;
	}
	else if (isset($_SESSION['circonscript7_url_ret_adm_plan_export_ical'])) {
		$url_ret_adm_plan_export_ical=$_SESSION['circonscript7_url_ret_adm_plan_export_ical'];
	}
	else $url_ret_adm_plan_export_ical="adm_animations.php";
	
	$erreur='';
	require '_sqlconnect.inc.php';
	require '_fonctions.inc.php';
	require '_fonctions_ical.inc.php';
	if (!isset($_SESSION['circonscript7_id_circo'])) {
		header( 'Location: erreur.php?erreur=expiree');
		exit;
	}		
	$id_circo=$_SESSION['circonscript7_id_circo'];
	debugInit();
	$h=connect();
	ejecteSiFerme($h);
	if (isset($_POST['exporter'])) 
		exporter($h);
	

function exporter($h)
{
	global $erreur,$id_circo;

	$exp=exporterICAL($h);
	if (!$exp) {
		$erreur="Impossible de gnrer le calendrier";
		return;
	}
	$circo=iconv("UTF-8","ISO-8859-15",queryValue("SELECT libelle_court FROM circos WHERE id_circo=$id_circo",$h));
	header('Content-type: text/calendar; charset=utf-8');
	header("Content-Disposition: inline; filename=animations-$circo.ics");	
	echo $exp;
	exit;
}
function exporterICAL($h)
{
	global $url_site,$id_circo;
	$q="SELECT NOW() AS dt_modif, dates.id_date, dates.date, dates.lieu, dates.horaire,dates.duree,  animations.intitule, animations.description, dates.remarque, seances.public, animations.remarque as anim_remarque, seances.id_seance 
	FROM (partages,seances,dates,animations,positions,domaines,circos)
	WHERE partages.id_circo=$id_circo AND partages.accepte<>0 AND partages.id_seance=seances.id_seance AND seances.id_anim=animations.id_anim AND animations.annule=0 AND dates.id_seance=seances.id_seance AND dates.date <'9999-12-30' AND positions.id_anim=animations.id_anim AND positions.id_domaine=domaines.id_domaine AND domaines.id_circo=$id_circo AND domaines.annee=0 AND animations.id_circo=circos.id_circo
	ORDER BY dates.date ASC, dates.horaire ASC";	 
	if ($url_site=='') {
		$domaine=$_SERVER['HTTP_HOST'];
		$path=$_SERVER['SCRIPT_NAME'];
		$t=explode('/',$path);
		if (sizeof($t)>1) {
			unset($t[sizeof($t)-1]);
			$path=implode('/',$t);
		}
		else $path='';
		$http='http';
		if (isset($_SERVER['HTTPS']) && $_SERVER['HTTPS']=='on') $http='https';
		$site="$http://$domaine$path";
	}
	else $site=$url_site;
	$r=query($q,$h);
	if (!$r) return '';
	if (@mysqli_num_rows($r)==0) return'';
	$ics=new MyICS();
	while ($row=@mysqli_fetch_array($r)) {
		$id_date=$row['id_date'];
		$id_seance=$row['id_seance'];
		$e=new MyEvent;
		$e->setText('uid',"Circoncript$id_date@$site");
		$titre=$row['intitule'];
		query("SET @k:=0",$h);
		$r2=query("SELECT rang, @k as nb FROM 
		( SELECT @k:=@k+1 as rang, dates.id_date FROM dates WHERE dates.id_seance=$id_seance AND dates.date<'9999-12-30' ORDER BY dates.date ASC, dates.horaire ASC) AS t WHERE t.id_date=$id_date;",$h);
		$num=$nbDates=1;
		$row2=@mysqli_fetch_row($r2);
		if (isset($row2)) {
			$num=$row2[0];
			$nbDates=$row2[1];
		}
		if($nbDates>1) $titre.=" ($num/$nbDates)";
		$e->setText('summary',$titre); 
		$descr=$row['description'];
		if ($row['anim_remarque']) {
			if ($descr) $descr.="\r\n";
			$descr.=$row['anim_remarque'];
		}
		if ($row['public']) {
			if ($descr) $descr.="\r\n";
			$descr.="Public : ".$row['public'];
		}
		if ($row['remarque']) {
			if ($descr) $descr.="\r\n";
			$descr.="Remarque : ".$row['remarque'];
		}
		$int=listeIntervenants("SELECT civilite, nom, prenom, fonction FROM intervenants, interventions WHERE interventions.id_date=$id_date AND interventions.id_intervenant=intervenants.id_intervenant ORDER BY nom ASC",$h);
		if ($int) {
			if ($descr) $descr.="\r\n";
			$descr.="Intervenant(s) : ".$int;
		}
		$r1=@mysqli_query($h, "SELECT COUNT(*) FROM inscriptions WHERE id_seance=$id_seance");
		$row1=@mysqli_fetch_row($r1);
		$nb_inscr=$row1[0];
		$r1=@mysqli_query($h, "SELECT COUNT(*) FROM convocations WHERE id_seance=$id_seance");
		$row1=@mysqli_fetch_row($r1);
		$nb_conv=$row1[0];
		if ($descr) $descr.="\r\n";
		$descr.="Nb. inscrits: $nb_inscr\r\nNb. convoqus: $nb_conv";
		$e->setText('description',$descr);
		$e->setText('location',$row['lieu']);
		$e->setDates($row['date'],$row['horaire'],$row['duree']);
		$e->setLastModified($row['dt_modif']);
		$ics->addEvent($e);
	}
	return $ics->exporter();
}
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="fr" lang="fr">
	<head>
		<title><?php print htmlentities($titre_site,ENT_COMPAT,'ISO-8859-15') ?></title>
		<meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-155" />
		<link rel="stylesheet" href="styles.css" type="text/css" /> <link rel="shortcut icon" type="image/x-icon" href="favicon.ico" /></head>
	<body>
		<div id="conteneur">
			<?php 
				include('menu_principal.inc.php');
			?>
			<div class="menu_secondaire">
				<ul class="menu2">
	  				<li><a href="<?php print $url_ret_adm_plan_export_ical?>">retour</a></li>
	  				<li><a href="#bas">bas</a></li>
				</ul>
			</div>
			<div id="corps">	 
			  <h1>Exportation du plan de formation au format icalendar	(ics)		  </h1>
			    <?php if ($erreur) print "<p class=\"erreur\">$erreur</p>";?> 
		      <form name="form1" method="post" action="">
		        <h2>Les animations propos&eacute;es par la circonscription dans le plan actuel </h2>
			        <p>Sont export&eacute;es les s&eacute;ances dont la date est connue. Sont donc exclues : les s&eacute;ances de t&eacute;l&eacute;formation, les s&eacute;ances dont la date est ind&eacute;finie, les animations annul&eacute;es. Toutes les animations sont concern&eacute;es, y compris les animations import&eacute;es. Seul le plan &quot;actuel&quot; est concern&eacute;. </p>
			        <p>Vous pouvez utiliser le fichier au format icalendar -ICS  pour alimenter vos calendriers &eacute;lectroniques.</p>
		        <p>Attention, il ne s'agit pas d'une synchronisation ! Les modifications effectu&eacute;es dans Circon'script ne sont pas automatiquement r&eacute;perctu&eacute;es dans votre calendrier &eacute;lectronique. Si vous voulez mettre &agrave; jour le calendrier &eacute;lectronique, il faut exporter ici un nouveau fichier ICS et le r&eacute;importer dans votre calendrier, ou proc&eacute;der &agrave; des modifications manuelles dans votre calendrier. </p>
			        <h2 align="center">
			          <input name="exporter" type="submit" class="bouton_standard" id="exporter" value="Exporter!" />
		        </h2>
			        <h2>Remarque sur l'intitul&eacute; des animations</h2>
			        <p>Lorsqu'il y a des s&eacute;ances group&eacute;es (obligation de participer &agrave; plusieurs s&eacute;ances) l'intitul&eacute; des animations peut afficher  deux nombres : (1/2), (2/4) ... </p>
			        <p>Le premier nombre est le num&eacute;ro d'ordre de la s&eacute;ance dans la s&eacute;rie.</p>
			        <p>Le second nombre est le nombre <em>total</em> de s&eacute;ances <em>de pr&eacute;sentiel</em> pour cette animation et ces stagiaires. Les t&eacute;l&eacute;formations et les animations dont les dates sont &agrave; d&eacute;finir ne sont pas prises en compte.    </p>
		      </form>
	      </div>
			<div class="menu_secondaire">
				<ul class="menu2">
	  				<li><a href="<?php print $url_ret_adm_plan_export_ical?>">retour</a></li>
		  			<li><a href="#haut">haut</a></li>
				</ul>
			</div>
			<a name="bas" id="bas"></a>	
		</div>
	</body>
</html>
