<?php
/*	
	Exporter tous les stagiaires dans leurs coles, pour toutes circos
	Circon'script PHP Script
	Version 7.0.3
	CeCILL Copyright (C) 2008 Thierry Gangloff
	e-mail: thierry.gangloff@ac-strasbourg.fr
*/
	require('_session.php');
	if (isset($_GET['url_ret'])) {
		$url_ret_adm_ecoles_export=strip_tags($_GET['url_ret']);
		$_SESSION['circonscript7_url_ret_adm_ecoles_export']=$url_ret_adm_ecoles_export;
	}
	else if (isset($_SESSION['circonscript7_url_ret_adm_ecoles_export'])) {
		$url_ret_adm_ecoles_export=$_SESSION['circonscript7_url_ret_adm_ecoles_export'];
	}
	else $url_ret_adm_ecoles_export="administration.php";
	if (!isset($_SESSION['circonscript7_administration'])) {
		header( 'Location: erreur.php?erreur=expiree');
		exit;
	}		
	
	$erreur='';
	require '_sqlconnect.inc.php';
	require '_fonctions.inc.php';
	$h=connect();
	debugInit();
	if (isset($_POST['Submit'])) {
		exporteEcolesCSV($h);
	}
	
function exporteEcolesCSV($h)
{
	global $erreur;
	
	while (!$erreur) {
		$file=tempnam('./temp',"csv");	
		if (!$file) {
			$erreur="Impossible de crer un nom de fichier temporaire.";
			break;
		}
		$fp=fopen($file,'w');
		if (!$fp) {
			$erreur="Impossible de crer un fichier temporaire.";
			break;
		}
		fputs($fp,'"CODCIRCO";"CIRCO";"NUMRNE";"ECOLE";"COURRIEL_EC";"NOM";"PRENOM";"EMAIL";"NIVEAU";"QUOTSERV";"QUOTA";"QUOTA_REEL";"GROUPE";"LOGIN";"SSO_LOGIN";"MOT_PASSE";"CRYPTAGE"');
		fputs($fp,"\n");
		$q="SELECT circos.rne AS codcirco, circos.libelle_court as circo, ecoles.rne as numrne, ecoles.nom as ecole, ecoles.courriel as courriel_ec, stagiaires.nom, stagiaires.prenom, stagiaires.courriel AS email, stagiaires.niveau,stagiaires.quotite, stagiaires.quota, stagiaires.quota_reel, groupes.libelle AS groupe, utilisateurs.login, utilisateurs.mdp, utilisateurs.codage, utilisateurs.sso_login FROM (ecoles, circos,stagiaires,utilisateurs) LEFT JOIN groupes ON stagiaires.id_groupe=groupes.id_groupe WHERE ecoles.id_circo=circos.id_circo AND stagiaires.id_ecole=ecoles.id_ecole AND stagiaires.id_uti=utilisateurs.id_uti ORDER BY circos.id_circo";
		$r=query($q,$h);
		while ($row=@mysqli_fetch_array($r)) {
			$mdp=$row['mdp'];
			if ($row['codage']==2) $mdp=bin2hex($mdp); //si aes
			$codage='non';
			switch($row['codage']) {
				case 0: $codage='non';break;
				case 1: $codage='md5'; break;
				case 2: $codage='aes'; break;
			}
			fputs($fp,sprintf("\"%s\";\"%s\";\"%s\";\"%s\";\"%s\";\"%s\";\"%s\";\"%s\";\"%s\";\"%s\";\"%s\";\"%s\";\"%s\";\"%s\";\"%s\";\"\"\"%s\"\"\";\"%s\"",
				$row['codcirco'], 
				$row['circo'],
				$row['numrne'],
				str_replace('"','""',$row['ecole']),
				$row['courriel_ec'],
				$row['nom'],
				$row['prenom'],
				$row['email'],
				$row['niveau'],
				str_replace('.',',',$row['quotite']),
				str_replace('.',',',$row['quota']),
				str_replace('.',',',$row['quota_reel']),
				str_replace('"','""',$row['groupe']),
				str_replace('"','""',$row['login']),
				str_replace('"','""',$row['sso_login']),
				str_replace('"','""',$mdp),
				$codage
				)
			);
			fputs($fp,"\n");
		
		}
		if ($fp) {
			fclose($fp);	
			exportFichier($file,"Ecoles_stagiaires_");
			exit;
		}
		break;
	}
}
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="fr" lang="fr">
	<head>
		<title><?php print htmlentities($titre_site,ENT_COMPAT,'ISO-8859-15') ?></title>
		<meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-15" />
		<link rel="stylesheet" href="styles.css" type="text/css" /> <link rel="shortcut icon" type="image/x-icon" href="favicon.ico" />
	</head>
	<body>
		<div id="conteneur">
			<?php 
				include('menu_principal.inc.php');
			?>
			<div class="menu_secondaire">
				<ul class="menu2">
	  				<li><a href="<?php print $url_ret_adm_ecoles_export?>">retour</a></li>
	  				<li><a href="#bas">bas</a></li>
				</ul>
			</div>
		  <div id="corps">
		    <h1>Exportation de la liste des stagiaires avec leurs &eacute;coles </h1>
		    <h2>Liste compl&egrave;te des stagiaires dans les &eacute;coles pour toutes les circonscriptions </h2>
		    <p>Format csv, pour tableur. </p>
			<form name="form1" method="post" action="">
		      <p align="center">
		        <input name="Submit" type="submit" class="bouton_standard" value="Exporter" />
</p>
		    </form>
		    <p>&nbsp;</p>
		    <p>&nbsp; </p>
		  </div>
			<div class="menu_secondaire">
				<ul class="menu2">
					<li><a href="<?php print $url_ret_adm_ecoles_export?>">retour</a></li>
					<li><a href="#haut">haut</a></li>
				</ul>
			</div>
			<a name="bas" id="bas"></a>	
		</div>
	</body>
</html>