<?php
/* 
	Modifier mot de passe provisoire
	Circon'script PHP Script
	Version 7.0.3
	CeCILL Copyright (C) 2008 Thierry Gangloff
	e-mail: thierry.gangloff@ac-strasbourg.fr
*/
	require('_session.php');
	require '_sqlconnect.inc.php';
	require '_fonctions_mdp.inc.php';

	$erreur='';
	debugInit();
	$h=connect();
	ejecteSiFerme($h);
	
	if (!isset($_SESSION['circonscript7_id_uti'])) {
		header('Location:erreur.php?erreur=expiree');
		exit;
	}
	$id_uti=$_SESSION['circonscript7_id_uti'];
	
	if(isset($_SESSION['circonscript7_sso'])) {
		header('Location:erreur.php?erreur=portailSSO');
		exit;
	}
	
	$utilisateur_pouvoir=queryValue("SELECT COUNT(*) FROM intervenants WHERE id_uti=$id_uti",$h);
	if (!$utilisateur_pouvoir) 
		$utilisateur_pouvoir=queryValue("SELECT COUNT(*) FROM administrateurs WHERE id_uti=$id_uti",$h);
	
	if (isset($_GET['url_ret'])) {
		$url_ret_compte_mdp=strip_tags($_GET['url_ret']);
		$_SESSION['circonscript7_url_ret_compte_mdp']=$url_ret_compte_mdp;
	}
	else if (isset($_SESSION['circonscript7_url_ret_compte_mdp'])) {
		$url_ret_compte_mdp=$_SESSION['circonscript7_url_ret_compte_mdp'];
	}
	else $url_ret_compte_mdp="compte.php";

	if (isset($_SESSION['circonscript7_semence'])) $semence=$_SESSION['circonscript7_semence'];
	else $semence='';
	// scurit=0: mot de passe simple
	// securite=1: mot de passe renforc
	$securite=1;
	if (isset($_SESSION['circonscript7_compte_securite'])) $securite=$_SESSION['circonscript7_compte_securite'];
	// si provisoire =1, modification du mdp provisoire: ne pas quitter tant que ce n'est pas fait.
	$provisoire=0;
	if (isset($_SESSION['circonscript7_compte_provisoire'])) $provisoire=$_SESSION['circonscript7_compte_provisoire'];
	$r=query("SELECT login, codage,hash FROM utilisateurs WHERE id_uti=$id_uti",$h);
	$row=@mysqli_fetch_row($r);
	$login=$row[0];
	$codage=$row[1];
	$hash=$row[2];
	if ($provisoire) $codage=0;

	if (isset($_POST['commande'])&& $semence!='') while(1){
		if ($cle_aes=="") {
			$erreur="Opration annule: l'administrateur principal n'a pas dfini de cl de cryptage. Impossible de modifier un mot de passe.";
			break;
		}
		if (!$semence) {
			header('Location: erreur.php?erreur=expiree');
			exit;
		}
		$mdp=decodeXor($semence,normaliseT($_POST['commande'],32));
		if (strlen($mdp)>16) {
			$erreur="Opration annule: le mot de passe est trop long.";
			break;
		}
		if ( ($securite==1 && strlen($mdp)<8)  || ($securite==0 && strlen($mdp)<5)) {
			$erreur="Opration annule: le mot de passe est trop court.";
			break;
		}
		$majuscule=false;
		$minuscule=false;
		$incorrect=false;
		$chiffre=false;
		for ($i=0;$i<strlen($mdp);++$i) {
			$c=$mdp[$i];
			if ($c>='A' && $c<='Z') $majuscule=true;
			else if ($c>='a' && $c<='z') $minuscule=true;
			else if ($c>='0' && $c<='9') $chiffre=true;
			else if ($c!=' ' && $c!='_' && $c!='-') $incorrect=true;
		}
		if ($incorrect) {
			$erreur="Opration annule: caractres incorrects dans le mot de passe.";
			break;
		}
		if ($securite && (!$majuscule || !$minuscule || !$chiffre)) {
			$erreur="Opration annule: il manque une majuscule, ou une minuscule, ou un chiffre.";
			break;
		}
		$valHash='NULL';
		if ($hash=='bloque') $valHash="'bloque'";
		
		if (isset($_POST['encodage'])) query("UPDATE utilisateurs SET mdp=MD5('$mdp'), codage=1, hash=$valHash WHERE id_uti=$id_uti",$h);
		else query("UPDATE utilisateurs SET mdp=AES_ENCRYPT('$mdp','$cle_aes'), codage=2,hash=$valHash WHERE id_uti=$id_uti",$h);
		if (!$erreur) {
			if ($provisoire) {
				header("Location: compte.php"); 
				exit;
			}
			else $erreur="Votre mot de passe a t chang. Cliquez sur 'retour'.";
		}
		break;
	}	
	$semence=semence();
	$_SESSION['circonscript7_semence']=$semence;
	
	
	
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="fr" lang="fr">
	<head>
		<title><?php print htmlentities($titre_site,ENT_COMPAT,'ISO-8859-15') ?></title>
		<meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-15" />
		<link rel="stylesheet" href="styles.css" type="text/css" /> <link rel="shortcut icon" type="image/x-icon" href="favicon.ico" />
		<script type="text/javascript" src="mdp.js"></script>
		<script type="text/javascript">
		<!--
		function jsTeste()
		{
			var mdp1, mdp2;
			if (document.getElementById('mdp1').style.display=="inline") mdp1=document.getElementById("mdp1").value;
			else mdp1=document.getElementById("mdp1b").value;
			if (document.getElementById('mdp2').style.display=="inline") mdp2=document.getElementById("mdp2").value;
			else mdp2=document.getElementById("mdp2b").value;
			
			mdp=testeMdp(mdp1,mdp2,<?php if ($securite) print'8,1'; else print '5,0'; ?>);
			if (mdp=="") return;		
			mdp_hex=encodeMdp('<?php print $semence?>',mdp);
			if (mdp_hex=="") return;
			
			document.form1.commande.value=mdp_hex;// n'envoyer que la forme teste
			document.form1.mdp1.value='';// effacer pour viter mission des mots de passe sur internet
			document.form1.mdp2.value='';
			document.form1.mdp1b.value='';
			document.form1.mdp2b.value='';
			document.form1.submit();
		}
		function montrerMdp()
		{
			var b=document.form1.montrer.checked;
			if (b) {
				document.getElementById('mdp1').style.display="none";
				document.getElementById('mdp2').style.display="none";
				document.getElementById('mdp1b').style.display="inline";
				document.getElementById('mdp2b').style.display="inline";
				document.getElementById('mdp1b').value=document.getElementById("mdp1").value;
				document.getElementById('mdp2b').value=document.getElementById("mdp2").value;
				
			}
			else {
				document.getElementById('mdp1').style.display="inline";
				document.getElementById('mdp2').style.display="inline";
				document.getElementById('mdp1b').style.display="none";
				document.getElementById('mdp2b').style.display="none";
				document.getElementById('mdp1').value=document.getElementById("mdp1b").value;
				document.getElementById('mdp2').value=document.getElementById("mdp2b").value;
			}			
		
		}
		//-->			
		</script></head>
	<body>
		<div id="conteneur">
			<?php 
				if ($provisoire)
					include('menu_principal_vide.inc.php');
				else
					include('menu_principal.inc.php');
			?>
			<div class="menu_secondaire">
			<ul class="menu2">
				<?php if (!$provisoire) print"<li><a href=\"$url_ret_compte_mdp\">retour</a></li>\n";?>
			  <li><a href="#bas">bas</a></li>
			</ul>
			</div>  
		  <div id="corps">	 
				<h1>Changement de votre mot de passe <?php if ($provisoire) print ' provisoire'?></h1>

				  <?php if ($erreur) printf ("<p class=\"erreur\">%s</p>\n",htmlentities($erreur,ENT_COMPAT,'ISO-8859-15'));
				  	else if ($provisoire) print "<p class=\"erreur\">Votre mot de passe provisoire doit &ecirc;tre chang&eacute;</p>\n";
					if ($use_sso)
						print"<p><b>Attention:</b>le mot de passe choisi ici est valable uniquement dans Circon'script. Il ne modifie pas le mot de passe de connexion au portail $sso_portail.</p>";
					if ($securite==1) print "<p><b>Vous &ecirc;tes administrateur:</b> le mot de passe est renforc&eacute;. Il doit comprendre au moins <em>8 caract&egrave;res</em> dont au moins <em>un chiffre, une lettre, une majuscule.</em></p>\n";
					else print "<p>Le mot de passe doit comprendre au moins <em>5 caract&egrave;res.</em></p>\n";
				  ?>
				<p>Les seuls caract&egrave;res autoris&eacute;s sont : les lettres non accentu&eacute;es, les chiffres, le soulign&eacute; (_), le trait d'union (-) et l'espace &agrave; l'int&eacute;rieur du mot de passe. Maximum 16 signes. </p>
				<form method="post" action="" name="form1">
				  <table>
<tr class="table_entete">
                      <td colspan="3">Votre identifiant : <?php print htmlentities($login,ENT_COMPAT,'ISO-8859-15') ?></td>
                </tr>
                    <tr class="survol">
                      <td>Mot de passe * :</td>
                      <td><p>
                        <input name="mdp1"  type="password" id="mdp1" size="17" maxlength="17" />
                        <input name="mdp1b" type="text" id="mdp1b" size="17" maxlength="17" />
                      </p></td>
                      <td rowspan="2"><input name="montrer" type="checkbox"  value="1" onclick="javascript:montrerMdp()"  />                      
                      Montrer les caract&egrave;res saisi<em>s</em>.</td>
                    </tr>
                    <tr class="survol">
                      <td>R&eacute;p&eacute;ter le mot de passe * : </td>
                      <td><p>
                        <input name="mdp2" type="password"  id="mdp2" size="17" maxlength="17" />
                        <input name="mdp2b" type="text" id="mdp2b" size="17" maxlength="17" />
                      </p></td>
                    </tr>
              </table>
                    <?php if ($utilisateur_pouvoir) {
						print "<p><input type=\"checkbox\" name=\"encodage\" value=\"1\"";
						if ($codage==1) print ' checked="checked"';
						print " />\n";
						print "Cryptage renforc&eacute; du mot de passe, pour un maximum de s&eacute;curit. Cochez cette case si vous utilisez ce m&ecirc;me mot de passe pour acc&eacute;der &agrave; des applications sensibles. Si vous cochez, le mot de passe sera ind&eacute;cryptable et Circon'script ne pourra pas vous l'envoyer par courriel si vous l'oubliez. Comme le mot de passe est stock&eacute; sous cette forme crypt&eacute;e dans la base de donn&eacute;es, l'administrateur ne peut le lire. Il faudra le r&eacute;initialiser si vous l'oubliez. Le cryptage employ&eacute; est le MD5. <em>Cette forme de cryptage est r&eacute;serv&eacute;e aux administrateurs et aux intervenants.</em>";
						print "</p>\n";		
					}
					?>

		      <div align="center">
<input name="commande" type="hidden" id="commande" />
                    <input name="valider" type="button" class="bouton_standard" value="Enregistrer" onclick="javascript:jsTeste()" />
              </div>
	        </form>
			<script type="text/javascript"> montrerMdp() </script>
	      </div>
			<a name="bas" id="bas"></a>	
		<div class="menu_secondaire">
		<ul class="menu2">
				<?php if (!$provisoire) print"<li><a href=\"$url_ret_compte_mdp\">retour</a></li>\n";?>		
		  <li><a href="#haut">haut</a></li>
		</ul>
		</div>		
	</div>
	</body>
</html>
