<?php
/* 
	index
	Circon'script PHP Script
	Version 7.0.3
	CeCILL Copyright (C) 2008 Thierry Gangloff
	e-mail: thierry.gangloff@ac-strasbourg.fr
*/

	require('_session.php');

	require '_sqlconnect.inc.php';
	require '_fonctions.inc.php';
	require '_fonctions_stagiaire.inc.php';
	require '_fonctions_mdp.inc.php';
	require '_version.inc.php';
	require '_securite.inc.php';
	debugInit();
	$erreur='';
	$login='';
	$mdp='';
	$remember=false;
	$login_connexion='';
	$afficher_logo=false;
	$_SESSION['circonscript7_session_menu_page']=-1;
	$h=connect();
	
	
	//installation ?
	if ($host=='' && $user=='' && $password=='' && $bdd=='' && file_exists('installe/index.php')) {
		$_SESSION['circonscript7_installation']=1;
		header('Location: installe/index.php');
		exit;
	}
	// utilisateur OK ? aller dans compte
	if (isset($_SESSION['circonscript7_id_uti'])&&$_SESSION['circonscript7_id_uti']>0) {
		header('Location: compte.php');
		exit;
	}
	// site ferm ?
	$r=query("SELECT ferme, actualite, message_accueil,autorisations, bannissement, ban_duree,ban_tentatives,ban_oubli FROM general",$h);
	$row=@mysqli_fetch_row($r);
	$ferme=isset($row)?$row[0]:1;
	if ($ferme) {
		header('Location: site_ferme.php');
		exit;
	}
	$actu=isset($row)?$row[1]:'';
	$accueil=isset($row)?$row[2]:'';
	$autorisations=isset($row)?$row[3]:'';
	$bannissement=isset($row)?$row[4]:0;
	$ban_duree=isset($row)?$row[5]:30;
	$ban_tentatives=isset($row)?$row[6]:10;
	$ban_oubli=isset($row)?$row[7]:10;


	$portailSSO=$use_sso && ($sso_login!='' || $sso_usermail!='');
	// services SSO et arrive sur la page sans validation du formulaire ? Tente de se connecter
	if ($portailSSO && !isset($_POST['identifiant'])) sso_connect($h,$ferme,$sso_login,$sso_usermail);
	// pas de connexion sso OU utilisation de l'interface standard dans le portail SSO...	
	if ($bannissement) testSecurite($h,getClientIp(),$ban_duree);// le bannissement IP se fait uniquement hors accs SSO
	// rcuprer le cookie de connexion rapide
	if (!isset($titre_site)) $titre_site="Circon'script"; 
	if (isset($_COOKIE["CirconscriptId$hash"])) {
		$login_connexion=encodeCookieLogin($_COOKIE["CirconscriptId$hash"],false);
		$remember=true;
	}
	// ouvrir ventuellement les inscriptions des circos qui sont automatises
	$r=query("SELECT id_circo FROM circos WHERE stag_etat=0 AND dt_ouverture < NOW()",$h);
	while ($row=@mysqli_fetch_row($r)) automatisationCirco($row[0],$h);
	
	// ne pas mettre de circo qui n'a pas dfini d'cole.
	$q="SELECT circos.id_circo,libelle FROM circos,ecoles WHERE circos.type_circo=0 AND ecoles.id_circo=circos.id_circo AND stag_etat=1 AND stag_enregistrement<>0 GROUP BY id_circo ORDER BY libelle";
	$r=query($q,$h);
	$circos=array();
	while($row=@mysqli_fetch_row($r)) 
		$circos[$row[0]]=htmlentities($row[1],ENT_COMPAT,'ISO-8859-15');
	if (isset($_SESSION['circonscript7_tentatives'])) $tentatives=$_SESSION['circonscript7_tentatives'];
	else $tentatives=0;
	if ($tentatives >=5) {
		header('Location: erreur.php?erreur=tentatives');
		exit;
	}
	if (strlen($autorisations)>=3) $afficher_logo=$autorisations[2]=='1';
	if (isset($_POST['identifiant'])) while(1) {
		if ($tentatives>=5) {
			$erreur="Trop de tentatives de connexion ont eu lieu. La connexion est dsactive. Veuillez fermer votre navigateur puis le relancer.";
			break;
		}
		$remember=isset($_POST['chkMemorise']);
		$login='';
		if (isset($_POST['identifiant'])) $login=normaliseT($_POST['identifiant'],256);
		if (!$login){
			$erreur="Veuillez indiquer un identifiant de connexion. ";
			break;
		}
		$mdp='';
		// le mot de passe vient cod en md5 sur 32 octets
		if (isset($_POST['mdp_hex'])) $mdp=normalise($_POST['mdp_hex'],32);
		if (strlen($mdp)!=32){
			$erreur="Veuillez indiquer un mot de passe de connexion valide. ";
			break;
		}
		$r=connexion($login,$mdp,$h);	
		if ($r<=0) {
			if ($r<0) $erreur="Mot de passe incorrect. ";
			else $erreur="Identifiant incorrect";
			++$tentatives;
			$_SESSION['circonscript7_tentatives']=$tentatives;
			if ($bannissement) majSecurite($h,$_SERVER['REMOTE_ADDR'],$login,$ban_oubli,$ban_tentatives);
		}
		else {
			$id_uti=$r;
			// seul le superadmin peut se connecter de l'extrieur s'il possde un sso_login et si sso_bloque_extrieur est activ
			if ($use_sso && $sso_bloque_exterieur) {
				$nb=queryValue("SELECT COUNT(*) FROM administrateurs WHERE id_uti=$id_uti AND type_admin=1",$h);
				if ($nb==0) {
					$sso_login_lu=queryValue("SELECT sso_login FROM utilisateurs WHERE id_uti=$id_uti",$h);
					// si l'utilisteur a un sso_login dans la base et qu'il n'est pas dj sur le portail SSO (tests sur sso_login et sso_usermail), alors refuser
					if (!empty($sso_login_lu) && empty($sso_login) && empty($sso_usermail)) {
						enregistreAcces($id_uti,$h,10);//enregistre la tentative d'accs, pour info.
						header('Location: erreur.php?erreur=portail');
						exit;
					}
				}		
			}
			enregistreAcces($id_uti,$h,$portailSSO?6:0);
			if (version_compare(phpversion(),"5.1.0",'>=')) session_regenerate_id(true);
			else session_regenerate_id();
			$_SESSION['circonscript7_id_uti']=$id_uti;
			$_SESSION['circonscript7_tentatives']=0;
			if(!$remember && $login!='') { // ne pas se souvenir et il existe un cookie: supprimer le cookie	
				$timeout=time()-24*3600;
				setcookie("CirconscriptId$hash",'',$timeout);
			}
			if ($remember) {
				$timeout=time()+365*24*60*60;
				setcookie("CirconscriptId$hash",encodeCookieLogin($login,true),$timeout);
			}
			header('Location: compte.php');
			exit;
		}
		$login_connexion=$login;
		break;
	}
function afficheCircos($circos)
{
	if (count($circos)==0) return;
	print "<table>\n";
	$col=0;

	foreach($circos as $id_circo=>$lib) { 
		if ($col==0) print "<tr>";
		print"<td><p><a href=\"ins_nouveau_stagiaire.php?id_circo=$id_circo\">$lib</a></p></td>\n";
		++$col;
		if ($col==3) {
			$col=0;
			print "</tr>\n";
		}
	}
	if ($col>0) {
		while ($col++<3) print "<td>&nbsp;</td>";
		print "</tr>\n";
	}
	print "</table>\n";
}
function afficheAccueil($msg)
{
	if ($msg=='') return;
	print "<p class=\"attention\">";
	afficheActualite($msg,false,true);
	print "</p>\n";
	
}
function afficheCharge($h)
{
	$nb_uti=queryValue("SELECT COUNT(*) FROM utilisateurs",$h);
	if ($nb_uti=='') return;
	$nb_connect=queryValue("SELECT COUNT(*) FROM utilisateurs WHERE dt_connexion > (NOW()-INTERVAL 30 MINUTE)",$h);
	if ($nb_connect=='') return;
	$n=queryValue("SELECT COUNT(*) FROM utilisateurs WHERE dt_connexion >= (NOW()-INTERVAL 1 DAY)",$h);
	
	if ($nb_uti>1)  
		print "<p>Vous &ecirc;tes en ce moment $nb_uti utilisateurs.</p>\n";
	if ($n>1) print "<p>$n personnes diffrentes se sont connect&eacute;es dans les derni&egrave;res 24 h.</p>\n";
	else if ($n==1) print "<p>1 personne s'est connect&eacute;e dans les derni&egrave;res 24 h.</p>\n";
	else print "<p>Personne ne s'est connect&eacute; dans les derni&egrave;res 24h.</p>\n";
	if ($nb_connect>1) 
		print "<p>$nb_connect personnes diffrentes se sont connect&eacute;es dans la derni&egrave;re demi-heure.</p>\n";
	else if ($nb_connect==1)
		print "<p>1 personne s'est connect&eacute;e dans la derni&egrave;re demi-heure.</p>\n";
	else 
		print "<p>Personne ne s'est connect&eacute; dans la derni&egrave;re demi-heure</p>\n";
}

?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="fr" lang="fr">
	<head>
		<title><?php print htmlentities($titre_site,ENT_COMPAT,'ISO-8859-15')?></title>
		<meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-15" />
		<link rel="stylesheet" href="styles.css" type="text/css" />  <link rel="shortcut icon" type="image/x-icon" href="favicon.ico" />
		<script type="text/javascript" src="mdp.js"></script>
		<script type="text/javascript" src="md5.js"></script>
	    <script type="text/JavaScript" charset="ISO-8859-15">
<!--
	function car(event)
	{
		if (event.keyCode==13)  validation();
	}

	function validation()
	{
		
		var mdp=document.form1.mdp.value;
		var login=document.form1.identifiant.value;
		if (login=='') {
			alert("Veuillez indiquer un identifiant");
			return;
		}
		if (!testeMdpSimple(mdp)) return;
		var mdp_encode=MD5(mdp);
		if (mdp_encode.length!=32) return;
		document.form1.mdp_hex.value=mdp_encode;
		document.form1.mdp.value='';
		document.form1.submit();	
	}

//-->
        </script>
	    <style type="text/css">
<!--
.Style1 {font-size: x-large}
.Style2 {font-size: large}
.Style3 {
	font-size: large;
	color: #990000;
	font-weight: bold;
}
.Style5 {font-size: small}
-->
        </style>
</head>
	<body>
		<div id="conteneur">
			<?php 
				include('menu_principal.inc.php');
			?>
		  <div id="corps" class="fond">	 
				<script type="text/javascript">
				</script>
			<noscript>
			<h2 class="erreur">JavaScript n'est pas activ&eacute; dans votre navigateur. Circon'script ne peut pas fonctionner correctement. Modifiez les options de votre navigateur pour autoriser JavaScript.</h2>
			</noscript>
				<h1>Bienvenue sur Circon'script, un scribe &eacute;lectronique au service de vos formations. </h1>
                <table>
                  <tr>
                    <td rowspan="5" align="left" valign="top"><img src="images/engrenages2.png" alt="engrenages" width="140" height="226" /></td>
                    <td valign="top"><?php if ($erreur) printf( "<p class=\"erreur\">%s</p>\n",htmlentities($erreur,ENT_COMPAT,'ISO-8859-15'));?>
                      <h1>Actualit&eacute;</h1>
                      <?php
						if ($actu=='') afficheActualite("Le site est oprationnel.",false,true);
						else afficheActualite($actu);
					?>
<h1>Acc&egrave;s standard </h1>
                      <?php afficheAccueil($accueil) ?>
       <form id="form1" name="form1" method="post" action="">
         <table>
                      <tr>
                        <td width="100"><p>Identifiant: </p></td>
                        <td width="224"><input name="identifiant" type="text" id="identifiant" value="<?php print htmlentities($login_connexion,ENT_COMPAT,'ISO-8859-15') ?>" size="32" maxlength="256" /></td>
                        <td width="328"><input name="chkMemorise" type="checkbox" id="chkMemorise" value="1" <?php print $remember?'checked="checked"':''?> />
                          Se souvenir de mon identifiant &agrave; la prochaine connexion <em>(le navigateur doit accepter les cookies)</em></td>
                      </tr>
                      <tr>
                        <td><p>Mot de passe: </p></td>
                        <td><input name="mdp" type="password" id="mdp" size="32" maxlength="32" onkeypress="javascript:car(event)" /></td>
                        <td>&nbsp;</td>
                      </tr>
                      <tr>
                        <td><input name="mdp_hex" type="hidden" id="mdp_hex" /></td>
                        <td><input name="connexion" type="button" class="bouton_standard" id="connexion" value="Connexion" onclick="javascript:validation()" /></td>
                        <td>&nbsp;</td>
                      </tr>
            </table>
       </form>
					<p><a href="ins_envoi_courriel.php?url_ret=index.php"><em>Vous n'arrivez pas &agrave; vous connecter ? </em></a></p>
                    <h1>Inscriptions personnelles </h1>
                    <p>Certaines circonscriptions offrent la possibilit&eacute; de s'inscrire soi-m&ecirc;me sur le site. Si vous &ecirc;tes dans ce cas, cliquez sur la circonscription et remplissez le formulaire.</p>
                    <table>
                      <tr>
                        <td><table width="100%" border="0">
                            <tr>
                              <td><?php 
						if (count($circos)==0) print"<p>Aucune circonscription n'est ouverte pour les inscriptions personnelles.</p>\n";
						else afficheCircos($circos);	
					?></td>
                            </tr>
                        </table></td>
                      </tr>
                    </table>                    </td></tr>
                  <tr>
                    <td valign="top">&nbsp;</td>
                  </tr>
            </table>
				    <h1>Infos site</h1>
					<table width="100%" border="0">
                      <tr>
                        <td width="83%"><?php afficheCharge($h) ?></td>
                        <td width="17%">
							<div align="right">
								<?php if ($afficher_logo) 
									print '<img src="images/logo_academie.png" alt="logo acad&eacute;mie" width="146" height="98" />';
									else print '&nbsp;';
								?>
							</div>
						</td>
                      </tr>
                    </table>
</div>


		 
			<div class="menu_secondaire">
				<ul class="menu2">
				  <li> &copy; 2008 Thierry Gangloff, <a href="http://tice67.site.ac-strasbourg.fr">mission TICE Strasbourg</a></li>
                  <li><p><?php print "Version $version_cs"?></p>
  </li>
  <li><p><a href="credits.php?url_ret=index.php">Cr&eacute;dits</a></p>
  </li>
				    <li><p>
    <img
        src="images/htmlvalide.png"
        alt="Valid XHTML 1.0 Transitional" height="31" width="88" />
  </p></li>
  <li>
  <p>
    <a href="licence.php?url_ret=index.php">Licence</a>  </p></li>
			  </ul>
		  </div>
		  
			<a name="bas" id="bas"></a>	
		</div>
	</body>
</html>
