<?php
/* 
	Parmatres d'un nouveau stagiaire
	Circon'script PHP Script
	Version 7.0.3
	CeCILL Copyright (C) 2008 Thierry Gangloff
	e-mail: thierry.gangloff@ac-strasbourg.fr
*/
	require('_session.php');
	require '_sqlconnect.inc.php';
	require '_fonctions.inc.php';
	require '_fonctions_stagiaire.inc.php';	
	require '_fonctions_mdp.inc.php';
	require '_captcha.inc.php';
	
	$h=connect();
	ejecteSiFerme($h);
	if (isset($_SESSION['circonscript7_id_uti'])&& $_SESSION['circonscript7_id_uti']>0) {
		header('Location: compte.php');
		exit;
	}
	if (!isset($_GET['id_circo'])) {
		header ('Location: index.php');
		exit;	
	}
	$id_circo=intval(normalise($_GET['id_circo']));
	if (isset($_SESSION['circonscript7_tentatives'])) $tentatives=$_SESSION['circonscript7_tentatives'];
	else $tentatives=0;
	if ($tentatives >=5) {
		header('Location: erreur.php?erreur=tentatives');
		exit;
	}
	if (isset($_SESSION['circonscript7_tentatives_rne'])) $tentatives_rne=$_SESSION['circonscript7_tentatives_rne'];
	else $tentatives_rne=0;
	if ($tentatives_rne >=3) {
		header('Location: erreur.php?erreur=tentatives');
		exit;
	}
	if (isset($_SESSION['circonscript7_semence'])) $semence=$_SESSION['circonscript7_semence'];
	else $semence='';
	if (isset($_GET['url_ret'])) {
		$url_ret_ins_nouveau_stagiaire=strip_tags($_GET['url_ret'])."?id_circo=$id_circo";
		$_SESSION['circonscript7_url_ret_ins_nouveau_stagiaire']=$url_ret_ins_nouveau_stagiaire;
	}
	else if (isset($_SESSION['circonscript7_url_ret_ins_nouveau_stagiaire'])) {
		$url_ret_ins_nouveau_stagiaire=$_SESSION['circonscript7_url_ret_ins_nouveau_stagiaire'];
	}
	else $url_ret_ins_nouveau_stagiaire="index.php";
	$erreur='';
	debugInit();
	$h=connect();
	$r=query("SELECT libelle, stag_enregistrement, saisie_courriel, duree_seance,regle,refuser_courriel_ecole,stag_etat FROM circos WHERE id_circo=$id_circo",$h);
	$row=@mysqli_fetch_row($r);
	if ($row[0]=='') {
		header('Location: erreur.php?erreur=id_circo');
		exit;
	}
	$libelle_circo=htmlentities($row[0],ENT_COMPAT,'ISO-8859-15');
	$stag_enregistrement=$row[1]&($row[6]==1);
	if (!$stag_enregistrement) {
		header('Location: erreur.php?erreur=enregistrement');
		exit;
	}
	$saisie_courriel=$row[2];
	$suffixe_courriel=suffixeDefaut($h);
	if (!$suffixe_courriel) {
		header('Location: erreur.php?erreur=suffixe');
		exit;
	}
	$duree_seance=$row[3];
	$regle=$row[4];
	$refuser_courriel_ecole=$row[5];
	$anonyme=0;
	$nom='';
	$prenom='';
	$niveau='';
	$courriel='';
	$mdp='';
	$mdp2='';
	$rne='';
	$captcha= new Captcha;
	if (isset($_SESSION['circonscript7_ins_nouveau_stagiaire_enonce'])) {
		$captcha->enonce=$_SESSION['circonscript7_ins_nouveau_stagiaire_enonce'];
		$captcha->reponse=$_SESSION['circonscript7_ins_nouveau_stagiaire_reponse'];
	}
	else {
		$captcha->produireEnonce();
		$_SESSION['circonscript7_ins_nouveau_stagiaire_enonce']=$captcha->enonce;
		$_SESSION['circonscript7_ins_nouveau_stagiaire_reponse']=$captcha->reponse;		
	}
	
	if (isset($_POST['commande'])) while(1) {
		if ($semence=='') {
			$erreur="Session expire: veuillez resaisir vos paramtres de connexion.";
			break;
		}
		
		if (isset($_POST['email']) && strlen($_POST['email'])>0) { // pot de miel pour bots: le champ 'email' est invisible et ne doit surtout pas tre rempli.
			$_SESSION['circonscript7_tentatives']=10; // d'office trop de tentatives, on quitte.
			header('Location: erreur.php?erreur=tentatives');
			exit;
		}
		$nom=majuscule(normaliseT($_POST['nom_stag'],25));
		if (!nomValide($nom)) $erreur.="Nom invalide. ";
		$prenom=majuscule(normaliseT($_POST['prenom_stag'],25));
		if (!nomValide($prenom)) $erreur.= "Prnom invalide. ";
		$courriel=strtolower(normaliseT($_POST['courriel_stag'],255));
		switch($saisie_courriel) {
			case 1:
				if (!$courriel) $erreur="Courriel manquant. ";
				else if (!testeEmail($courriel)) $erreur.="Courriel invalide. ";
				break;
			case 2: // courriel acadmique obligatoire 
				if (!$courriel) $erreur="Courriel manquant. ";
				else if (strpos($courriel,'@')!==false) {
					if (!testeEmailAca($courriel,$h)) $erreur="Adresse de courriel acadmique requis. ";
				}
				else {
					$courriel.='@'.$suffixe_courriel;
					if (!testeEmail($courriel)) $erreur.="Courriel invalide. ";
				}
				break;
			default:
				if ($courriel && !testeEmail($courriel)) $erreur.="Courriel invalide. ";
		}
		if (!$erreur && $courriel && $refuser_courriel_ecole) {
			if (testeEmailEcole($courriel,$h)) $erreur.="Votre circonscription interdit l'utilisation de l'adresse de courriel d'une cole  la place d'une adresse personnelle. ";
		}
		// le niveau
		$nv='';
		if (isset($_POST['niveau_stag'])) {
			$q="SELECT libelle FROM niveaux WHERE 1 ORDER BY groupe, tri";
			$r=query($q,$h);
			$nvx=array();
			while ($row=@mysqli_fetch_row($r)) 
				$nvx[$row[0]]=0; //nv stocke les niveaux dans l'ordre
			foreach($_POST['niveau_stag'] as $n) {
				$niv=normaliseT($n,15);
				if (isset($nvx[$niv])) $nvx[$niv]=1;
			}
			foreach($nvx as $k=>$v) if ($v) $nv.='/'.$k;
		}
		if ($nv=='') $erreur.="Niveau invalide. ";
			$niveau=$nv.'/';

		$id_ecole=normaliseT($_POST['ecoles'],20);
		if (!is_numeric($id_ecole)|| $id_ecole==0) $erreur.= 'cole invalide. ';
		$rne=trim(normaliseT($_POST['rne'],10));
		if ($rne=='') $erreur.="RNE absent. ";
		$quotite=decimal(normaliseT($_POST['quotite_stag'],6));
		if ($quotite=='') $erreur.="Quotit invalide. ";
		else if ($quotite<=0 || $quotite >100) $erreur.="La quotit doit tre plus grande que 0 et infrieure ou gale  100. ";
		$quota=calculerQuota($h, $id_ecole,$niveau);
		if ($quota=='' && !$erreur) $erreur="Impossible de calculer le quota d'heures";
		// anonyme
		$anonyme=0;
		if (!isset($_POST['anonyme_stag'])) $erreur.="Il faut slectionner une des options de confidentialit. " ;
		else {
			$anonyme=$_POST['anonyme_stag'];
			if ($anonyme>=1) $anonyme=1;
			else $anonyme=0;
		}	
		$mdp=decodeXor(normaliseT($_POST['commande'],32),$semence);
		if (!motDePasse($mdp)) $erreur="Le mot de passe est incorrect.";
		if ($erreur) break;
		//  test sur le rne et l'cole
		$ok=0;
		if (testRNE($rne)) $ok=queryValue("SELECT COUNT(*) FROM ecoles WHERE ecoles.id_circo=$id_circo AND ecoles.id_ecole=$id_ecole AND ecoles.rne LIKE '$rne'",$h);
		if (!$ok) {
			$erreur="Le RNE et l'cole ne correspondent pas.";
			$_SESSION['circonscript7_tentatives_rne']=++$tentatives_rne;
			if ($tentatives_rne>=3) {
				$_SESSION['circonscript7_tentatives']=5;
				header('Location: erreur.php?erreur=tentatives');
				exit;					
			}
			break;
		}	
		// test sur le captcha
		$reponse='';
		if (isset($_POST['reponse'])) $reponse=normaliseT($_POST['reponse'],40);
		if (!$captcha->testReponse($reponse)) {
			++$tentatives;
			$_SESSION['circonscript7_tentatives']=$tentatives;
			$erreur="Erreur sur la question subsidiaire. ";
			$erreur.=sprintf("Il reste %d tentative%s.",5-$tentatives,5-$tentatives>1?'s':'');
			if ($tentatives >=5) {
				header('Location: erreur.php?erreur=tentatives');
				exit;
			}
			$captcha->produireEnonce();
			$_SESSION['circonscript7_ins_nouveau_stagiaire_enonce']=$captcha->enonce;
			$_SESSION['circonscript7_ins_nouveau_stagiaire_reponse']=$captcha->reponse;		
			break;
		}
		
		$nom_f=normaliseNom($nom);
		$prenom_f=normaliseNom($prenom);
		$q="SELECT COUNT(*) FROM stagiaires WHERE nom_f LIKE '$nom_f' AND prenom_f LIKE '$prenom_f' AND id_ecole='$id_ecole'";
		$n=queryValue($q,$h);
		if ($n>0) {
			$erreur="Il semble que vous soyez dj inscrit dans cette cole. Cliquez sur \"retour\" pour retourner  la page de connexion et indiquez votre nom, prnom, cole et mot de passe pour vous connecter. En cas d'homonymie avre, vous pouvez vous diffrencier en ajoutant un chiffre  votre nom. Ne le faites QUE SI vous tes au courant de cette situation particulire (deux collgues parfaitement homonymes dans la mme cole).";
			break;
		}
		$quota_reel=quotaReelStagiaire($quota,$quotite,$duree_seance,$regle);
		$r=query("SELECT id_uti, codage, mdp FROM utilisateurs WHERE login='$courriel'",$h);
		$row=@mysqli_fetch_row($r);
		// le compte 'courriel' existe dj ?
		if (@mysqli_num_rows($r)>0) {
			header('Location: erreur.php?erreur=inscription');
			exit;
		}
		else { //  compte courriel n'existe pas : le crer
			$r=query("INSERT INTO utilisateurs (login, mdp, codage) VALUES ('$courriel',AES_ENCRYPT('$mdp','$cle_aes'),2)",$h);
			$id_uti=@mysqli_insert_id($h);
			if (!isset($id_uti) || !$id_uti) {
				$erreur.="Impossible d'attribuer un compte. Opration annule. ";	
				break;
			}
		}
		$q=sprintf("INSERT INTO stagiaires (nom, prenom,nom_f,prenom_f, niveau, courriel, id_ecole,quotite,quota,quota_reel,anonyme,id_uti) VALUES('%s','%s','%s','%s','%s','%s','%d','%d','%.2f','%.2f','%d','%d');",myEscapeString($h,$nom),myEscapeString($h,$prenom),myEscapeString($h,$nom_f),myEscapeString($h,$prenom_f),myEscapeString($h,$niveau),myEscapeString($h,$courriel),$id_ecole,$quotite,$quota,$quota_reel,$anonyme,$id_uti);
		query($q,$h);
		if (!$erreur) {
			$portailSSO=$use_sso && ($sso_login!='' || $sso_usermail!='');
			enregistreAcces($id_uti,$h,$portailSSO?8:2);
			$_SESSION['circonscript7_id_uti_bilan']=$id_uti;
			$_SESSION['circonscript7_tentatives']=0;
			unset($_SESSION['circonscript7_ins_nouveau_stagiaire_enonce']);
			header('Location: ins_nouveau_stagiaire_bilan.php');
			exit;
		}
		break;
	}
	$semence=semence();
	$_SESSION['circonscript7_semence']=$semence;

	
function afficheNiveaux($h)
{
	global $niveau;
	$q="SELECT libelle, groupe FROM niveaux WHERE 1 ORDER BY groupe, tri";
	$r=query($q,$h);
	$col=-1;
	$lig=-1;
	$max_lig=0;
	$nv=array();
	$prec_groupe=-1;
	while ($row=@mysqli_fetch_row($r)) {
		if ($prec_groupe!=$row[1]) {
			$prec_groupe=$row[1];
			++$col;
			$lig=0;
		}
		else ++$lig;
		$nv[$col][$lig]=strtoupper($row[0]);
		if ($max_lig<$lig) $max_lig=$lig;
	}
	if ($prec_groupe==-1) return;
	$max_col=$col+1;
	++$max_lig;
	print "<table class=\"invisible\">\n";
	for ($lig=0;$lig<$max_lig;++$lig) {
		print "<tr>\n";
		for ($col=0;$col<$max_col;++$col) {
			print "<td>";
			if (isset($nv[$col][$lig])) {
				$chk='';
				if (!(strpos($niveau,'/'.$nv[$col][$lig].'/')===false)) $chk='checked="checked"';	
				$n=htmlentities($nv[$col][$lig],ENT_COMPAT,'ISO-8859-15');			
				printf("<input type=\"checkbox\" name=\"niveau_stag[]\" value=\"%s\" %s />%s\n",$n,$chk,$n);
			}
			else 
				print "&nbsp;";
			print "</td>\n";
		}
		print "</tr>\n";
	}
	print "</table>\n";
}
function afficheEcoles($h)
{
	global $id_circo, $id_ecole;
//<option value="Ecole 1">01</option>	
	$q="SELECT id_ecole, nom FROM ecoles WHERE id_circo=$id_circo ORDER BY nom ASC";
	$r=query($q,$h);
	if (!isset($id_ecole) ||$id_ecole==0) print "<option value=\"0\" selected=\"selected\">* Choisissez... *</option>\n";
	while($row=@mysqli_fetch_row($r)) {
		$id_ecole_courante=$row[0];
		$nom_ecole=htmlentities($row[1],ENT_COMPAT,'ISO-8859-15');
		print "<option value=\"$id_ecole_courante\"";
		if (isset($id_ecole) && $id_ecole_courante==$id_ecole) print " selected=\"selected\"";
		print ">$nom_ecole</option>\n";
	}
}
function afficheQuotites($h)
{
	global $quotite;
	$q="SELECT quotite FROM quotites ORDER BY quotite DESC";
	$r=query($q,$h);
	if (!isset($quotite) ||$quotite==0) print "<option value=\"0\" selected=\"selected\">* Choisissez... *</option>\n";
	while($row=@mysqli_fetch_row($r)) {
		$quotite_courante=$row[0];
		print "<option value=\"$quotite_courante\"";
		if (isset($quotite) && $quotite==$quotite_courante) print " selected=\"selected\"";
		print ">$quotite_courante</option>\n";
	}
}


function calculerQuota($h, $id_ecole_stag, $niveau_stag)
{
	global $erreur, $id_circo;
	// lire et interprter les rgles
	$regles=array();
	$r=query("SELECT quota,id_ecole,niveau FROM regles WHERE id_circo=$id_circo",$h);
	while ($row=@mysqli_fetch_array($r)) {
		$niveau=$row['niveau'];
		$nivs=array();
		if ($niveau) {
			$t=explode('/',$niveau);
			foreach($t as $v) if ($v) $nivs[]='/'.$v.'/';
		}
		$quota=$row['quota'];
		$id_ecole=$row['id_ecole'];
		$regles[]=array('quota'=>$quota,'id_ecole'=>$id_ecole,'niveaux'=>$nivs);
	}
	//lire quota standard
	$quota=queryValue("SELECT quota FROM circos WHERE id_circo=$id_circo",$h);
	if ($erreur) return;
	if ($quota=='') {
		$quota=queryValue("SELECT quota FROM general",$h);
		if ($erreur || $quota=='') return;
	}
	// appliquer les rgles  au stagiaire
	foreach($regles as $regle) {
		$ecole= true;
		if($regle['id_ecole']>0) $ecole=$id_ecole_stag==$regle['id_ecole'];
		if ($ecole==false) continue;
		if (count($regle['niveaux'])!=0) {
			if ($niveau_stag=='') continue;
			$ok=false;
			foreach($regle['niveaux'] as $niv) {
				if (!(strpos($niveau_stag,$niv)===false)) {
					$ok=true;
					break;
				}
			}
			if (!$ok) continue;
		}
		if ($regle['quota'] < $quota) $quota=$regle['quota'];
	}
	return $quota;	
}
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="fr" lang="fr">
	<head>
		<title><?php print htmlentities($titre_site,ENT_COMPAT,'ISO-8859-15') ?></title>
		<meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-15" />
		<link rel="stylesheet" href="styles.css" type="text/css" /> <link rel="shortcut icon" type="image/x-icon" href="favicon.ico" />
		<script type="text/javascript" src="mdp.js"></script>
    	<script type="text/JavaScript" charset="ISO-8859-15">
<!--
function effacer()
{
	var leForm=document.form;
	var laListe=leForm["niveau_stag[]"];
	if (laListe!=null) 
		if (laListe.length!=0) 
			for(i=0;i<laListe.length;++i) 
				laListe[i].checked=false;
		else
			laListe.checked=false;
}
function envoyer()
{
	var f=document.form;
	if (f.nom_stag.value=='') {
		alert("Le nom n'est pas renseign");
		return;
	}
	if (f.prenom_stag.value=='') {
		alert("Le prnom n'est pas renseign");
		return;
	}
	<?php
	if ($saisie_courriel==1 || $saisie_courriel==2) {
		print"if (f.courriel_stag.value=='') {\n";
		print "alert(\"Le courriel n'est pas renseign\");\n";
		print "return;\n";
		print "}\n";	
	}
	?>
	liste=f["niveau_stag[]"];
	if (liste!=null) {
		var b=false;
		for (i=0;b==false && i<liste.length;++i) {
			if (liste[i].checked) b=true;
		}
		if (!b) {
			alert("Il faut cocher un niveau");
			return;
		}
	}
	if (f.rne.value=='') {
		alert("RNE non renseign");
		return;
	}
	if (f.ecoles.value==0) {
		alert("Il faut choisir une cole");
		return;
	}
	if (f.quotite_stag.value==0) {
		alert("Quotit non renseigne");
		return;
	}
	if (f.reponse.value=='') {
		alert("Question subsidiaire non renseigne");
		return;
	}
	
	var mdp1, mdp2;
	if (document.getElementById('mdp1').style.display=="inline") mdp1=document.getElementById("mdp1").value;
	else mdp1=document.getElementById("mdp1b").value;
	if (document.getElementById('mdp2').style.display=="inline") mdp2=document.getElementById("mdp2").value;
	else mdp2=document.getElementById("mdp2b").value;
	mdp=testeMdp(mdp1,mdp2,5,0);
	if (mdp!='') {
		f.commande.value=encodeMdp('<?php print $semence ?>',mdp);
		f.submit();
	}
}
function montrerMdp()
{
	var b=document.form.montrer.checked;
	if (b) {
		document.getElementById('mdp1').style.display="none";
		document.getElementById('mdp2').style.display="none";
		document.getElementById('mdp1b').style.display="inline";
		document.getElementById('mdp2b').style.display="inline";
		document.getElementById('mdp1b').value=document.getElementById("mdp1").value;
		document.getElementById('mdp2b').value=document.getElementById("mdp2").value;
		
	}
	else {
		document.getElementById('mdp1').style.display="inline";
		document.getElementById('mdp2').style.display="inline";
		document.getElementById('mdp1b').style.display="none";
		document.getElementById('mdp2b').style.display="none";
		document.getElementById('mdp1').value=document.getElementById("mdp1b").value;
		document.getElementById('mdp2').value=document.getElementById("mdp2b").value;
	}			

}

//-->
        </script>
	</head>
	<body>
		<div id="conteneur">
			<?php 
				include('menu_principal.inc.php');
			?>
			<div class="menu_secondaire">
			<ul class="menu2">
			  <li><a href="<?php print $url_ret_ins_nouveau_stagiaire?>">retour</a></li>
			  <li><a href="#bas">bas</a></li>
            </ul>
			</div>  
		  <div id="corps">	 
				<h1>
				Nouveau stagiaire: mes param&egrave;tres personnels </h1>
				<p>Les champs suvis de &quot;*&quot; sont obligatoires. </p>
				<form method="post" action="" name="form">
                  <?php if ($erreur) printf ("<p class=\"erreur\">%s</p>\n",htmlentities($erreur,ENT_COMPAT,'ISO-8859-15'))?>
                  <table>
                    <tr class="table_entete">
                      <td width="300">Mes param&egrave;tres </td>
                      <td colspan="2">Circonscription : <?php print "$libelle_circo"; ?></td>
                    </tr>
                    <tr class="survol">
                      <td>Nom * </td>
                      <td colspan="2"><input name="nom_stag" type="text" id="nom_stag" value="<?php print htmlentities($nom,ENT_COMPAT,'ISO-8859-15')?>" size="25" maxlength="25" /></td>
                    </tr>
                    <tr class="survol">
                      <td>Pr&eacute;nom * </td>
                      <td colspan="2"><input name="prenom_stag" type="text" id="prenom_stag" value="<?php print htmlentities($prenom,ENT_COMPAT,'ISO-8859-15')?>" size="25" maxlength="25" /></td>
                    </tr>
                    <tr class="survol">
                      <td><?php switch($saisie_courriel) {
							case 1: print "Courriel * ";break;
							case 2: print "Courriel acad&eacute;mique * <br/><i>uniquement le pr&eacute;fixe si adresse en @$suffixe_courriel</i>";break;
							default: print "Courriel";
						}
						?></td>
                      <td colspan="2"><?php 
					  	$p=strpos($courriel,'@'.$suffixe_courriel);
						if (($courriel=='' || $p!==false) && $saisie_courriel==2) {
							print '<input name="courriel_stag" type="text" id="courriel_stag" value="';
							print htmlentities(substr($courriel,0,$p),ENT_COMPAT,'ISO-8859-15');
							print '" size="60" maxlength="255" />';
							print "@$suffixe_courriel";
						}
						else {
							print '<input name="courriel_stag" type="text" id="courriel_stag" value="';
							print htmlentities($courriel,ENT_COMPAT,'ISO-8859-15');
							print '" size="60" maxlength="255" />';
						}
						?></td>
                      <td width="15" colspan="2">&nbsp;</td>
                    </tr>
                    <tr class="survol">
                      <td>Niveau : * </td>
                      <td colspan="2"><?php
				  	afficheNiveaux($h);
				?></td>
                      <td colspan="2">&nbsp;</td>
                    </tr>
                    <tr class="survol">
                      <td>RNE de l'&eacute;cole : * </td>
                      <td><input name="rne" type="text" id="rne" value="<?php print htmlentities($rne,ENT_COMPAT,'ISO-8859-15')?>" size="10" maxlength="10" /></td>
                      <td rowspan="2"><em>Le RNE est demand&eacute; afin d'&eacute;viter les inscriptions frauduleuses. Demandez-le &agrave; votre directeur. Il doit correspondre &agrave; l'&eacute;cole. Vous disposez de trois essais. </em></td>
                    </tr>
                    <tr class="survol">
                      <td>Ecole * </td>
                      <td><select name="ecoles" id="ecoles">
                          <?php afficheEcoles($h)?>
                      </select></td>
                    </tr>
                    <tr class="survol">
                      <td>Quotit&eacute;
                          <p class="remarque">Mettez 100 pour travail &agrave; temps complet, 50 pour un mi-temps, etc. </p></td>
                      <td colspan="2"><select name="quotite_stag">
                          <?php afficheQuotites($h)?>
                      </select></td>
                    </tr>
                    <tr class="survol">
                      <td>Mot de passe *
                        <p class="remarque">Doit comprendre entre 5 et 16 caract&egrave;res, lettres ou chiffres ou signes  &quot;-&quot; et &quot;_&quot;. Les lettres accentu&eacute;es sont interdites. </p></td>
                      <td width="376"><input name="mdp1"  type="password" id="mdp1" size="17" maxlength="17" />
                          <input name="mdp1b" type="text" id="mdp1b" size="17" maxlength="17" /></td>
                      <td width="317" rowspan="2"><input name="montrer" type="checkbox"  value="1" onclick="javascript:montrerMdp()"/>
                        Montrer les caract&egrave;res saisi<em>s</em>.</td>
                    </tr>
                    <tr class="survol">
                      <td>R&eacute;p&eacute;ter le mot de passe * </td>
                      <td><input name="mdp2" type="password"  id="mdp2" size="17" maxlength="17" />
                          <input name="mdp2b" type="text" id="mdp2b" size="17" maxlength="17" /></td>
                    </tr>
                    <tr class="survol">
                      <td>Anonymat</td>
                      <td colspan="2"><p>
                          <input type="radio" name="anonyme_stag" value="0" <?php if ($anonyme==0) print "checked=\"checked\"" ?> />
                        J'accepte que les autres stagiaires puissent savoir si je suis inscrit ou convoqu&eacute; &agrave; une animation p&eacute;dagogique particuli&egrave;re. Mon nom, pr&eacute;nom et &eacute;cole de rattachement seront publi&eacute;s, uniquement pour les animations auxquelles je suis inscrit ou convoqu&eacute;. </p>
                          <p>
                            <input type="radio" name="anonyme_stag" value="1"<?php if ($anonyme==1) print "checked=\"checked\"" ?>/>
                            Je souhaite rester anonyme. Mon nom, pr&eacute;nom et &eacute;cole de rattachement ne seront pas publi&eacute;s dans les listes. Les autres stagiaires ne pourront pas savoir si je suis inscrit ou convoqu&eacute; &agrave; une animation particuli&egrave;re. </p></td>
                    </tr>
					<tr class="survol">
					<td>Question subsidiaire * </td>
					<td>
					<p>
					<?php 
						print htmlentities($captcha->enonce,ENT_COMPAT,'ISO-8859-15');
					?>

					<input name="reponse" type="text" id="reponse" size="20" maxlength="40" /></p></td>
					<td><em>La question ci-contre a pour but de d&eacute;jouer les inscriptions automatiques g&eacute;n&eacute;r&eacute;es par des programmes informatiques malveillants. La r&eacute;ponse est simple mais fait appel &agrave; votre intelligence ou &agrave; vos connaissances.</em></td>
					</tr>
                  </table>
					<div id="inv">
					<p>Section cach&eacute;e : 
					  <input name="email" type="text" id="email" size="20" maxlength="200" /> 
					<i>Ne remplissez surtout pas ce champ: il est rserv aux traitements informatiques validant le formulaire.</i></p>
					</div>
                  <div align="center">
			        <input name="commande" type="hidden" id="commande" />
                    <input name="valider" type="button" class="bouton_standard" value="Enregistrer" onclick="javascript:envoyer()" />
                  </div>
	        </form>
			<script type="text/javascript"> montrerMdp() </script>
		  </div>
			<a name="bas" id="bas"></a>	
		<div class="menu_secondaire">
		<ul class="menu2">
		  <li><a href="<?php print $url_ret_ins_nouveau_stagiaire?>">retour</a></li>
		  <li><a href="#haut">haut</a></li>
        </ul>
		</div>		
	</div>
	</body>
</html>
