<?php
/* 
	Installation
	Circon'script PHP Script
	Version 5.0.2
	CeCILL Copyright (C) 2008 Thierry Gangloff
	e-mail: thierry.gangloff@ac-strasbourg.fr
*/	
	session_cache_limiter('nocache');
	session_name("CIRCONSCRIPT_INSTALLATION");
	session_start(); 
	header("Date: Thu, 19 Nov 1981 08:52:00 GMT");
	header('Expires: Thu, 19 Nov 1981 08:52:00 GMT');
	header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");
	header("Cache-Control: no-store, no-cache, must-revalidate, post-check=0, pre-check=0");
	header("Pragma: no-cache");
	header('Content-Type: text/html; charset=ISO-8859-15');
	$_SESSION['circonscript7_installation']=1;
	//$_SESSION['circonscript7_etape']=8;
	if (!isset($_SESSION['circonscript7_installation']) || $_SESSION['circonscript7_installation']!=1) {
		header('Location: ../erreur.php?erreur=expiree');
		exit;
	}
	$erreur='';
	$page='';
	$d=@getdate();
	$annee=$d['year'];
	require '../parametres/_parametres.inc.php';
	require '../_sqlconnect.inc.php';
	require '../_fonctions.inc.php';
	require '../_fonctions_stagiaire.inc.php';
	debugInit();

	$version_mysql=array(5,5,10);// minimum pour MySQL
	$version_php= array(5,3,0);// minimum pour PHP
	$htaccess = <<<TEXT
DirectoryIndex index.php
ErrorDocument 404 [path]/erreur404.php
AddDefaultCharset ISO-8859-15
<Files .htaccess>
Order allow,deny
Deny from all
Satisfy all
</Files>
<Files ~ "^.*\.(inc|svg|sql|log)">
Order allow,deny
Deny from all
Satisfy all
</Files>
RewriteEngine on
RewriteRule ^([a-zA-Z0-9\-]+)/interventions.ics$ int_calendrier_export.php?id=$1 [L]
TEXT;

	if (isset($_SESSION['circonscript7_etape'])) $etape=$_SESSION['circonscript7_etape'];
	else $etape=0;
	if (isset($_SESSION['circonscript7_user'])) $user=$_SESSION['circonscript7_user'];
	if (isset($_SESSION['circonscript7_bdd'])) $bdd=$_SESSION['circonscript7_bdd'];
	if (isset($_SESSION['circonscript7_password'])) $password=$_SESSION['circonscript7_password'];
	if (isset($_SESSION['circonscript7_host'])) $host=$_SESSION['circonscript7_host'];
	if (isset($_SESSION['circonscript7_cle'])) $cle=$_SESSION['circonscript7_cle'];
	if (isset($_SESSION['circonscript7_suffixe'])) $suffixe=$_SESSION['circonscript7_suffixe'];
	else $suffixe='';
	if (isset($_SESSION['circonscript7_cle_aes'])) $cle_aes=$_SESSION['circonscript7_cle_aes'];
	if (isset($_SESSION['circonscript7_titre_site'])) $titre_site=$_SESSION['circonscript7_titre_site'];
	else $titre_site="Circon'script";
	if (isset($_SESSION['circonscript7_zone'])) $zone=$_SESSION['circonscript7_zone'];
	else {
		if (version_compare(phpversion(),"5.1.0",'>=')) $zone=date_default_timezone_get();
		else $zone=$timezone;
	}
	
//---------------------------Lecture formulaires
	switch ($etape) {
		case 0: //licence 
			if (isset($_POST['valider'])) {
				if (isset($_POST['chkComprend'])&& $_POST['chkComprend']=='accepte' ) $etape=1;
				else if (isset($_POST['chkComprend']) && $_POST['chkComprend']=='refuse') {
					header('Location: ../erreur.php?erreur=licence_refusee');
					exit;
				}
				else $erreur="Veuillez cocher une des cases au bas de la page";	
			}
			break;
		
		case 1: // menu, dmarrage de l'installation
			if (isset($_POST['commencer_installation'])) ++$etape;
			break;
		case 2: // test accs
			if (isset($_POST['valider_acces'])) goAccesForm();
			break;
		case 6:
			if (isset($_POST['installer_htaccess'])) {
				goEcrireHtaccess();
				break;
			}
			else if (isset($_POST['passer_htaccess'])) ++$etape;
			else break;
		case 9:
			if (isset($_POST['valider_tables'])) goCreationTables();
			break;
		case 7: 
			if (isset($_POST['btOk'])) {
				if (ini_get('magic_quotes_runtime') || ini_get('magic_quotes_sybase')) {
					include ('magic_quotes.inc.php');
					exit;
				}
				
				++$etape;
			}
			break;
		case 8: //suffixe
			if (isset($_POST['valider_suffixe'])) {
				$suffixe='';
				if (isset($_POST['suffixe'])) $suffixe=normaliseT($_POST['suffixe'],255);
				if ($suffixe=='' || !preg_match("#^[\w.-]+\.[a-zA-Z]{2,6}$#",$suffixe)) 
					$erreur="Suffixe incorrect. ";
				else {
					$_SESSION['circonscript7_suffixe']=$suffixe;
				}
				if (!$erreur) ++$etape;
			}
			break;
		case 10:
			if (isset($_POST['valider'])) {
				if (isset($_POST['chkOuiNon']) && $_POST['chkOuiNon']=='non') ++$etape;
				else if (isset($_POST['chkOuiNon']) && $_POST['chkOuiNon']=='oui') {
					$nb=2;
					if (isset($_POST['nb_circos'])) $nb=intval($_POST['nb_circos']);
					if ($nb<=0 || $nb>10) $erreur="Nombre de circonscriptions incorrect: tapez un nombre entre 1 et 10.";
					else goCreerJeuEssai($nb);
				
				}
				else $erreur="Veuillez cocher une des cases !";	
			}
			break;
		case 11:
			if (isset($_POST['valider_supprime'])) goSupprimerFichiers();
			break;
			
	}
//--------------------------Passage aux diverses tapes
	
	do {
		switch ($etape) {
			case 0:
				doLicence();break;
			case 1:
				doDepart();break;
			case 2: 
				doAcces();break;
			case 3: 
				doTestCompatibilit();break;
			case 4:
				dotestEcriture();break;
			case 5:
				doEcrireAcces();break;
			case 6:
				doTestHtAccess();break;
			case 7:
				doAvertissements();
				break;
			case 8:
				doSuffixe();break;
			case 9:
				doTables();break;
			case 10:
				doJeuEssai();break;
			case 11:
				dosupprimer();break;
			default:
				header('Location: ../index.php');
				exit;
		}
		if (!$erreur) ++$etape;
	} while(!$erreur);
	$_SESSION['circonscript7_etape']=$etape;
	if ($page) include ($page);
	else 
		if ($erreur) print $erreur;
	exit;
// test LOCK TABLE, set_time_limit,etc...
function doAvertissements()
{
	global $erreur,$host,$user,$bdd,$password,$page;
	//set_time_limit
	$erreur='';
	$old_error_handler=set_error_handler("ErrorHandler");
	$err_time_limit=0;
	$err_lock_table=0;
	$err_magic_quotes=0;
	
	@set_time_limit(0);
	if ($erreur) $err_time_limit=1;
	$h= @mysqli_connect($host,$user,$password);
	if ($h) {
		if (!@mysqli_select_db($h,$bdd)) $h=NULL;
	}
	if ($h) {
		// crer la table provisoire circonscript_temp et teste le lock
		@mysqli_query($h,"SET NAMES 'latin1'");
		@mysqli_query($h,"CREATE TABLE IF NOT EXISTS circonscript_temp(id INT(11) UNSIGNED NOT NULL, PRIMARY KEY(id)) ENGINE=MyISAM"); 
		$r=@mysqli_query($h,"LOCK TABLE circonscript_temp WRITE");
		if (!$r) $err_lock_table=1;
		else @mysqli_query($h,"UNLOCK TABLES");
		@mysqli_query($h,"DROP TABLE IF EXISTS circonscript_temp");
	}
	// test register_globals  OFF
	if (ini_get('magic_quotes_gpc')==1) $err_magic_quotes=1;
	if (ini_get('magic_quotes_runtime')==1) $err_magic_quotes=1;
	if (ini_get('magic_quotes_sybase')==1) $err_magic_quotes=1;
	
	$_SESSION['circonscript7_err_time_limit']=$err_time_limit;
	$_SESSION['circonscript7_err_lock_table']=$err_lock_table;
	$_SESSION['circonscript7_err_magic_quotes']=$err_magic_quotes;	
	if ($err_time_limit || $err_lock_table ||$err_magic_quotes ){
		$erreur='*';
		$page="avertissements.inc.php";
	}
}
function testVersion($vTest,$vRef)
{
	$err=false;
	for ($i=0;$i<sizeof($vRef);++$i){
		$v=0;
		if (isset($vTest[$i]))
			$v=intval($vTest[$i]);
		if ($v>$vRef[$i]) break;
		if ($v<$vRef[$i]) {
			$err=true;
			break;
		}
	}
	return $err;
}

function errorHandler($in_erreur,$cherreur)
{
	global $erreur;
	$erreur=$cherreur;
	//echo $erreur;
	//echo "<br>\n";
	return true;
}
function doSuffixe()
{
	global $page,$erreur;
	$page="suffixe.inc.php";
	if (!$erreur) $erreur='*';
	
}
function doJeuEssai()
{
	global $page,$erreur;
	$page="jeu_essai.inc.php";
	if (!$erreur) $erreur='*';
}
function doLicence()
{
	global $page,$erreur;
	$page="licence.inc.php";
	if (!$erreur) $erreur='*';
}
function doDepart()
{
	global $page,$erreur;
	$page="depart.inc.php";
	$erreur='*';

}
function doTestCompatibilit()
{
	global $erreur,$page,$version_php,$version_mysql,$host,$user,$password;
	$page="compatibilite.inc.php";
	//test version php
	$version=phpversion();
	$v=explode('.',$version);
	$err=testVersion($v,$version_php);
	if ($err) $erreur.="ERREUR FATALE: La version du php que vous utilisez ($version) est infrieure  ".donnerVersion($version_php)."<br/>\n";
	$h= @mysqli_connect($host,$user,$password);
	$version=queryValue("SELECT VERSION()",$h);
	$v=explode('.',$version);

	$err=testVersion($v,$version_mysql);
	if ($err) $erreur.="ERREUR FATALE: La version de MySQL que vous utilisez ($version) est infrieure  ".donnerVersion($version_mysql)."<br/>\n";
	// test register_globals  OFF
	if (ini_get('register_globals')==1) {
		$erreur.="ERREUR FATALE: register_globals est  ON.<br/>\n";
	}
	if (!function_exists('mysqli_connect')) {
		$erreur.="ERREUR FATALE: La bibliothque mysqli n'est pas installe.<br/>\n";
	}
	if (!extension_loaded('mbstring')) {
		$erreur.="ERREUR FATALE: La bibliothque mbstring n'est pas installe.<br/>\n";
	}

}

function doTestHtAccess()
{
	global $erreur,$page,$htaccess;
	$page="ecriture_htaccess.inc.php";
	if (!$erreur) $erreur='*';
}

function goSupprimerFichiers()
{
	
	global $erreur,$etape;
	$dir="../installe";
	$d=@opendir($dir);
	if ($d===false) {
		$erreur.="Impossible d'ouvrir le dossier 'installe'. ";
		return;
	}
	$fichiers=array();
	while ($file=readdir($d)) {
		if ($file=='.' || $file=='..') continue;
		$fichiers[]=$file;
	}
	closedir($d);
	foreach($fichiers as $f) {
		$u=@unlink("$dir/$f");
		if ($u==false) {
			$erreur.="Impossible de supprimer le fichier '$f'. ";
			return;
		}
	}
	++$etape;
	header('Location: ../index.php');
	exit;

}
function dosupprimer()
{
	global $page,$erreur;
	$page='supprimer_fichiers.inc.php';
	if (!$erreur) $erreur='*';
}

function goCreationTables()
{
	global $erreur,$host,$user,$bdd,$password,$etape,$suffixe;
	$t=file('../sql/tables.sql');
	if (sizeof($t)<10) {
		$erreur.="Impossible de lire le fichier 'sql/tables.sql. '";
		return;
	}
	
	$h=@mysqli_connect($host,$user,$password);
	if (!$h) {
		$erreur.="Impossible de se connecter  MySql. ";
		return;
	}
	$b=	@mysqli_select_db($h,$bdd);
	if (!$b) {
		$erreur="Connexion  MySQL russie mais impossible de se connecter  la base de donnes \#$bdd\". ";
		return;
	}
	//if (get_magic_quotes_runtime()) set_magic_quotes_runtime(false); ---- OBSOLETE --
	@mysqli_query($h,"SET NAMES 'latin1'");
	$q='';
	foreach($t as $s) {
		$s=trim($s);
		if ($s=='') continue;
		if (substr($s,0,2)=='--') continue;
		$q.=$s;
		$pos=strrpos($s,';');
		if ($pos===false) continue;
		
		query( $q,$h);
		if ($erreur) break;
		$q='';
	}
	// gnre les tables indispensables (utilisateurs, administrateurs, general, quotits, niveaux)
	if (!$erreur) {
		$id_uti=genereUnUtilisateur('admin','admin',$h);
		query("INSERT INTO administrateurs (id_uti,type_admin,nom,courriel) VALUES($id_uti,1,'Administrateur','')",$h);
		query("INSERT INTO general(nom_admin,quota,ferme,duree_seance,actualite) VALUES('Administrateur',18,0,3,'Le site est oprationnel.')",$h);		
		$quotites=array('100.00','80.00','77.78','75.00','66.67','50.00');
		for ($i=0;$i<sizeof($quotites);++$i) {
			$lib=$quotites[$i];
			$q="INSERT INTO quotites(quotite) VALUES ('$lib')";
			query($q,$h);
		}
		genereNiveaux($h);
		if ($suffixe) query("INSERT INTO suffixes(suffixe,defaut) VALUES ('$suffixe',1)",$h);
	}
	if (!$erreur) ++$etape;
}
function doTables()
{
	global $page,$erreur;
	$page='creation_tables.inc.php';
	if (!$erreur) $erreur='*';

}
// ecrire les paramtres host, bdd, password, user dans le fichier

function doEcrireAcces()
{
	global $erreur,$page,$host,$bdd,$password,$user,$cle,$cle_aes,$titre_site,$zone;
	$page="ecriture_fichier.inc.php";
	
	$t=file('../parametres/_parametres.inc.php');
	if (sizeof($t)<10) {
		$erreur.="Problme sur le fichier '_parametres.inc.php' - il ne semble pas correct. ";
		return;
	}
	$hash='';
	for ($i=0;$i<6;++$i) 
		$hash.=sprintf("%02x",rand(0,255));
	$s=implode("",$t);
	$t=preg_replace('(\$host=\"[a-zA-Z0-9_]*\")',"\$host=\"$host\"",$s);
	$t=preg_replace('(\$user=\"[a-zA-Z0-9_]*\")',"\$user=\"$user\"",$t);
	$t=preg_replace('(\$password=\"[a-zA-Z0-9_]*\")',"\$password=\"$password\"",$t);
	$t=preg_replace('(\$bdd=\"[a-zA-Z0-9_]*\")',"\$bdd=\"$bdd\"",$t);
	$t=preg_replace('(\$cle=\"([^"])*\")',"\$cle=\"$cle\"",$t);
	$t=preg_replace('(\$cle_aes=\"([^"])*\")',"\$cle_aes=\"$cle_aes\"",$t);
	$t=preg_replace('(\$titre_site=\"([^"])*\")',"\$titre_site=\"$titre_site\"",$t);
	$t=preg_replace('(\$hash=\"([^"])*\")',"\$hash=\"$hash\"",$t);
	$t=preg_replace('(\$timezone=\"([^"])*\")',"\$timezone=\"$zone\"",$t);
	$fp=fopen('../parametres/_parametres.inc.php','w');
	if (!$fp) {
		$erreur.="Impossible d'ouvrir le fichier '_parametres.inc.php' en criture. ";
		return; 
	}
	$b=fputs($fp,$t,strlen($t));
	fclose($fp);
	if (!$b) {
		$erreur="Probleme d'criture dans le fichier '_parametres.inc.php'. ";
		return;
	}
	
/*	
	$fp=fopen("../temp/test.tmp","w");
	if (!$fp) {
		$erreur.="Impossible d'crire dans le dossier 'temp'. ";
		return;
	}
	$b=fputs($fp,$t,strlen($t));
	fclose($fp);
	if (!$b) {
		$erreur="Problme d'criture dans le fichier 'test.tmp' du dossier 'temp'. ";
		return;
	}
	@chmod('../temp/test.tmp',0644);// le serveur pourrait devenir le seul propritaire du fichier et lui attribuer des droits en 0600 ce qui le rend illisible par ftp.
	$b=unlink('../_parametres.inc.php');
	if (!$b) {
		$erreur.="Impossible de supprimer le fichier '_parametres.inc.php' preexistant. ";
		return;
	}
	$b=rename('../temp/test.tmp','../_parametres.inc.php');
	if (!$b) {
		$erreur="Impossible de renommer le fichier 'temp/test.tmp' en '_parametres.inc.php' dans le dossier courant. ";
		return;
	}
*/	
}
// Cration du htaccess personnalis

function goEcrireHtaccess()
{
	global $erreur,$etape,$htaccess;
	$path=$_SERVER['SCRIPT_NAME'];
	$t=explode('/',$path);
	//te le nom du fichier
	if (sizeof($t)>1) {
		unset($t[sizeof($t)-1]);
		$path=implode('/',$t);
	}
	else $path='';
	//te le nom du dossier installe
	if (sizeof($t)>1) {
		unset($t[sizeof($t)-1]);
		$path=implode('/',$t);
	}
	else $path='';
	$http='http';
	if (isset($_SERVER['HTTPS']) && $_SERVER['HTTPS']=='on') $http='https';
	$path=$http.'://'.$_SERVER['SERVER_NAME'].$path;
	
	$s=str_replace('[path]',$path,$htaccess);
	$fp=fopen("../temp/.htaccess","w");
	if (!$fp) {
		$erreur.="Impossible d'crire dans le dossier 'temp'. ";
		return;
	}
	$b=fputs($fp,$s,strlen($s));
	fclose($fp);
	if (!$b) {
		$erreur="Probleme d'criture dans le fichier '.htaccess' du dossier 'temp'. ";
		return;
	}
	if (file_exists('../.htaccess')) {
		$b=unlink('../.htaccess');
		if (!$b) {
			$erreur.="Impossible de supprimer le fichier '.htaccess' prexistant. Vous pouvez faire l'opration vous-meme, en rcuprant le fichier .htaccess dans le dossier 'temp' et en le recopiant dans le dossier parent.";
			return;
		}
	}
	$b=rename('../temp/.htaccess','../.htaccess');
	if (!$b) {
		$erreur="Impossible de renommer le fichier 'temp/.htaccess' en '.htaccess' dans le dossier courant. Vous pouvez faire l'opration vous-meme, en rcuprant le fichier .htaccess dans le dossier 'temp' et en le recopiant dans le dossier parent.";
		return;
	}
	if (!$erreur) ++ $etape;
}

function goAccesForm()
{
	global $erreur,$page,$host,$user,$password,$bdd,$cle,$cle_aes, $titre_site,$zone;
	
	if (isset($_POST['zone'])) $zone=normalise($_POST['zone']);
	else $zone="";
	$host='';
	if (isset($_POST['host'])) $host=normalise($_POST['host']);
	$u='';
	if (isset($_POST['user'])) $user=normalise($_POST['user']);
	$bdd='';
	if (isset($_POST['bdd'])) $bdd=normalise($_POST['bdd']);
	$password='';
	if (isset($_POST['password'])) $password=normalise($_POST['password']);
	$cle='';
	if (isset($_POST['edCle'])) {
		$cle=$_POST['edCle']; 
		if ($cle!='' && strlen($cle)<8) $erreur.="La cl doit comporter au moins 8 caractres. ";
		if (strpos($cle,'"')!==false) $erreur.="La cl ne doit pas contenir de guillemets (\"). ";
	}
	if (isset($_POST['cle_aes'])) {
		$cle_aes=normalise($_POST['cle_aes']);
		if (strlen($cle_aes)<16) {
			$erreur.= "La cl AES doit comporter au moins 16 caractres. ";
		}
		else if (strlen($cle_aes)>255) {
			$erreur.= "La cl AES est trop longue (max: 255 caractres). ";
		}
		else if (htmlspecialchars($cle_aes,ENT_QUOTES , 'ISO-8859-15')!=$cle_aes) {
			$erreur.="La cl contient une apostrophe ou un guillemet. ";
		}
	}
	if (isset($_POST['titre_site'])) {
		$titre_site=normalise($_POST['titre_site']);
		if (strpos($titre_site,'"')!==false) $erreur.="Le titre ne doit pas contenir de guillemet. ";
	}
	if (!$password || !$user || !$host || !$bdd || !$cle_aes||!$titre_site||!$zone) {
		$erreur.="Il faut renseigner tous les champs obligatoires. ";
		return;
	}
}
function doAcces()
{
	global $erreur,$page,$host,$user,$password,$bdd,$cle,$cle_aes,$titre_site,$zone;
	$page='formulaire_acces.inc.php';
	if ($host=='' || $user=='' || $password=='' || $bdd=='' ||$cle_aes==''||$titre_site==''||$zone=='') {
		$erreur.="*";
		return;
	}
	$h= @mysqli_connect($host,$user,$password);
	if (!$h) {
		$erreur.="Impossible de se connecter  MySQL. ";
		return;
	}
	// test de la version de MySQL
	$vers=version($h);
	if ($vers<4.1) {
		$erreur="ERREUR FATALE: la version de MySQL employe ($vers) est infrieure  la version 4.1. Circonscript ncessite MySQL version 4.1 au moins.";
		return; 
	}
	$b=	@mysqli_select_db($h,$bdd);
	if (!$b) $erreur.="Connexion  MySQL russie mais impossible de se connecter  la base de donnes \"$bdd\". ";
	@mysqli_query($h,"SET NAMES 'latin1'");
	$_SESSION['circonscript7_host']=$host;
	$_SESSION['circonscript7_password']=$password;
	$_SESSION['circonscript7_user']=$user;
	$_SESSION['circonscript7_bdd']=$bdd;
	$_SESSION['circonscript7_cle']=$cle;
	$_SESSION['circonscript7_cle_aes']=$cle_aes;	
	$_SESSION['circonscript7_titre_site']=$titre_site;	
	$_SESSION['circonscript7_zone']=$zone;	
	
}

	
function dotestEcriture()
{
	global $erreur,$page;
	$page='test_ecriture.inc.php';
	$b=testEcriture('../temp');
	if (!$b) $erreur.="Le dossier 'temp' n'est pas accessible en criture. ";
	$b=testEcriture('../svg');
	if (!$b) $erreur.="Le dossier 'svg' n'est pas accessible en criture. ";
	$b=testEcriture('../installe');
	if (!$b) $erreur.="Le dossier 'installe' n'est pas accessible en criture. ";
	$fp=@fopen('../parametres/_parametres.inc.php','r+');
	if ($fp===false) {
		$erreur.="Impossible d'ouvrir \"parametres/_parametres.inc.php\" en criture. ";	
	}
	else fclose($fp);
}



function testEcriture($dossier)
{
	$fp=@fopen("$dossier/test.tmp",'w');
	if (!$fp) return false;
	fclose($fp);
	unlink("$dossier/test.tmp");
	return true;
}

/************************************************
LE JEU D'ESSAI V4
*************************************************/

function goCreerJeuEssai($nb_circos)
{
	global $erreur,$etape,$suffixe;
	@set_time_limit(0); // pas de limitation pour le calcul, qui peut tre long...
	$h=connect();
	query("TRUNCATE TABLE regles",$h);
	query("TRUNCATE TABLE bassin",$h);
	query("TRUNCATE TABLE positions",$h);
	query("TRUNCATE TABLE circos",$h);
	query("TRUNCATE TABLE domaines",$h);
	query("TRUNCATE TABLE themes",$h);
	query("TRUNCATE TABLE animations",$h);
	query("TRUNCATE TABLE seances",$h);
	query("TRUNCATE TABLE dates",$h);
	query("TRUNCATE TABLE partages",$h);
	query("TRUNCATE TABLE ecoles",$h);
	query("TRUNCATE TABLE stagiaires",$h);
	query("TRUNCATE TABLE inscriptions",$h);
	query("TRUNCATE TABLE convocations",$h);
	query("TRUNCATE TABLE absences",$h);
	query("TRUNCATE TABLE interventions",$h);
	query("TRUNCATE TABLE intervenants",$h);
	query("TRUNCATE TABLE groupes",$h);
	query("TRUNCATE TABLE groupements",$h);
	
	$num_anim=1;
	$num_domaine=1;
	$num_theme=1;
	$num_seance=1;
	$num_date=1;
	$num_groupe=1;
	genereintervenants($h);
	$base=1;
	for ($i=0;$i<$nb_circos;++$i) {
		$id_circo=$base+$i;
		$libelle_court=sprintf("Circo%02d",$i+1);
		$libelle=sprintf("Circo %02d",$i+1);
		$rne=sprintf("099%04dA",$i+1);
		if ($suffixe)
			$courriel=strtolower($libelle_court)."@$suffixe";
		else
			$courriel=strtolower($libelle_court)."@ac-ademie.fr";
		//$nom_admin=phrase(1,1).' '.phrase(1,1);
		$quota=18;
		$export=1;
		$q="INSERT INTO circos(id_circo,libelle_court,libelle,rne,courriel,exportations_autorisees,quota,stag_enregistrement,stag_etat,saisie_courriel) VALUES('$id_circo','$libelle_court','$libelle','$rne','$courriel','$export','$quota','1','1','2')";
		query($q,$h);
		// crer des domaines dans la circo
		$nb_domaines=rand(2,5);
	
		for($j=0;$j<$nb_domaines;++$j) {
			$libelle="Domaine $num_domaine ".phrase(2,7);
			++$num_domaine;
			$tri=$j+1;
			query("INSERT INTO domaines(id_circo,libelle,tri) VALUES('$id_circo','$libelle','$tri')",$h);
		}
		// crer des themes dans la circo
		$nb_themes=rand(2,5);
	
		for($j=0;$j<$nb_domaines;++$j) {
			$libelle="Theme $num_theme ".phrase(2,7);
			++$num_theme;
			$tri=$j+1;
			query("INSERT INTO themes(id_circo,libelle,tri) VALUES('$id_circo','$libelle','$tri')",$h);
		}
		
		$nb_groupes=5;
		for($j=0;$j<$nb_groupes;++$j) {
			$libelle="Groupe $num_groupe ".phrase(1,3);
			++$num_groupe;
			query("INSERT INTO groupes(id_circo,libelle) VALUES('$id_circo','$libelle')",$h);
		}

		
		// cre des animations dans la circo
		$domaines=array();
		$themes=array();
		$rd=query("SELECT id_domaine FROM domaines WHERE id_circo=$id_circo",$h);
		while ($row=@mysqli_fetch_row($rd)) $domaines[]=$row[0];
		$rt=query("SELECT id_theme FROM themes WHERE id_circo=$id_circo",$h);
		while ($row=@mysqli_fetch_row($rt)) $themes[]=$row[0];
		$nb_domaines=sizeof($domaines);
		$nb_themes=sizeof($themes);
		$nb_anim=rand(5,15);
		for ($j=0;$j<$nb_anim;++$j) {
			$id_domaine=$domaines[rand(0,$nb_domaines-1)];
			$id_theme=$themes[rand(0,$nb_themes-1)];
			//printf("(%s) (%s)<br>\n",$id_domaine,$id_theme);
			genereUneAnimation($num_anim,$num_seance,$num_date,$id_circo,$id_domaine,$id_theme,0,$h);
		
		}
		// classer les positions
		$rp=query("SELECT id_position,positions.id_domaine,positions.id_theme FROM positions,domaines,themes WHERE positions.id_domaine=domaines.id_domaine AND domaines.id_circo=$id_circo AND positions.id_theme=themes.id_theme ORDER BY id_domaine ASC,id_theme ASC",$h);
		$id_domaine_anc=0;
		$id_theme_anc=0;
		$tri=1;
		while ($row=@mysqli_fetch_row($rp)) {
			$id_position=$row[0];	
			$id_domaine=$row[1];
			$id_theme=$row[2];
			if ($id_domaine!=$id_domaine_anc || $id_theme !=$id_theme_anc) {
				$tri=1;
				$id_domaine_anc=$id_domaine;
				$id_theme_anc=$id_theme;
			}	
			query("UPDATE positions SET tri='$tri' WHERE id_position=$id_position",$h);
			++$tri;
		}


	}
	genereGeneral($h);
	generePartages($h);
	genereImportations($h);
	genereEcoles($h);
	genereStagiaires($h);
	genereGroupements($h);
	genereInscriptions($h);
	genereConvocations($h);
	if (!$erreur) ++$etape;
}
//------------------------------------------------------------
function genereintervenants($h)
{
	global $suffixe;
	$suf=$suffixe;
	if (!$suf) $suf='ac-ademie.fr';
	$fonctions=array('CP.ADJ.IEN','CP.LANG.CR','CONS.PED.','CP.EPS','ANIM.INF','CP.EDU.MUS','');
	$nb=count($fonctions);
	for ($i=0;$i<40;++$i) {
		$civ=rand(0,2);
		$nom=ucfirst(mot(1,3));
		$prenom=ucfirst(mot(1,3));
		$nom_f=strtoupper($nom);
		$prenom_f=strtoupper($prenom);
		$f=$fonctions[rand(0,$nb-1)];
		$courriel=strtolower("$prenom.$nom@$suf");
		$id_uti=genereUnUtilisateur($courriel,'test',$h);
		if ($id_uti) query("INSERT INTO intervenants(civilite,nom,prenom,nom_f,prenom_f,fonction,courriel,id_circo,id_uti) VALUES('$civ','$nom','$prenom','$nom_f','$prenom_f','$f','$courriel',0,$id_uti)",$h);
	}

}
function genereUneAnimation(&$num_anim,&$num_seance,&$num_date,$id_circo,$id_domaine,$id_theme,$position,$h)
{
	$intitule=sprintf("Animation%02d %s",$num_anim,phrase(3,7));
	++$num_anim;
	$description=phrase(1,20);
	$remarque=phrase(0,10);
	$participation=rand(0,1);// si 1, une sance avec plusieurs dates, si 0, plusieurs sances avec une date
	query("INSERT INTO animations(id_circo,intitule,description,remarque) VALUES('$id_circo','$intitule','$description','$remarque')",$h);	
	$id_anim=@mysqli_insert_id($h);
	query("INSERT INTO positions(id_anim,id_domaine,id_theme,tri) VALUES('$id_anim','$id_domaine','$id_theme','$position')",$h);
	if ($participation==0) $nb_seances=rand(1,5);
	else $nb_seances=rand(2,5);
	genereSeances($num_seance,$num_date,$nb_seances,$id_anim,$id_circo,$participation,$h);
}

function genereSeances(&$num_seance,&$num_date,$nb_seances,$id_anim,$id_circo,$participation,$h)
{
	$publics=array('c1','c2','c3','directeurs','bilingues','clin', 'tout public','coles de secteur','public rserv','maternelles','lmentaires',);
	$horaires=array('08:30:00', '09:00:00','13:30:00','14:00:00');
	for ($i=0;$i<=$nb_seances;++$i) {
		if ($i==0 || $participation==0) {
			if (rand(0,2)<2) $max=0;
			else $max=rand(7,20);
			$index_public=rand(0,sizeof($publics)-1);
			$public='';
			if (rand(0,2)<2)
				$public=$publics[$index_public];
			//$public=mot();
			query("INSERT INTO seances(id_anim,max,public) VALUES('$id_anim','$max','$public')",$h);
			$id_seance=@mysqli_insert_id($h);
			++$num_seance;
		}
		$date=genDate();
		//$duree=rand(1,3)+rand(0,3)*0.25;
		$duree=rand(2,3);
		$lieu=phrase(1,3);
		$remarque=phrase(0,5);
		$horaire=$horaires[rand(0,count($horaires)-1)];
		++$num_date;
		
		query("INSERT INTO dates(id_seance,date,lieu,remarque,duree,horaire) VALUES('$id_seance','$date','$lieu','$remarque','$duree','$horaire')",$h);
		
		// choix des intervenants				
		$id_date=@mysqli_insert_id($h);
		$nb_int=rand(0,3);
		while ($nb_int>0) {
			$min_id=queryValue("SELECT MIN(id_intervenant) FROM intervenants",$h);
			$max_id=queryValue("SELECT MAX(id_intervenant) FROM intervenants",$h);
			if ($max_id<=$min_id) break;
			$id_intervenants=array();
			if ($nb_int>$max_id-$min_id) $nb_int=$max_id-$min_id;
			for($j=0;$j<$nb_int;++$j) {
				do 
					$id=rand($min_id,$max_id);
				while (in_array($id,$id_intervenants));
				$id_intervenants[]=$id;
			}						
			foreach($id_intervenants as $id_intervenant) query("INSERT INTO interventions(id_intervenant,id_date) VALUES($id_intervenant,$id_date)",$h);
			break;
		
		}
	}
}

function generePartages($h)
{
	$circos=array();
	$r=query("SELECT id_circo FROM circos",$h);
	while ($row=mysqli_fetch_row($r)) $circos[]=$row[0];
	
	$r1=query("SELECT id_anim, id_circo FROM positions, domaines WHERE positions.id_domaine=domaines.id_domaine",$h);
	while ($anim=mysqli_fetch_row($r1)) {
		$id_anim=$anim[0];
		$id_circo=$anim[1];
		$r2=query("SELECT id_seance FROM seances WHERE id_anim=$id_anim",$h);
		while($seance=mysqli_fetch_row($r2)) {
			$id_seance=$seance[0];
			for ($i=0;$i<sizeof($circos);++$i) {
				$id_circo_export=$circos[$i];
				if ($id_circo_export==$id_circo) $accepte=1;
				else $accepte=0;
				query("INSERT INTO partages(id_circo,id_seance,accepte) VALUES ($id_circo_export,$id_seance,$accepte)",$h); 
			}
		}
	}
}

function genereEcoles($h)
{
	global $suffixe;
	$suf=$suffixe;
	if (!$suf) $suf='ac-ademie.fr';
	$r=query("SELECT id_circo FROM circos ORDER BY id_circo ASC",$h);
	$numec=1;
	while ($row=mysqli_fetch_row($r)) {
		$id_circo=$row[0];
		$n=rand(20,40);
		for ($i=0;$i<$n;++$i){
			$mot=ucwords(mot(1,4));
			$type=rand(0,1)?'E.E.PU.':'E.M.PU.';
			$nom="$type $mot";
			$rne=sprintf("099%04d",$numec);
			$rne.=chr(ord('A')+rand(0,25));
			$courriel='ce.'.strtolower($rne).'@'.$suf;
			query("INSERT INTO ecoles(id_ecole,rne,nom,courriel,id_circo) VALUES('$numec','$rne','$nom','$courriel','$id_circo')",$h);
			++$numec;
		}
	}		
}
function genereNiveaux($h)
{
		
	$niveaux=array('TPS','PS','MS','GS','-','CP','CE1','CE2','CM1','CM2','-','RASED','CLIN','CLIS','-','DIRECTION','AUTRE');
	$groupe=1;
	$tri=1;
	for ($i=0;$i<sizeof($niveaux);++$i) {
		$lib=$niveaux[$i];
		if ($lib!='-') {
			$q="INSERT INTO niveaux(libelle, groupe,tri) VALUES ('$lib',$groupe,$tri)";
			query($q,$h);
			++$tri;
		}
		else {
			++$groupe;
			$tri=1;
		}
	}
}
function genereStagiaires($h)
{
	global $suffixe;
	$fai=$suffixe;
	if (!$fai) $fai='ac-ademie.fr';

	$quotites=array(50,66.67,75,75.78,80,100);
	$q="SELECT libelle FROM niveaux WHERE 1";
	$r=query($q,$h);
	$niveaux='';
	while ($row=mysqli_fetch_row($r)) 
		$niveaux[]=$row[0];
	$quota=queryValue("SELECT quota FROM general",$h);
	$num_stag=1;	
	$r=query("SELECT id_ecole FROM ecoles",$h);
	while ($row=mysqli_fetch_row($r)) {
		$n=rand(1,20);//de 1  20 stagiaires par cole.
		$id_ecole=$row[0];
		$r2=query("SELECT id_groupe FROM groupes, ecoles WHERE groupes.id_circo=ecoles.id_circo AND ecoles.id_ecole=$id_ecole",$h);
		$groupes=array();
		while ($row=@mysqli_fetch_row($r2))$groupes[]=$row[0];
		$groupes[]='0';
		
		for ($i=0;$i<$n;++$i) {
			$nom=ucfirst(mot(1,3));
			$prenom=ucfirst(mot(1,2));
			$nom_f=strtoupper($nom);
			$prenom_f=strtoupper($prenom);
			if (rand(1,4)>1)
				$courriel=strtolower("$nom.$prenom@$fai");
			else $courriel='';
			
			$n1=rand(0,sizeof($niveaux)-1);
			$niveau='/'.$niveaux[$n1].'/';
			$n2=rand(0,sizeof($niveaux)-1);
			if (rand(0,3)==0 && $n2!=$n1) {
				$niveau.=$niveaux[$n2].'/';
			}
			$quotite=$quotites[ rand(0,count($quotites)-1)];
			$quota_stag=$quota;
			$quota_reel=quotaReelStagiaire(18,$quotite,3,1);
			$id_groupe=$groupes[rand(0,count($groupes)-1)];
			$id_uti=genereUnUtilisateur($courriel,'test',$h);
			if ($id_uti) query("INSERT INTO stagiaires(id_stagiaire,nom,prenom,nom_f,prenom_f,courriel,id_ecole,niveau,quotite,quota,quota_reel,id_groupe,id_uti) VALUES ('$num_stag','$nom','$prenom','$nom_f','$prenom_f','$courriel','$id_ecole','$niveau','$quotite','$quota_stag','$quota_reel','$id_groupe','$id_uti')",$h);
			++$num_stag;
		}
	}
}

function genereInscriptions($h)
{
	$num_inscr=1;
	$r=query("SELECT id_stagiaire, ecoles.id_circo FROM stagiaires, ecoles WHERE stagiaires.id_ecole=ecoles.id_ecole ORDER BY ecoles.id_circo",$h);
	$prec_circo=0;
	$anims=array();
	while ($row=@mysqli_fetch_row($r)) {
		$id_stagiaire=$row[0];
		$id_circo=$row[1];
		if( $id_circo!=$prec_circo) {
			$r2=query("SELECT seances.id_seance,max FROM partages,seances, positions, domaines WHERE partages.id_circo=$id_circo AND partages.accepte=1 AND partages.id_seance=seances.id_seance AND seances.id_anim=positions.id_anim AND positions.id_domaine=domaines.id_domaine AND domaines.id_circo=$id_circo",$h);
			$anims=array();
			while ($row=mysqli_fetch_row($r2))$anims[]=$row;
			$prec_circo=$id_circo;
		}
		$n=rand(0,5); // nombre de sances  inscrire.
		for ($i=0;$i<$n;++$i) {
			$a=rand(0,sizeof($anims)-1); // choisir une animation au hasard.
			$id_seance=$anims[$a][0];
			$max=$anims[$a][1];
			if ($max>0) { // il existe un maximum de participants
				$nb_inscrits=queryValue("SELECT COUNT(*) FROM inscriptions where id_seance=$id_seance",$h);
				if ($nb_inscrits>=$max) continue;
			}
			
			$nb=queryValue("SELECT COUNT(*) FROM inscriptions WHERE id_stagiaire=$id_stagiaire AND id_seance=$id_seance",$h);
			if ($nb==0) 
				query("INSERT INTO inscriptions(id_stagiaire,id_seance) VALUES('$id_stagiaire','$id_seance')",$h);
				
		}
	}
	
}
function genereConvocations($h)
{
	$num_inscr=1;
	$r=query("SELECT id_stagiaire, ecoles.id_circo FROM stagiaires, ecoles WHERE stagiaires.id_ecole=ecoles.id_ecole ORDER BY ecoles.id_circo",$h);
	$prec_circo=0;
	$anims=array();
	while ($row=@mysqli_fetch_row($r)) {
		$id_stagiaire=$row[0];
		$id_circo=$row[1];
		if( $id_circo!=$prec_circo) {
			$r2=query("SELECT seances.id_seance,max FROM partages,seances, positions, domaines WHERE partages.id_circo=$id_circo AND partages.accepte=1 AND partages.id_seance=seances.id_seance AND seances.id_anim=positions.id_anim AND positions.id_domaine=domaines.id_domaine AND domaines.id_circo=$id_circo",$h);
			$anims=array();
			while ($row=mysqli_fetch_row($r2))$anims[]=$row;
			$prec_circo=$id_circo;
		}
		$n=rand(0,5); // nombre de sances  convoquer.
		for ($i=0;$i<$n;++$i) {
			$a=rand(0,sizeof($anims)-1); // choisir une animation au hasard.
			$id_seance=$anims[$a][0];
			$max=$anims[$a][1];
			if ($max>0) { // il existe un maximum de participants
				$nb_inscrits=queryValue("SELECT COUNT(*) FROM convocations where id_seance=$id_seance",$h);
				if ($nb_inscrits>=$max) continue;
			}
			
						
			$nb=queryValue("SELECT COUNT(*) FROM convocations WHERE id_stagiaire=$id_stagiaire AND id_seance=$id_seance",$h);
			if ($nb==0) {
				query("INSERT INTO convocations(id_stagiaire,id_seance) VALUES('$id_stagiaire','$id_seance')",$h);
				//gnration d'une absence alatoire
				if (rand(0,9)<4) {
					$r2=query("SELECT id_date FROM dates WHERE dates.id_seance='$id_seance'",$h);
					$id_dates=array();
					while ($row2=@mysqli_fetch_row($r2)) $id_dates[]=$row2[0];
					if (count($id_dates>1)) for($k=0;$k<count($id_dates);++$k) {
						$id_date=$id_dates[$k];
						$k2=rand(0,count($id_dates)-1);
						$id_dates[$k]=$id_dates[$k2];
						$id_dates[$k2]=$id_date;
					}
					$n2=rand(1,count($id_dates));
					for ($k=0;$k<$n2;++$k) {
						$id_date=$id_dates[$k];
						$exc=rand(0,1)?"1":"0";
						query("INSERT INTO absences(id_stagiaire,id_date,excuse) VALUES ('$id_stagiaire','$id_date','$exc')",$h);
					}
				}
			}
				
		}
	}
	
}

function genereGroupements($h)
{
	$r1=query("SELECT id_circo FROM circos",$h);
	while ($row=@mysqli_fetch_row($r1)) {
		$id_circo=$row[0];
		$seances=array();
		$r2=query("SELECT seances.id_seance FROM seances, positions, domaines WHERE seances.id_anim=positions.id_anim AND positions.id_domaine=domaines.id_domaine AND domaines.id_circo=$id_circo",$h);
		while($row=@mysqli_fetch_row($r2)) $seances[]=$row[0];
		if (count($seances)==0) continue;
		$r2=query("SELECT id_groupe FROM groupes WHERE id_circo=$id_circo",$h);
		while ($row2=@mysqli_fetch_row($r2)) {
			$id_groupe=$row2[0];
			// mlange sances
			for ($i=0;$i<count($seances);++$i) {
				$j=rand(0, count($seances)-1);
				$s=$seances[$i];
				$seances[$i]=$seances[$j];
				$seances[$j]=$s;
			} 
			$nb_seances=rand(1,count($seances));
			for ($i=0;$i<$nb_seances;++$i) {
				$id_seance=$seances[$i];	
				query("INSERT INTO groupements(id_groupe,id_seance) VALUES('$id_groupe','$id_seance')",$h);
			}
		}
	
	}

}
function genereGeneral($h)
{
	$q="REPLACE INTO general(nom_admin,courriel,actualite) VALUES('Administrateur','admin@circonscript.fr','Le site est en dmonstration avec un jeu d\'essai.')";
	query($q,$h);
}

function genereImportations($h)
{
	global $erreur;
	if ($erreur) return;
	$r=query("SELECT id_circo FROM circos",$h);
	if (@mysqli_num_rows($r)<=1) return;
	while ($row1=@mysqli_fetch_row($r)) {
		$id_circo=$row1[0];
		$domaines=array();
		$themes=array();
		$rd=query("SELECT id_domaine FROM domaines WHERE id_circo=$id_circo",$h);
		while ($row=@mysqli_fetch_row($rd)) $domaines[]=$row[0];
		$rt=query("SELECT id_theme FROM themes WHERE id_circo=$id_circo",$h);
		while ($row=@mysqli_fetch_row($rt)) $themes[]=$row[0];
		$nb_domaines=sizeof($domaines);
		$nb_themes=sizeof($themes);
		$rp=query("SELECT partages.id_partage, seances.id_anim FROM partages,seances,animations WHERE accepte='0' AND partages.id_circo=$id_circo AND partages.id_seance=seances.id_seance AND seances.id_anim=animations.id_anim AND animations.id_circo<>partages.id_circo HAVING FLOOR(RAND()*3)< 1 ",$h);
		while ($row=@mysqli_fetch_row($rp)) {
			$id_partage=$row[0];
			$id_anim=$row[1];
			query("UPDATE partages SET accepte='1' WHERE id_partage=$id_partage",$h);
			$id_domaine=$domaines[rand(0,$nb_domaines-1)];
			$id_theme=$themes[rand(0,$nb_themes-1)];
			$tri=1+queryValue("SELECT COUNT(*) FROM positions WHERE id_domaine=$id_domaine AND id_theme=$id_theme",$h);
			$n=queryValue("SELECT COUNT(*) FROM positions,domaines WHERE id_anim=$id_anim AND positions.id_domaine=domaines.id_domaine AND domaines.id_circo=$id_circo",$h);
			if ($n==0) query("INSERT INTO positions(id_domaine,id_theme,tri,id_anim) VALUES($id_domaine,$id_theme,$tri,$id_anim)",$h);
		}
	}
}
function genDate()
{
	global $annee;
	if (rand(1,5)==1) return '9999-12-31'; //vide
	$j=rand(1,29);
	$m=rand(1,12);
	$a=rand($annee,$annee+1);
	if ($m==2 && $j>=29) $j=28;
	return sprintf("%04d-%02d-%02d",$a,$m,$j);
}

function phraseLieu($n)
{
	if (rand(1,3)==1) return '';
	return phrase(1,$n);
}

function phrase($min,$max)
{
	$n=rand($min,$max);
	if ($n==0) return '';
	$s='';
	for ($i=0;$i<$n;++$i) {
		if ($s) $s.=' ';
		$s.=mot();
	}
	return ucfirst($s);
}

function mot(  $min=1,$max=3)
{
	$n=rand($min,$max);
	$mot='';
	$r=rand(0,1);
	for ($i=0;$i<$n;++$i) {
		if ($r) 
			$mot.=voyelle().consonne();
			else
			$mot.=consonne().voyelle();
	}
	if($r) $mot.=voyelle();
	//if(!$r && rand(0,1)) $mot.=consonneFinale();	
	return $mot;
}
function voyelle()
{
	$voyelles = array("a","a","a", "e","e","e","e","e","e", "i","i","i", "o","o","o", "u","u","u");
	return $voyelles[rand(0,count($voyelles)-1)]; 
}
function consonne()
{
	$consonnes = array("b", "b","c","c", "d","d",  "f","f", "g","g", "h", "j", "k", "m","m", "n","n", "p","p", "r","r","s", "s","s","s", "t","t", "v","v",   "z");
	return $consonnes[rand(0,count($consonnes)-1)];
}
function consonneFinale()
{
	$consonnes_finales = "cflprs";
	return substr($consonnes_finales,rand(0,strlen($consonnes_finales)-1),1);
}
function genereUnUtilisateur($login,$mdp,$h)
{
	$id_uti=0;
	if ($login!='') {
		$id_uti=queryValue("SELECT id_uti FROM utilisateurs WHERE login LIKE '$login'",$h);
		if (!$id_uti) {
			query("INSERT INTO utilisateurs (login,mdp,codage) VALUES ('$login','$mdp',0)",$h);
			$id_uti=@mysqli_insert_id($h);
		}
	}
	else {
		query("INSERT INTO utilisateurs (login, mdp, codage) VALUES ('temp','$mdp',0)",$h);
		$id_uti=@mysqli_insert_id($h);
		if ($id_uti) query("UPDATE utilisateurs SET login='utilisateur$id_uti' WHERE id_uti=$id_uti",$h);
	}
	return $id_uti;
}
function donnerVersion($v)
{
	return implode('.',$v);
}
?>
