<?php
/* 
	Exportation du plan de formation au format csv
	Circon'script PHP Script
	Version 7.0.3
	CeCILL Copyright (C) 2008 Thierry Gangloff
	e-mail: thierry.gangloff@ac-strasbourg.fr
*/

	require('_session.php');
	if (isset($_GET['url_ret'])) {
		$url_ret_int_calendrier=strip_tags($_GET['url_ret']);
		$_SESSION['circonscript7_url_ret_int_calendrier']=$url_ret_int_calendrier;
	}
	else if (isset($_SESSION['circonscript7_url_ret_int_calendrier'])) {
		$url_ret_int_calendrier=$_SESSION['circonscript7_url_ret_int_calendrier'];
	}
	else $url_ret_int_calendrier="int_accueil.php";
	
	$erreur='';
	require '_sqlconnect.inc.php';
	require '_fonctions.inc.php';
	require '_fonctions_intervenants.inc.php';
	require '_fonctions_ical.inc.php';
	
	if (!isset($_SESSION['circonscript7_id_intervenant'])) {
		header( 'Location: erreur.php?erreur=expiree');
		exit;
	}		
	$id_intervenant=$_SESSION['circonscript7_id_intervenant'];
	debugInit();
	$h=connect();
	ejecteSiFerme($h);
	if ($url_site=='') {
		$domaine=$_SERVER['HTTP_HOST'];
		$path=$_SERVER['SCRIPT_NAME'];
		$t=explode('/',$path);
		if (sizeof($t)>1) {
			unset($t[sizeof($t)-1]);
			$path=implode('/',$t);
		}
		else $path='';
		$http='http';
		if (isset($_SERVER['HTTPS']) && $_SERVER['HTTPS']=='on') $http='https';
		$site="$http://$domaine$path";
	}
	else $site=$url_site;
	$intervenants_ical=queryValue("SELECT intervenants_ical FROM general",$h);
	if( !$intervenants_ical) {
		header('Location: erreur.php?erreur=acces_page');
		exit;
	}
	$ical_session=queryValue("SELECT ical_session FROM intervenants WHERE id_intervenant=$id_intervenant",$h);
	$url='';
	if ($ical_session) $url=$site."/$ical_session/interventions.ics";
	if (isset($_POST['commande'])&& $_POST['commande']=='desabonner') {//dsabonnement
		$ical_session=updateIntervenantICAL($h,$id_intervenant,false);
		$url='';
	}
	else if (isset($_POST['abonner'])) {
		$nb=queryValue("SELECT COUNT(*) FROM interventions, dates WHERE id_intervenant=$id_intervenant AND interventions.id_date=dates.id_date AND dates.date<'9999-12-30' && dates.date>'0000-00-00'",$h);
		if($nb<$intervenants_ical) 
			$erreur="Vous n'avez pas assez d'interventions  votre actif ! Cette fonctionnalit est rserve aux intervenants ayant au moins $intervenants_ical interventions en prsentiel.";
		
		else 
			$ical_session=updateIntervenantICAL($h,$id_intervenant,true);
			$url='';
			if ($ical_session) $url=$site."/$ical_session/interventions.ics";
	}
	else if (isset($_POST['exporter'])) {
		$exp=exporterICALIntervenant($h);
		if (!$exp) $erreur="Impossible de crer le calendrier";
		else {
			if ($ical_session) {
				$r=@mysqli_prepare($h,"UPDATE intervenants SET ical_timestamp=NOW(), ical_cache=? WHERE id_intervenant=?");
				@mysqli_stmt_bind_param($r,'ss',$exp,$id_intervenant);
				@mysqli_stmt_execute($r);
				@mysqli_stmt_close($r);
			}
			header('Content-type: text/calendar; charset=utf-8');
			header('Content-Disposition: inline; filename=interventions.ics');	
			echo $exp;
			exit;
		}
	}
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="fr" lang="fr">
	<head>
		<title><?php print htmlentities($titre_site,ENT_COMPAT,'ISO-8859-15') ?></title>
		<meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-155" />
		<link rel="stylesheet" href="styles.css" type="text/css" /> <link rel="shortcut icon" type="image/x-icon" href="favicon.ico" />
		<script type="text/javascript">
		<!--			
			function confirme()
			{
				b=window.confirm("Confirmez-vous le dsabonnement ? Cette action est irrversible. Si vous souhaitez vous rabonner plus tard, il faudra reprogrammer les fournisseurs d'accs avec une nouvelle URL diffrente de celle-ci.");
				if (b) {
					form1.commande.value="desabonner";
					form1.submit();
				}
			}
		
		//-->	
		</script>
	</head>
	<body>
		<div id="conteneur">
			<?php 
				include('menu_principal.inc.php');
			?>
			<div class="menu_secondaire">
				<ul class="menu2">
	  				<li><a href="<?php print $url_ret_int_calendrier?>">retour</a></li>
	  				<li><a href="#bas">bas</a></li>
				</ul>
			</div>
		  <div id="corps">	 
			  <h1>Synchroniser mon agenda avec Circon'script </h1>
			    <?php if ($erreur) print "<p class=\"erreur\">$erreur</p>";?> 
	        <form name="form1" method="post" action="">
			        <p>
			          <input name="commande" type="hidden" id="commande" value="0" />
		            Les intervenants qui font plus de 10 interventions en pr&eacute;sentiel peuvent les retrouver sur leurs agendas &eacute;lectroniques. Seules sont affich&eacute;es les animations non annul&eacute;es dont les dates sont d&eacute;finies et dans le plan &quot;actuel&quot;. </p>
			        <p>Une fois votre abonnement valid&eacute; par Circon'script, vous recevrez une URL &agrave; copier/coller dans n'importe quel syst&egrave;me de gestion d'agenda en ligne ou local qui accepte les URL des calendriers au format <em>icalendar ICS</em>.</p>
		        <p><strong>Attention, Circon'script r&eacute;actualise par d&eacute;faut le calendrier toutes les 12 heures, pour mettre &agrave; jour le nombre d'inscrits et de convoqu&eacute;s, sauf s'il y a des modifications dans votre plan de formation.</strong> Dans ce dernier cas, la mise &agrave; jour est imm&eacute;diatement disponible, &agrave; condition d'actualiser votre calendrier. </p>
			        <p>			          La fr&eacute;quence de r&eacute;actualisation d&eacute;pend, soit du logiciel que vous utilisez,<strong> soit  de l'op&eacute;rateur qui affiche votre calendrier</strong> (Google Calendar, Microsoft Live Calendar, etc.) Selon l'op&eacute;rateur,<strong> le d&eacute;lai peut d&eacute;passer 24h</strong> et la r&eacute;actualisation<strong> n'est pas forc&eacute;ment effectu&eacute;e</strong> lors d'une synchronisation manuelle. Le mieux est donc d'utiliser un programme ou une application qui accepte directement l'URL. Sur les plates-formes Andro&iuml;d, l'application ICSDroid disponible sur le magasin open-source F-Droid est une bonne alternative. </p>
			        <p>SVP veuillez espacer vos r&eacute;actualisations d'une heure au moins. </p>
			        <p>
			          <?php if (!$url) : ?>
                      <input name="abonner" type="submit" class="bouton_standard" id="abonner" value="S'abonner au calendrier Circon'script" />
                      <?php else : ?>
                      Votre URL personnelle et unique &agrave; copier/coller (cliquez pour s&eacute;lectionner):
                      <input name="url" type="text" class="courrier" id="url" value="<?php print $url ?>" size="100" readonly="readonly" onclick="this.select()" />
                      <input name="desabonner" type="button" class="bouton_standard" id="desabonner" value="Se d&eacute;sabonner" onclick="javascript:confirme()"/>
                      <?php endif ?>		
			  </p>
	                <h1>Exporter un fichier au format iCalendar (ics) pour l'int&eacute;grer dans une application de calendrier</h1>
                  <p>Si vous ne faites pas partie des &eacute;lus autoris&eacute;s &agrave; synchroniser leurs calendriers, ou si vous pr&eacute;f&eacute;rez ne pas faire de synchronisation, vous pouvez r&eacute;cup&eacute;rer  un fichier &agrave; int&eacute;grer dans n'importe quel agenda. Bien entendu, les modifications op&eacute;r&eacute;es ult&eacute;rieurement sur Circon'script ne se r&eacute;percutent pas sur le calendrier ainsi export&eacute;. </p>
                  <p>Si vous &ecirc;tes abonn&eacute;, le fait d'exporter un fichier va r&eacute;initialiser le d&eacute;lai de 12h jusqu'&agrave; la prochaine actualisation. </p>
                  <p align="center">
	                  <input name="exporter" type="submit" class="bouton_standard" id="exporter" value="Exporter" />
              </p>
		            <h2>Remarque importante sur les titres</h2>
              <p>Les intitul&eacute;s de vos interventions sont parfois compl&eacute;t&eacute;s par des nombres: (1/2), (2/3)...</p>
			  <p>Le premier nombre est le num&eacute;ro d'ordre de votre intervention<em> en pr&eacute;sentiel </em>sur cette animation, avec ce groupe de stagiaires. </p>
			  <p>Le second nombre indique le nombre de fois que vous allez intervenir <em>en pr&eacute;sentiel</em> sur cette animation, avec  ce groupe de stagiaires. Notez que ce nombre peut &ecirc;tre diff&eacute;rent du nombre total de s&eacute;ances auxquelles ce groupe doit participer, s'il y a des s&eacute;ances anim&eacute;es par d'autres intervenants que vous, ou des t&eacute;l&eacute;formations (m&ecirc;me anim&eacute;es par vous). </p>
			  <p>Les t&eacute;l&eacute;formations ne sont pas prises en compte, de m&ecirc;me que les dates &agrave; d&eacute;finir. </p>
	        </form>
		  </div>
			<div class="menu_secondaire">
				<ul class="menu2">
	  				<li><a href="<?php print $url_ret_int_calendrier?>">retour</a></li>
		  			<li><a href="#haut">haut</a></li>
				</ul>
			</div>
			<a name="bas" id="bas"></a>	
		</div>
	</body>
</html>
