<?php
/*	
	Exportation des interventions. Appel direct de cette page pour obtenir un calendrier pour un intervenant, au format ical.
	URL: adresse_du_site/int_calendrier_export.php?id=un_id_present_dans_la_table_des_intervenants
	On peut utiliser rewriterule dans le .htaccess pour obtenir une adresse plus simple: 
	http://adresse-du-site/id_present_dans_la_table/interventions.ics devient http://adresse_du_site/int_calendrier_export.php?id=id_present_dans_la_table
	RewriteRule ^([a-zA-Z0-9]+)/interventions.ics$ int_calendrier_export.php?id=$1 [L]
	Circon'script PHP Script
	Version 7.1.0
	CeCILL Copyright (C) 2008 Thierry Gangloff
	e-mail: thierry.gangloff@ac-strasbourg.fr
*/
	require 'parametres/_parametres.inc.php';
	$intervalle=60*12;// 12 heures entre 2 ractualisations effectives (sachant qu'en cas de modifications des interventions ical_timestamp est null et donc la ractualisation se fait d'office)
	$protocol=isset($_SERVER['protocol'])?$_SERVER['protocol']:'HTTP/1.1';
	$h= @mysqli_connect($host,$user,$password);
	if (!$h) {
		header("$protocol 404 Not Found");
		header('Status: 404 Not Found');
		exit;
	}
	if (!@mysqli_select_db($h,$bdd)) {
		header("$protocol 404 Not Found");
		header('Status: 404 Not Found');
		exit;
	}
	@mysqli_query($h,"SET NAMES 'latin1'");
	$r=@mysqli_query($h,"SElECT ferme FROM general");
	$row=@mysqli_fetch_row($r);
	if ($row[0]) {
		header("$protocol 503 Service Temporarily Unavailable");
		header('Status: 503 Service Temporarily Unavailable');
		header('Retry-After: 3600');		
		exit;
	}
	$id='';
	if (isset($_GET['id']))$id= @mysqli_real_escape_string($h,$_GET['id']);
	if (!$id) {
		header("$protocol 401 Unauthorized");
		header('Status: 401 Unauthorized');
		exit;
	}
	// rcupre les donnes et ventuellement le calendrier en cache
	$r=@mysqli_prepare($h,"SELECT id_intervenant, ouvert,IF(ical_timestamp IS NULL, $intervalle, TIMESTAMPDIFF(MINUTE,ical_timestamp,CURRENT_TIMESTAMP())), IFNULL(ical_cache,'')  FROM intervenants WHERE ical_session=?");
	@mysqli_stmt_bind_param($r,'s',$id);
	@mysqli_stmt_execute($r);
	@mysqli_stmt_bind_result($r,$id_intervenant,$ouvert,$diff,$exp);
	@mysqli_stmt_fetch($r);
	@mysqli_stmt_close($r);
	if(!isset($id_intervenant)|| !isset($ouvert) || !$ouvert || !$id_intervenant) {
		header("$protocol 401 Unauthorized");
		header('Status: 401 Unauthorized');
		exit;
	}
	if ($diff<$intervalle && $exp!='') { // utilise le cache si dans les temps
		header('Content-type: text/calendar; charset=utf-8');
		header('Content-Disposition: inline; filename=interventions.ics');	
		echo $exp;
		exit;	
	}
	// calculer le nouveau calendrier et mettre en cache.
	require '_fonctions_ical.inc.php';
	$exp=exporterICALIntervenant($h);
	if (!$exp) {
		header("$protocol 204 No Content");
		header('Status: 204 No Content');
		exit;
	}
	$r=@mysqli_prepare($h,"UPDATE intervenants SET ical_timestamp=NOW(), ical_cache=? WHERE id_intervenant=?");
	@mysqli_stmt_bind_param($r,'ss',$exp,$id_intervenant);
	@mysqli_stmt_execute($r);
	@mysqli_stmt_close($r);
	header('Content-type: text/calendar; charset=utf-8');
	header('Content-Disposition: inline; filename=interventions.ics');	
	echo $exp;
	exit;
?>