
DROP TABLE IF EXISTS `absences`;
CREATE TABLE IF NOT EXISTS `absences` (
  `id_abs` int(10) UNSIGNED NOT NULL AUTO_INCREMENT,
  `id_stagiaire` int(11) UNSIGNED NOT NULL DEFAULT '0',
  `id_date` int(11) UNSIGNED NOT NULL DEFAULT '0',
  `excuse` tinyint(4) DEFAULT '0',
  PRIMARY KEY (`id_abs`),
  KEY `id_stagiaire` (`id_stagiaire`),
  KEY `id_date` (`id_date`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;

DROP TABLE IF EXISTS `acces`;
CREATE TABLE IF NOT EXISTS `acces` (
  `IP` varchar(15) CHARACTER SET latin1 COLLATE latin1_general_ci NOT NULL,
  `dt_acces` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `tentatives` int(11) NOT NULL,
  `login` tinytext NOT NULL,
  `ban` tinyint(4) NOT NULL DEFAULT '0',
  PRIMARY KEY (`IP`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

DROP TABLE IF EXISTS `administrateurs`;
CREATE TABLE IF NOT EXISTS `administrateurs` (
  `id_admin` int(10) UNSIGNED NOT NULL AUTO_INCREMENT,
  `id_uti` int(11) UNSIGNED NOT NULL,
  `type_admin` tinyint(4) NOT NULL DEFAULT '0',
  `nom` tinytext COLLATE latin1_general_ci NOT NULL,
  `courriel` tinytext COLLATE latin1_general_ci NOT NULL,
  PRIMARY KEY (`id_admin`),
  KEY `id_uti` (`id_uti`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;

DROP TABLE IF EXISTS `animations`;
CREATE TABLE IF NOT EXISTS `animations` (
  `id_anim` int(10) UNSIGNED NOT NULL AUTO_INCREMENT,
  `id_circo` int(11) UNSIGNED NOT NULL DEFAULT '0',
  `id_categorie` int(11) UNSIGNED NOT NULL DEFAULT '0',
  `intitule` tinytext COLLATE latin1_general_ci NOT NULL,
  `description` text COLLATE latin1_general_ci,
  `remarque` text COLLATE latin1_general_ci,
  `lien` tinytext COLLATE latin1_general_ci,
  `annule` tinyint(4) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id_anim`),
  KEY `id_circo` (`id_circo`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;

DROP TABLE IF EXISTS `bassin`;
CREATE TABLE IF NOT EXISTS `bassin` (
  `id_bassin` int(10) UNSIGNED NOT NULL AUTO_INCREMENT,
  `id_circo` int(11) UNSIGNED NOT NULL DEFAULT '0',
  `id_circo_bassin` int(11) UNSIGNED NOT NULL DEFAULT '0',
  PRIMARY KEY (`id_bassin`),
  KEY `id_circo` (`id_circo`),
  KEY `id_circo_bassin` (`id_circo_bassin`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;

DROP TABLE IF EXISTS `categories`;
CREATE TABLE IF NOT EXISTS `categories` (
  `id_categorie` int(10) UNSIGNED NOT NULL AUTO_INCREMENT,
  `codage` tinytext COLLATE latin1_general_ci NOT NULL,
  `libelle` tinytext COLLATE latin1_general_ci NOT NULL,
  `tri` tinyint(4) UNSIGNED NOT NULL DEFAULT '0',
  PRIMARY KEY (`id_categorie`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;

DROP TABLE IF EXISTS `circos`;
CREATE TABLE IF NOT EXISTS `circos` (
  `id_circo` int(10) UNSIGNED NOT NULL AUTO_INCREMENT,
  `inscriptions_autorisees` tinyint(4) NOT NULL DEFAULT '0',
  `rne` varchar(8) COLLATE latin1_general_ci NOT NULL DEFAULT '',
  `libelle` tinytext COLLATE latin1_general_ci NOT NULL,
  `libelle_court` varchar(7) COLLATE latin1_general_ci NOT NULL DEFAULT '',
  `saisie_courriel` tinyint(4) NOT NULL DEFAULT '2',
  `exportations_autorisees` tinyint(4) NOT NULL DEFAULT '0',
  `stag_enregistrement` tinyint(4) NOT NULL DEFAULT '0',
  `stag_etat` tinyint(4) NOT NULL DEFAULT '0',
  `quota` decimal(6,2) NOT NULL DEFAULT '18.00',
  `duree_seance` decimal(6,2) NOT NULL DEFAULT '3.00',
  `regle` tinyint(4) NOT NULL DEFAULT '1',
  `checklist` varchar(200) COLLATE latin1_general_ci DEFAULT NULL,
  `horaire_defaut` time NOT NULL DEFAULT '09:00:00',
  `autoriser_plan_futur` tinyint(4) NOT NULL DEFAULT '0',
  `saisie_quotite` tinyint(4) NOT NULL DEFAULT '0',
  `courriel` tinytext COLLATE latin1_general_ci NOT NULL,
  `refuser_courriel_ecole` tinyint(4) NOT NULL DEFAULT '1',
  `dt_ouverture` datetime DEFAULT NULL,
  `dt_fermeture` datetime DEFAULT NULL,
  `lien_externe0` tinytext COLLATE latin1_general_ci,
  `legende_lien_externe0` tinytext COLLATE latin1_general_ci,
  `lien_externe1` tinytext COLLATE latin1_general_ci,
  `legende_lien_externe1` tinytext COLLATE latin1_general_ci,
  `type_circo` tinyint(3) UNSIGNED NOT NULL DEFAULT '0',
  PRIMARY KEY (`id_circo`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;

DROP TABLE IF EXISTS `convocations`;
CREATE TABLE IF NOT EXISTS `convocations` (
  `id_convoc` int(10) UNSIGNED NOT NULL AUTO_INCREMENT,
  `id_stagiaire` int(11) UNSIGNED NOT NULL DEFAULT '0',
  `id_seance` int(11) UNSIGNED NOT NULL DEFAULT '0',
  PRIMARY KEY (`id_convoc`),
  KEY `id_stagiaire` (`id_stagiaire`),
  KEY `id_seance` (`id_seance`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;

DROP TABLE IF EXISTS `dates`;
CREATE TABLE IF NOT EXISTS `dates` (
  `id_date` int(10) UNSIGNED NOT NULL AUTO_INCREMENT,
  `id_seance` int(11) UNSIGNED NOT NULL DEFAULT '0',
  `date` date NOT NULL DEFAULT '9999-12-31',
  `horaire` time NOT NULL DEFAULT '00:00:00',
  `lieu` tinytext COLLATE latin1_general_ci NOT NULL,
  `remarque` tinytext COLLATE latin1_general_ci NOT NULL,
  `duree` decimal(4,2) NOT NULL DEFAULT '0.00',
  `tri` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id_date`),
  KEY `id_seance` (`id_seance`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;

DROP TABLE IF EXISTS `domaines`;
CREATE TABLE IF NOT EXISTS `domaines` (
  `id_domaine` int(10) UNSIGNED NOT NULL AUTO_INCREMENT,
  `id_circo` int(11) UNSIGNED NOT NULL DEFAULT '0',
  `libelle` tinytext COLLATE latin1_general_ci NOT NULL,
  `tri` tinyint(4) UNSIGNED NOT NULL DEFAULT '0',
  `annee` tinyint(4) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id_domaine`),
  KEY `id_circo` (`id_circo`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;

DROP TABLE IF EXISTS `droits`;
CREATE TABLE IF NOT EXISTS `droits` (
  `id_droit` int(10) UNSIGNED NOT NULL AUTO_INCREMENT,
  `id_admin` int(11) UNSIGNED NOT NULL DEFAULT '0',
  `id_circo` int(11) UNSIGNED NOT NULL DEFAULT '0',
  PRIMARY KEY (`id_droit`),
  KEY `id_admin` (`id_admin`),
  KEY `id_circo` (`id_circo`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;

DROP TABLE IF EXISTS `ecoles`;
CREATE TABLE IF NOT EXISTS `ecoles` (
  `id_ecole` int(10) UNSIGNED NOT NULL AUTO_INCREMENT,
  `nom` text COLLATE latin1_general_ci NOT NULL,
  `id_circo` int(11) UNSIGNED NOT NULL DEFAULT '0',
  `rne` varchar(8) COLLATE latin1_general_ci DEFAULT NULL,
  `courriel` tinytext COLLATE latin1_general_ci,
  PRIMARY KEY (`id_ecole`),
  KEY `id_circo` (`id_circo`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;

DROP TABLE IF EXISTS `general`;
CREATE TABLE IF NOT EXISTS `general` (
  `nom_admin` tinytext COLLATE latin1_general_ci NOT NULL,
  `quota` decimal(6,2) NOT NULL DEFAULT '18.00',
  `ferme` tinyint(4) NOT NULL DEFAULT '0',
  `duree_seance` decimal(6,2) NOT NULL DEFAULT '3.00',
  `message_maintenance` text COLLATE latin1_general_ci,
  `horaire_defaut` time NOT NULL DEFAULT '09:00:00',
  `intervalle_svg` decimal(5,2) NOT NULL DEFAULT '0.00',
  `date_svg` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00',
  `session_svg` varchar(32) COLLATE latin1_general_ci DEFAULT NULL,
  `actualite` text COLLATE latin1_general_ci,
  `courriel` tinytext COLLATE latin1_general_ci,
  `saisie_courriel` tinyint(4) NOT NULL DEFAULT '1',
  `message_accueil` text COLLATE latin1_general_ci,
  `autorisations` varchar(50) COLLATE latin1_general_ci DEFAULT '00000000000000000000000000000000000000000000000000',
  `webcourriel` tinytext COLLATE latin1_general_ci,
  `taille_max_description` int(10) UNSIGNED NOT NULL DEFAULT '500',
  `taille_max_remarque` int(10) UNSIGNED NOT NULL DEFAULT '200',
  `message_compte` text COLLATE latin1_general_ci,
  `message_circo` text COLLATE latin1_general_ci,
  `avertissementChoix` tinyint(3) UNSIGNED NOT NULL DEFAULT '1',
  `intervenants_ical` tinyint(4) NOT NULL DEFAULT '10',
  `bannissement` tinyint(4) NOT NULL DEFAULT '1',
  `ban_duree` int(11) NOT NULL DEFAULT '30',
  `ban_oubli` int(11) NOT NULL DEFAULT '10',
  `ban_tentatives` int(11) NOT NULL DEFAULT '10'
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;

DROP TABLE IF EXISTS `groupements`;
CREATE TABLE IF NOT EXISTS `groupements` (
  `id_groupement` int(10) UNSIGNED NOT NULL AUTO_INCREMENT,
  `id_groupe` int(11) UNSIGNED NOT NULL DEFAULT '0',
  `id_seance` int(11) UNSIGNED NOT NULL DEFAULT '0',
  PRIMARY KEY (`id_groupement`),
  KEY `id_groupe` (`id_groupe`),
  KEY `id_seance` (`id_seance`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;

DROP TABLE IF EXISTS `groupes`;
CREATE TABLE IF NOT EXISTS `groupes` (
  `id_groupe` int(10) UNSIGNED NOT NULL AUTO_INCREMENT,
  `id_circo` int(11) UNSIGNED NOT NULL DEFAULT '0',
  `libelle` tinytext COLLATE latin1_general_ci NOT NULL,
  `annee` tinyint(4) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id_groupe`),
  KEY `id_circo` (`id_circo`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;

DROP TABLE IF EXISTS `inscriptions`;
CREATE TABLE IF NOT EXISTS `inscriptions` (
  `id_inscr` int(10) UNSIGNED NOT NULL AUTO_INCREMENT,
  `id_stagiaire` int(11) UNSIGNED NOT NULL DEFAULT '0',
  `id_seance` int(11) UNSIGNED NOT NULL DEFAULT '0',
  `traite` tinyint(3) UNSIGNED NOT NULL DEFAULT '0',
  PRIMARY KEY (`id_inscr`),
  KEY `id_stagiaire` (`id_stagiaire`),
  KEY `id_seance` (`id_seance`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;

DROP TABLE IF EXISTS `intervenants`;
CREATE TABLE IF NOT EXISTS `intervenants` (
  `id_intervenant` int(10) UNSIGNED NOT NULL AUTO_INCREMENT,
  `civilite` tinyint(4) NOT NULL DEFAULT '0',
  `nom` varchar(25) COLLATE latin1_general_ci NOT NULL DEFAULT '',
  `prenom` varchar(25) COLLATE latin1_general_ci NOT NULL DEFAULT '',
  `nom_f` varchar(25) COLLATE latin1_general_ci NOT NULL DEFAULT '',
  `prenom_f` varchar(25) COLLATE latin1_general_ci NOT NULL DEFAULT '',
  `courriel` tinytext COLLATE latin1_general_ci,
  `fonction` varchar(20) COLLATE latin1_general_ci DEFAULT NULL,
  `ouvert` tinyint(4) NOT NULL DEFAULT '0',
  `id_circo` int(11) UNSIGNED NOT NULL DEFAULT '0',
  `id_uti` int(11) UNSIGNED NOT NULL,
  `ical_session` varchar(50) COLLATE latin1_general_ci DEFAULT NULL,
  `ical_timestamp` timestamp NULL DEFAULT NULL,
  `ical_cache` blob,
  PRIMARY KEY (`id_intervenant`),
  KEY `id_uti` (`id_uti`),
  KEY `ical_session` (`ical_session`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;

DROP TABLE IF EXISTS `interventions`;
CREATE TABLE IF NOT EXISTS `interventions` (
  `id_intervention` int(10) UNSIGNED NOT NULL AUTO_INCREMENT,
  `id_intervenant` int(11) UNSIGNED NOT NULL DEFAULT '0',
  `id_date` int(11) UNSIGNED NOT NULL DEFAULT '0',
  PRIMARY KEY (`id_intervention`),
  KEY `id_intervenant` (`id_intervenant`),
  KEY `id_date` (`id_date`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;

DROP TABLE IF EXISTS `items`;
CREATE TABLE IF NOT EXISTS `items` (
  `id_item` int(10) UNSIGNED NOT NULL AUTO_INCREMENT,
  `id_liste` int(11) UNSIGNED NOT NULL,
  `id_seance` int(11) UNSIGNED NOT NULL,
  `tri` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id_item`),
  KEY `id_liste` (`id_liste`),
  KEY `id_seance` (`id_seance`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;

DROP TABLE IF EXISTS `listes`;
CREATE TABLE IF NOT EXISTS `listes` (
  `id_liste` int(10) UNSIGNED NOT NULL AUTO_INCREMENT,
  `id_circo` int(11) UNSIGNED NOT NULL,
  `libelle` text COLLATE latin1_general_ci NOT NULL,
  PRIMARY KEY (`id_liste`),
  KEY `id_circo` (`id_circo`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;

DROP TABLE IF EXISTS `niveaux`;
CREATE TABLE IF NOT EXISTS `niveaux` (
  `id_niveau` int(10) UNSIGNED NOT NULL AUTO_INCREMENT,
  `libelle` varchar(15) COLLATE latin1_general_ci NOT NULL DEFAULT '',
  `groupe` tinyint(4) NOT NULL DEFAULT '1',
  `tri` tinyint(4) NOT NULL DEFAULT '1',
  PRIMARY KEY (`id_niveau`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;

DROP TABLE IF EXISTS `partages`;
CREATE TABLE IF NOT EXISTS `partages` (
  `id_partage` int(10) UNSIGNED NOT NULL AUTO_INCREMENT,
  `id_circo` int(11) UNSIGNED NOT NULL DEFAULT '0',
  `id_seance` int(11) UNSIGNED NOT NULL DEFAULT '0',
  `accepte` tinyint(3) UNSIGNED NOT NULL DEFAULT '0',
  PRIMARY KEY (`id_partage`),
  KEY `id_circo` (`id_circo`),
  KEY `id_seance` (`id_seance`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;

DROP TABLE IF EXISTS `positions`;
CREATE TABLE IF NOT EXISTS `positions` (
  `id_position` int(10) UNSIGNED NOT NULL AUTO_INCREMENT,
  `id_domaine` int(11) UNSIGNED NOT NULL,
  `id_theme` int(11) UNSIGNED NOT NULL,
  `tri` int(11) NOT NULL DEFAULT '0',
  `id_anim` int(11) UNSIGNED NOT NULL,
  PRIMARY KEY (`id_position`),
  KEY `id_domaine` (`id_domaine`),
  KEY `id_theme` (`id_theme`),
  KEY `id_anim` (`id_anim`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;

DROP TABLE IF EXISTS `quotites`;
CREATE TABLE IF NOT EXISTS `quotites` (
  `id_quotite` int(10) UNSIGNED NOT NULL AUTO_INCREMENT,
  `quotite` decimal(5,2) NOT NULL DEFAULT '0.00',
  PRIMARY KEY (`id_quotite`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;

DROP TABLE IF EXISTS `regles`;
CREATE TABLE IF NOT EXISTS `regles` (
  `id_regle` int(10) UNSIGNED NOT NULL AUTO_INCREMENT,
  `id_circo` int(11) UNSIGNED NOT NULL DEFAULT '0',
  `niveau` tinytext COLLATE latin1_general_ci NOT NULL,
  `id_ecole` int(11) DEFAULT NULL,
  `id_groupe` int(11) UNSIGNED NOT NULL DEFAULT '0',
  `quota` decimal(7,2) NOT NULL DEFAULT '0.00',
  PRIMARY KEY (`id_regle`),
  KEY `id_groupe` (`id_groupe`),
  KEY `id_circo` (`id_circo`),
  KEY `id_ecole` (`id_ecole`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;

DROP TABLE IF EXISTS `seances`;
CREATE TABLE IF NOT EXISTS `seances` (
  `id_seance` int(10) UNSIGNED NOT NULL AUTO_INCREMENT,
  `id_anim` int(11) UNSIGNED NOT NULL DEFAULT '0',
  `max` int(11) NOT NULL DEFAULT '0',
  `public` tinytext COLLATE latin1_general_ci NOT NULL,
  `tri` int(11) NOT NULL DEFAULT '0',
  `cond` tinyint(4) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id_seance`),
  KEY `id_anim` (`id_anim`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;

DROP TABLE IF EXISTS `stagiaires`;
CREATE TABLE IF NOT EXISTS `stagiaires` (
  `id_stagiaire` int(10) UNSIGNED NOT NULL AUTO_INCREMENT,
  `nom` varchar(25) COLLATE latin1_general_ci NOT NULL DEFAULT '',
  `prenom` varchar(25) COLLATE latin1_general_ci NOT NULL DEFAULT '',
  `nom_f` varchar(25) COLLATE latin1_general_ci NOT NULL DEFAULT '',
  `prenom_f` varchar(25) COLLATE latin1_general_ci NOT NULL DEFAULT '',
  `courriel` tinytext COLLATE latin1_general_ci NOT NULL,
  `type_courriel` tinyint(4) UNSIGNED NOT NULL DEFAULT '0',
  `id_ecole` int(11) UNSIGNED NOT NULL DEFAULT '0',
  `id_groupe` int(11) UNSIGNED NOT NULL DEFAULT '0',
  `niveau` tinytext COLLATE latin1_general_ci NOT NULL,
  `quotite` decimal(6,2) NOT NULL DEFAULT '100.00',
  `quota` decimal(6,2) NOT NULL DEFAULT '0.00',
  `quota_reel` decimal(6,2) NOT NULL DEFAULT '0.00',
  `avertissement_lu` tinyint(4) NOT NULL DEFAULT '0',
  `date_publi_convoc` date NOT NULL DEFAULT '9999-12-31',
  `anonyme` tinyint(4) NOT NULL DEFAULT '0',
  `id_uti` int(11) UNSIGNED NOT NULL,
  PRIMARY KEY (`id_stagiaire`),
  KEY `id_ecole` (`id_ecole`),
  KEY `id_groupe` (`id_groupe`),
  KEY `id_uti` (`id_uti`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;

DROP TABLE IF EXISTS `suffixes`;
CREATE TABLE IF NOT EXISTS `suffixes` (
  `id_suffixe` int(10) UNSIGNED NOT NULL AUTO_INCREMENT,
  `suffixe` tinytext COLLATE latin1_general_ci NOT NULL,
  `defaut` tinyint(4) NOT NULL,
  PRIMARY KEY (`id_suffixe`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;

DROP TABLE IF EXISTS `themes`;
CREATE TABLE IF NOT EXISTS `themes` (
  `id_theme` int(10) UNSIGNED NOT NULL AUTO_INCREMENT,
  `id_circo` int(11) UNSIGNED NOT NULL DEFAULT '0',
  `libelle` tinytext COLLATE latin1_general_ci NOT NULL,
  `tri` tinyint(4) UNSIGNED NOT NULL DEFAULT '0',
  `annee` tinyint(4) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id_theme`),
  KEY `id_circo` (`id_circo`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;

DROP TABLE IF EXISTS `tmp_absences`;
CREATE TABLE IF NOT EXISTS `tmp_absences` (
  `id_circo` int(11) UNSIGNED NOT NULL DEFAULT '0',
  `id_uti` int(11) UNSIGNED NOT NULL,
  `id_stagiaire` int(11) UNSIGNED NOT NULL DEFAULT '0',
  `nom_stagiaire` text COLLATE latin1_general_ci,
  `courriel_stagiaire` text COLLATE latin1_general_ci,
  `nom_ecole` tinytext COLLATE latin1_general_ci,
  `id_ecole` int(11) UNSIGNED NOT NULL DEFAULT '0',
  `courriel_ec` tinytext COLLATE latin1_general_ci,
  `niveau` tinytext COLLATE latin1_general_ci,
  `quotite` decimal(6,2) UNSIGNED DEFAULT NULL,
  `absences` int(11) UNSIGNED DEFAULT NULL,
  `duree_convoc` decimal(7,2) DEFAULT '0.00',
  `duree_inj` decimal(7,2) DEFAULT NULL,
  `duree_exc` decimal(7,2) DEFAULT NULL,
  `duree_demandee` decimal(7,2) DEFAULT NULL,
  `duree_effectuee` decimal(7,2) DEFAULT NULL,
  `difference` decimal(7,2) DEFAULT '0.00',
  PRIMARY KEY (`id_stagiaire`),
  KEY `id_circo` (`id_circo`),
  KEY `id_ecole` (`id_ecole`),
  KEY `id_uti` (`id_uti`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;

DROP TABLE IF EXISTS `utilisateurs`;
CREATE TABLE IF NOT EXISTS `utilisateurs` (
  `id_uti` int(10) UNSIGNED NOT NULL AUTO_INCREMENT,
  `sso_login` varchar(255) COLLATE latin1_general_ci DEFAULT NULL,
  `login` varchar(255) COLLATE latin1_general_ci NOT NULL,
  `mdp` tinyblob NOT NULL,
  `codage` tinyint(4) NOT NULL,
  `date_publipostage` date NOT NULL DEFAULT '9999-12-31',
  `dt_connexion` datetime DEFAULT NULL,
  `acces` tinyint(4) NOT NULL DEFAULT '0',
  `hash` varchar(64) COLLATE latin1_general_ci DEFAULT NULL,
  PRIMARY KEY (`id_uti`),
  UNIQUE KEY `sso_login` (`sso_login`),
  KEY `login` (`login`),
  KEY `hash` (`hash`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;
